(*^

::[	frontEndVersion = "Microsoft Windows Mathematica Notebook Front End Version 2.2";
	microsoftWindowsStandardFontEncoding;
	fontset = title, "Times New Roman", 24, L0, center, nohscroll, bold;
	fontset = subtitle, "Times New Roman", 18, L0, center, nohscroll, bold;
	fontset = subsubtitle, "Times New Roman", 14, L0, center, nohscroll, bold;
	fontset = section, "Times New Roman", 14, L0, bold, grayBox;
	fontset = subsection, "Times New Roman", 12, L0, bold, blackBox;
	fontset = subsubsection, "Times New Roman", 10, L0, bold, whiteBox;
	fontset = text, "Times New Roman", 12, L0;
	fontset = smalltext, "Times New Roman", 10, L0;
	fontset = input, "Courier New", 12, L0, nowordwrap, bold;
	fontset = output, "Courier New", 12, L0, nowordwrap;
	fontset = message, "Courier New", 10, L0, nowordwrap, R65535;
	fontset = print, "Courier New", 10, L0, nowordwrap;
	fontset = info, "Courier New", 10, L0, nowordwrap;
	fontset = postscript, "Courier New", 8, L0, nowordwrap;
	fontset = name, "Times New Roman", 10, L0, nohscroll, italic, B65535;
	fontset = header, "Times New Roman", 10, L0, right, nohscroll;
	fontset = footer, "Times New Roman", 10, L0, right, nohscroll;
	fontset = help, "Times New Roman", 10, L0, nohscroll;
	fontset = clipboard, "Times New Roman", 12, L0, nohscroll;
	fontset = completions, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = graphics, "Courier New", 10, L0, nowordwrap, nohscroll;
	fontset = special1, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = special2, "Times New Roman", 12, L0, center, nowordwrap, nohscroll;
	fontset = special3, "Times New Roman", 12, L0, right, nowordwrap, nohscroll;
	fontset = special4, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = special5, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = leftheader, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = leftfooter, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = reserved1, "Courier New", 10, L0, nowordwrap, nohscroll;]
:[font = section; inactive; startGroup; ]
1.3 Numerical Calculations
:[font = subsection; inactive; startGroup; Cclosed; ]
1.3.1 Simple Examples
:[font = subsubsection; inactive; startGroup; Cclosed; ]
Integers
:[font = input; nowordwrap; ]
1 + 1
:[font = input; nowordwrap; ]
1 + 1 - 2
:[font = input; nowordwrap; ]
4 * 15 / 5
:[font = input; nowordwrap; ]
4 15 / 5
:[font = input; nowordwrap; ]
2^1000
:[font = input; endGroup; nowordwrap; ]
60 / 8
:[font = subsubsection; inactive; startGroup; Cclosed; ]
Numerical Approximations of Real Numbers
:[font = input; nowordwrap; ]
15.33333 + 3.14159 / 2.^3
:[font = input; nowordwrap; ]
60 / 8.
:[font = input; nowordwrap; ]
2.^1000
:[font = input; nowordwrap; ]
N[60 / 8]
:[font = input; preserveAspect; nowordwrap; ]
Rationalize[7.5]
:[font = input; preserveAspect; endGroup; nowordwrap; ]
2^1000 // N
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Using Previous Results
:[font = input; nowordwrap; ]
10^300 / %
:[font = input; preserveAspect; endGroup; nowordwrap; ]
%10 / %11
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Parentheses, Brackets and Braces
:[font = input; endGroup; nowordwrap; ]
1 / (2.5 + 1.7^3)
:[font = subsubsection; inactive; startGroup; Cclosed; ]
Elementary Functions
:[font = input; nowordwrap; ]
Sqrt[4]
:[font = input; nowordwrap; ]
Sqrt[2]
:[font = input; nowordwrap; ]
% // N
:[font = input; nowordwrap; ]
Sin[1]
:[font = input; nowordwrap; ]
Sin[1.]
:[font = input; preserveAspect; nowordwrap; ]
Sin[1.5708]
:[font = input; endGroup; nowordwrap; ]
Sin[90 Degree] // N
:[font = subsubsection; inactive; startGroup; Cclosed; ]
Constants
:[font = input; preserveAspect; nowordwrap; ]
Sin[Pi]
:[font = input; nowordwrap; ]
Exp[-Infinity]
:[font = input; nowordwrap; ]
Pi / 2
:[font = input; nowordwrap; ]
N[Pi]
:[font = input; endGroup; nowordwrap; ]
N[Pi, 200]
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Remark about the Precision of Calculations
:[font = input; nowordwrap; ]
N[2.1^1000, 30]
:[font = input; preserveAspect; nowordwrap; ]
N[2.100000000000000000000000000000000^1000, 30]
:[font = input; preserveAspect; endGroup; nowordwrap; ]
N[(21/10)^1000, 30]
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Questions and Answers
:[font = input; preserveAspect; nowordwrap; ]
Tg(.5)
:[font = input; preserveAspect; nowordwrap; ]
n[1/7]
:[font = input; preserveAspect; endGroup; endGroup; nowordwrap; ]
N[1/7]
:[font = subsection; inactive; startGroup; Cclosed; ]
1.3.2 External Packages: Units
:[font = input; nowordwrap; ]
<<Miscellaneous`Units`
:[font = input; preserveAspect; nowordwrap; ]
Needs["Miscellaneous`Units`"]
:[font = input; nowordwrap; ]
?WineBottle
:[font = input; nowordwrap; ]
Convert[1 WineBottle, Liter]
:[font = input; nowordwrap; ]
Convert[1 WineBottle, UKGallon]
:[font = input; nowordwrap; ]
Convert[1 Parsec^3, WineBottle]
:[font = input; nowordwrap; ]
Convert[1 Parsec^3, Tera WineBottle]
:[font = input; nowordwrap; ]
SI[Inch^3]
:[font = input; nowordwrap; ]
Convert[1 Acre, Meter^2]
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Help about Packages (Text-Based Interface)
:[font = input; nowordwrap; ]
!!Miscellaneous/Units.m
:[font = input; nowordwrap; ]
?Miscellaneous`Units`*
:[font = input; nowordwrap; ]
Contexts[]
:[font = input; nowordwrap; ]
Contexts["Miscellaneous`*"]
:[font = input; endGroup; nowordwrap; ]
?Miscellaneous`SIUnits`*
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Questions and Answers
:[font = input; preserveAspect; nowordwrap; ]
SI[Yard]
:[font = input; nowordwrap; ]
<<Miscellaneous`Units`
:[font = input; preserveAspect; nowordwrap; ]
SI[Yard]
:[font = input; preserveAspect; nowordwrap; ]
Remove[Global`SI, Global`Yard]
:[font = input; preserveAspect; endGroup; endGroup; nowordwrap; ]
SI[Yard]
:[font = subsection; inactive; startGroup; Cclosed; ]
1.3.3 Large Numbers: The RSA Public-Key Cryptosystem
:[font = input; nowordwrap; ]
Prime[1000000]
:[font = input; nowordwrap; ]
p = Prime[1000000]
:[font = input; nowordwrap; ]
q = Prime[1000005]
:[font = input; nowordwrap; ]
n = p q
:[font = input; nowordwrap; ]
e = Random[Integer, {100000, 1000000}]
:[font = input; nowordwrap; ]
GCD[e, (p-1)(q-1)]
:[font = input; nowordwrap; ]
e = Random[Integer, {100000, 1000000}]
:[font = input; nowordwrap; ]
GCD[e, (p-1)(q-1)]
:[font = input; nowordwrap; ]
<<SKPackages`RSA`
:[font = input; nowordwrap; ]
e = GenerateE[p, q]
:[font = input; nowordwrap; ]
GCD[e, (p-1)(q-1)]
:[font = input; nowordwrap; ]
d = PowerMod[e, -1, (p-1)(q-1)]
:[font = input; nowordwrap; ]
m = 12911991
:[font = input; nowordwrap; ]
c = PowerMod[m, e, n]
:[font = input; nowordwrap; ]
PowerMod[c, d, n]
:[font = input; nowordwrap; ]
Mod[55555555^1111, 11111111111] // Timing
:[font = input; nowordwrap; ]
PowerMod[55555555, 1111, 11111111111] // Timing
:[font = input; nowordwrap; ]
FactorInteger[n]
:[font = input; preserveAspect; nowordwrap; ]
p = 3327151126608487421877558088519028649458169361\
  279160142523661652581105578513717982486654235124\
  785151
:[font = input; preserveAspect; nowordwrap; ]
q = 1207914684137593486834633084205117743731337601\
  510373997760717454678735342949711476106521763447\
  795837
:[font = input; nowordwrap; ]
PrimeQ[p]
:[font = input; nowordwrap; ]
PrimeQ[q]
:[font = input; nowordwrap; ]
n = p q
:[font = input; nowordwrap; ]
e = GenerateE[p, q]
:[font = input; nowordwrap; ]
d = PowerMod[e, -1, (p-1)(q-1)]
:[font = input; nowordwrap; ]
c = PowerMod[m, e, n]
:[font = input; nowordwrap; ]
PowerMod[c, d, n]
:[font = input; nowordwrap; ]
c = RSAEncode["This is a very secret message!", e, n]
:[font = input; nowordwrap; ]
ListToString[c]
:[font = input; preserveAspect; nowordwrap; ]
RSADecode[c, d, n]
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Exercises
:[font = input; preserveAspect; endGroup; endGroup; endGroup; nowordwrap; ]
8427822041268851087721954336481188257911244421059372\
1870209000281178226826571886453856092817025114976097\
0758062557529117414392358167459937542237240676819854\
81122012528444316192634325816891869662444157
^*)