(*^

::[	frontEndVersion = "Microsoft Windows Mathematica Notebook Front End Version 2.2";
	microsoftWindowsStandardFontEncoding;
	fontset = title, "Times New Roman", 24, L0, center, nohscroll, bold;
	fontset = subtitle, "Times New Roman", 18, L0, center, nohscroll, bold;
	fontset = subsubtitle, "Times New Roman", 14, L0, center, nohscroll, bold;
	fontset = section, "Times New Roman", 14, L0, bold, grayBox;
	fontset = subsection, "Times New Roman", 12, L0, bold, blackBox;
	fontset = subsubsection, "Times New Roman", 10, L0, bold, whiteBox;
	fontset = text, "Times New Roman", 12, L0;
	fontset = smalltext, "Times New Roman", 10, L0;
	fontset = input, "Courier New", 12, L0, nowordwrap, bold;
	fontset = output, "Courier New", 12, L0, nowordwrap;
	fontset = message, "Courier New", 10, L0, nowordwrap, R65535;
	fontset = print, "Courier New", 10, L0, nowordwrap;
	fontset = info, "Courier New", 10, L0, nowordwrap;
	fontset = postscript, "Courier New", 8, L0, nowordwrap;
	fontset = name, "Times New Roman", 10, L0, nohscroll, italic, B65535;
	fontset = header, "Times New Roman", 10, L0, right, nohscroll;
	fontset = footer, "Times New Roman", 10, L0, right, nohscroll;
	fontset = help, "Times New Roman", 10, L0, nohscroll;
	fontset = clipboard, "Times New Roman", 12, L0, nohscroll;
	fontset = completions, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = graphics, "Courier New", 10, L0, nowordwrap, nohscroll;
	fontset = special1, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = special2, "Times New Roman", 12, L0, center, nowordwrap, nohscroll;
	fontset = special3, "Times New Roman", 12, L0, right, nowordwrap, nohscroll;
	fontset = special4, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = special5, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = leftheader, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = leftfooter, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = reserved1, "Courier New", 10, L0, nowordwrap, nohscroll;]
:[font = section; inactive; startGroup; ]
1.5 Plots: Different Pendulums
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
1.5.1 Two-Dimensional Plots
:[font = input; preserveAspect; nowordwrap; ]
Plot[Sin[x] Sin[3x] Sin[5x], {x, 0, 2 Pi}]
:[font = input; preserveAspect; nowordwrap; ]
Plot[{Sin[x], Sin[3x], Sin[5x]}, {x, 0, 2 Pi}]
:[font = input; preserveAspect; nowordwrap; ]
j3j5[x_] := BesselJ[3, x] BesselJ[5, x]
:[font = input; preserveAspect; nowordwrap; ]
j3j5Graph = Plot[j3j5[x], {x, 0, 4Pi}]
:[font = input; preserveAspect; nowordwrap; ]
Options[Plot]
:[font = input; preserveAspect; nowordwrap; ]
FullOptions[j3j5Graph]
:[font = input; preserveAspect; nowordwrap; ]
Show[j3j5Graph, PlotLabel -> "J3 J5"]
:[font = input; preserveAspect; nowordwrap; ]
Show[j3j5Graph, 
  GridLines -> Automatic, 
  AxesLabel -> {"x", "J3 J5"}
]
:[font = input; preserveAspect; nowordwrap; ]
Plot[Cos[2Pi x], {x, 0, 24}]
:[font = input; preserveAspect; nowordwrap; ]
Plot[Cos[2Pi x], {x, 0, 24}, PlotPoints -> 40]
:[font = input; preserveAspect; nowordwrap; ]
Plot[Sin[x] Exp[x], {x, 0, 5 Pi}]
:[font = input; preserveAspect; nowordwrap; ]
Show[%, PlotRange -> All]
:[font = input; preserveAspect; nowordwrap; ]
PSPrint[j3j5Graph]
:[font = input; preserveAspect; nowordwrap; ]
Display["mathpsfile", j3j5Graph]
:[font = input; preserveAspect; endGroup; nowordwrap; ]
Display["!psfix -epsf > psfile.eps", j3j5Graph]
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
1.5.2 Example: The Triple Pendulum
:[font = input; preserveAspect; nowordwrap; ]
beta = 
:[font = input; nowordwrap; ]
ep = - (m l g/2)*
  (5 Cos[phi1[t]] + 3 Cos[phi2[t]] + Cos[phi3[t]]);
:[font = input; nowordwrap; ]
ek1 = (1/2)(m l^2/3) phi1'[t]^2;
:[font = input; preserveAspect; nowordwrap; ]
Integrate[m/(2l) (x phi1'[t])^2, {x, 0, l}]
:[font = input; preserveAspect; nowordwrap; ]
% - ek1
:[font = input; nowordwrap; ]
ek2 = (m l^2/2)*
  ((phi2'[t]^2/12) + 
   (phi1'[t] Cos[phi1[t]] + phi2'[t] Cos[phi2[t]]/2)^2 + 
   (phi1'[t] Sin[phi1[t]] + phi2'[t] Sin[phi2[t]]/2)^2);
:[font = input; preserveAspect; nowordwrap; ]
Integrate[m/(2l)
  ((l phi1'[t] Cos[phi1[t]] + x phi2'[t] Cos[phi2[t]])^2 + 
   (l phi1'[t] Sin[phi1[t]] + x phi2'[t] Sin[phi2[t]])^2),
  {x, 0, l}]
:[font = input; preserveAspect; nowordwrap; ]
% - ek2 // Simplify
:[font = input; nowordwrap; ]
ek3 = (m l^2/2 ) *
   (phi3'[t]^2/12 + 
    (phi1'[t] Cos[phi1[t]] + phi2'[t] Cos[phi2[t]] + 
     phi3'[t] Cos[phi3[t]]/2 )^2 + 
    (phi1'[t] Sin[phi1[t]] + phi2'[t] Sin[phi2[t]] + 
     phi3'[t] Sin[phi3[t]]/2 )^2);
:[font = input; nowordwrap; ]
ek = ek1 + ek2 + ek3;
:[font = input; nowordwrap; ]
lag = ek - ep;
:[font = input; nowordwrap; ]
lagEquations =
  { 
    D[D[lag, phi1'[t]], t] - D[lag, phi1[t]] == 0, 
    D[D[lag, phi2'[t]], t] - D[lag, phi2[t]] == 0,
    D[D[lag, phi3'[t]], t] - D[lag, phi3[t]] == 0
  };
:[font = input; preserveAspect; nowordwrap; ]
lagEquations[[1]]
:[font = input; preserveAspect; nowordwrap; ]
Simplify[%]
:[font = input; nowordwrap; ]
lag = ek - ep // Simplify;
:[font = input; nowordwrap; ]
lagEquations =
  { 
    D[D[lag, phi1'[t]], t] - D[lag, phi1[t]] == 0, 
    D[D[lag, phi2'[t]], t] - D[lag, phi2[t]] == 0,
    D[D[lag, phi3'[t]], t] - D[lag, phi3[t]] == 0
  } // Simplify;
:[font = input; preserveAspect; nowordwrap; ]
angles = {phi1[t], phi2[t], phi3[t]};
:[font = input; preserveAspect; nowordwrap; ]
velocities = {phi1'[t], phi2'[t], phi3'[t]};
:[font = input; preserveAspect; nowordwrap; ]
variables = Join[angles, velocities]
:[font = input; preserveAspect; nowordwrap; ]
<<SKPackages`Linearization`
:[font = input; nowordwrap; ]
linEquations = Linearize[lagEquations, 
  variables, {0,0,0,0,0,0}] // Simplify
:[font = input; preserveAspect; nowordwrap; ]
Save["triplePendulum.m", lag, lagEquations, linEquations,
  angles, velocities, variables]
:[font = input; preserveAspect; nowordwrap; ]
initials =
  {phi1[0] == 1, phi2[0] == 0, phi3[0] == 0,
   phi1'[0] == 0, phi2'[0] == 0, phi3'[0] == 0 }
:[font = input; preserveAspect; nowordwrap; ]
valueRule = {m -> 1, l -> 1, g -> 1}
:[font = input; preserveAspect; nowordwrap; ]
linEquInits = Flatten[{linEquations, initials}] /.
  valueRule;
:[font = input; preserveAspect; nowordwrap; ]
lagEquInits = Flatten[{lagEquations, initials}] /.
  valueRule;
:[font = input; preserveAspect; nowordwrap; ]
lagSolRule = NDSolve[lagEquInits, angles, {t, 0, 1}]
:[font = input; preserveAspect; nowordwrap; ]
linSolRule = NDSolve[linEquInits, angles, {t, 0, 1}]
:[font = input; preserveAspect; nowordwrap; ]
Plot[phi1[t] /. lagSolRule, {t, 0, 1}] // Timing
:[font = input; preserveAspect; nowordwrap; ]
Plot[Evaluate[phi1[t] /. lagSolRule], {t, 0, 1}] // Timing
:[font = input; preserveAspect; nowordwrap; ]
lag1 = %[[2]]
:[font = input; preserveAspect; nowordwrap; ]
lin1 = Plot[Evaluate[phi1[t] /. linSolRule], {t, 0, 1}]
:[font = input; preserveAspect; nowordwrap; ]
linLag1 = Show[{lin1, lag1}, PlotLabel -> "phi1"]
:[font = input; preserveAspect; nowordwrap; ]
linLag2 = Plot[Evaluate[
    {phi2[t] /. lagSolRule, phi2[t] /. linSolRule}],
  {t, 0, 1}, PlotLabel -> "phi2"]
:[font = input; preserveAspect; nowordwrap; ]
linLag3 = Plot[Evaluate[
    {phi3[t] /. lagSolRule, phi3[t] /. linSolRule}],
  {t, 0, 1}, PlotLabel -> "phi3"]
:[font = input; preserveAspect; nowordwrap; ]
Show[GraphicsArray[{linLag1, linLag2, linLag3}],
  Frame -> True]
:[font = input; preserveAspect; nowordwrap; ]
smallInitials =
  {phi1[0] == 0.05, phi2[0] == 0, phi3[0] == 0,
   phi1'[0] == 0, phi2'[0] == 0, phi3'[0] == 0};
:[font = input; preserveAspect; nowordwrap; ]
smallLagEquInits =
  Flatten[{lagEquations, smallInitials}] /.
    valueRule;
:[font = input; preserveAspect; nowordwrap; ]
smallLinEquInits =
  Flatten[{linEquations, smallInitials}] /.
    valueRule;
:[font = input; preserveAspect; nowordwrap; ]
smallLagSolRule =
  NDSolve[smallLagEquInits, angles, {t, 0, 1}];
:[font = input; preserveAspect; nowordwrap; ]
smallLinSolRule =
  NDSolve[smallLinEquInits, angles, {t, 0, 1}];
:[font = input; preserveAspect; nowordwrap; ]
smallLinLag1 = Plot[Evaluate[
    {phi1[t] /. smallLagSolRule,
     phi1[t] /. smallLinSolRule}],
  {t, 0, 1}, PlotLabel -> "phi1",
  DisplayFunction -> Identity];
:[font = input; preserveAspect; nowordwrap; ]
smallLinLag2 = Plot[Evaluate[
    {phi2[t] /. smallLagSolRule,
     phi2[t] /. smallLinSolRule}],
  {t, 0, 1}, PlotLabel -> "phi2",
  DisplayFunction -> Identity];
:[font = input; preserveAspect; nowordwrap; ]
smallLinLag3 = Plot[Evaluate[
    {phi3[t] /. smallLagSolRule,
     phi3[t] /. smallLinSolRule}],
  {t, 0, 1}, PlotLabel -> "phi3",
  DisplayFunction -> Identity];
:[font = input; preserveAspect; endGroup; nowordwrap; ]
Show[GraphicsArray[
  {smallLinLag1, smallLinLag2, smallLinLag3}],
  Frame -> True]
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
1.5.3 Three-Dimensional Graphics and Animation: A Rotating Double Pendulum
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
A Rotating Double Pendulum
:[font = input; nowordwrap; ]
epStat = - (m l g/2)(3 Cos[phi1] + Cos[phi2]);
:[font = input; preserveAspect; nowordwrap; ]
ekRot = 1/2 (m l^2 / 3 omega^2 Sin[phi1]^2 +
  m l^2 / 12 omega^2 Sin[phi2]^2 +
  m l^2 omega^2 (Sin[phi1] + 1/2 Sin[phi2])^2);
:[font = input; preserveAspect; nowordwrap; ]
epStat - ekRot
:[font = input; preserveAspect; endGroup; nowordwrap; ]
epEff = epStat - ekRot /. {m -> 1, l -> 1, g -> 1}
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Surface Plots
:[font = input; preserveAspect; nowordwrap; ]
Plot3D[Evaluate[epEff /. omega -> 0], 
  {phi1, -Pi, Pi}, {phi2, -Pi, Pi}]
:[font = input; preserveAspect; nowordwrap; ]
Plot3D[Evaluate[epEff /. omega -> 10], 
  {phi1, -Pi, Pi}, {phi2, -Pi, Pi}]
:[font = input; preserveAspect; nowordwrap; ]
Show[%, ViewPoint -> {3, -1, 1}]
:[font = input; preserveAspect; nowordwrap; ]
Options[Plot3D]
:[font = input; preserveAspect; endGroup; nowordwrap; ]
Show[%%, AxesEdge -> {{-1, -1}, {1, -1}, {1, 1}},
  AxesLabel -> {"phi1", "phi2", "epEff"},
  BoxRatios -> {1, 1, .8},
  PlotLabel -> "omega = 10"]
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Contour Plots
:[font = input; preserveAspect; nowordwrap; ]
ContourPlot[Evaluate[epEff /. omega -> 10], 
  {phi1, -Pi, Pi}, {phi2, -Pi, Pi}]
:[font = input; preserveAspect; nowordwrap; ]
Options[ContourPlot]
:[font = input; preserveAspect; nowordwrap; ]
ContourPlot[Evaluate[epEff /. omega -> 10],
  {phi1, -Pi, Pi}, {phi2, -Pi, Pi},
  PlotPoints -> 40, ColorFunction -> Hue]
:[font = input; preserveAspect; endGroup; nowordwrap; ]
Show[%, ColorFunction -> Automatic, Contours -> 25]
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Density Plots
:[font = input; preserveAspect; nowordwrap; ]
DensityPlot[Evaluate[epEff /. omega -> 10], 
  {phi1, -Pi, Pi}, {phi2, -Pi, Pi}]
:[font = input; preserveAspect; nowordwrap; ]
DensityPlot[Evaluate[epEff /. omega -> 10], 
  {phi1, -Pi, Pi}, {phi2, -Pi, Pi},
  PlotPoints -> 50, Mesh -> False]
:[font = input; preserveAspect; endGroup; nowordwrap; ]
Show[SurfaceGraphics[%]]
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Animations
:[font = input; preserveAspect; nowordwrap; ]
plots = Table[Plot3D[Evaluate[epEff],
    {phi1, -Pi, Pi}, {phi2, -Pi, Pi},
    PlotRange -> {-6, 2},
    BoxRatios -> {1, 1, 1},
    ViewPoint-> {0.7, -2, 2.6},
    PlotLabel -> StringJoin["omega = ", ToString[omega]]], 
  {omega, 0, 2, .1}]
:[font = input; preserveAspect; nowordwrap; ]
Show[GraphicsArray[
  Table[plots[[7(i-1) + j]], {i, 3}, {j, 7}]]]
:[font = input; preserveAspect; nowordwrap; ]
<<Graphics`Animation`
:[font = input; preserveAspect; nowordwrap; ]
ShowAnimation[plots]
:[font = input; preserveAspect; endGroup; endGroup; nowordwrap; ]
Save["rotDoublePend.m", epEff]
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
1.5.4 Parametric Plots: A Rotating Double Pendulum
:[font = input; preserveAspect; nowordwrap; ]
r1 = 2.5; r2 = 1;
:[font = input; preserveAspect; nowordwrap; ]
ParametricPlot3D[
  {
    Cos[phi1](r1 + r2 Cos[phi2]),
    Sin[phi1](r1 + r2 Cos[phi2]),
    r2 Sin[phi2]
  } // Evaluate,
  {phi1, 0, 2 Pi}, {phi2, 0, 2 Pi},
  Boxed -> False, Axes -> False
]
:[font = input; preserveAspect; nowordwrap; ]
torus = Show[Graphics3D[{EdgeForm[], %[[1]]}],
  Boxed -> False]
:[font = input; preserveAspect; nowordwrap; ]
<<rotDoublePend.m;
:[font = input; preserveAspect; nowordwrap; ]
ParametricPlot3D[
  Evaluate[
    {
      Cos[phi1](r1 + r2 Cos[phi2]),
      Sin[phi1](r1 + r2 Cos[phi2]),
      r2 Sin[phi2],
      GrayLevel[(epEff + 2)/4]
    } /. {m -> 1, l -> 1, g -> 1, omega -> 0}
  ],
  {phi1, 0, 2Pi}, {phi2, 0, 2Pi},
  Lighting -> False
]
:[font = input; preserveAspect; nowordwrap; ]
FindMinimum[epEff /. {m -> 1, l -> 1, g -> 1, omega -> 10},
  {phi1, -2}, {phi2, -2}]
:[font = input; preserveAspect; nowordwrap; ]
FindMinimum[-epEff /. {m -> 1, l -> 1, g -> 1, omega -> 10},
  {phi1, Pi}, {phi2, Pi}]
:[font = input; preserveAspect; nowordwrap; ]
ParametricPlot3D[
  Evaluate[
    {
      Cos[phi1](r1 + r2 Cos[phi2]),
      Sin[phi1](r1 + r2 Cos[phi2]),
      r2 Sin[phi2],
      Hue[(epEff + 133.3)/135.3]
    } /. {m -> 1, l -> 1, g -> 1, omega -> 10}
  ],
  {phi1, 0, 2Pi}, {phi2, 0, 2Pi},
  Lighting -> False, PlotPoints -> {45, 15}
]
:[font = input; preserveAspect; nowordwrap; ]
epT = epEff /. {phi1 -> phi1[t], phi2 -> phi2[t]};
:[font = input; nowordwrap; ]
ek1 = (1/2) (m l^2 / 3) phi1'[t]^2;
:[font = input; nowordwrap; ]
ek2 = (m l^2/2) *
       ((phi2'[t]^2/12) + 
        (phi1'[t] Cos[phi1[t]] +
         phi2'[t] Cos[phi2[t]]/2)^2 + 
        (phi1'[t] Sin[phi1[t]] +
         phi2'[t] Sin[phi2[t]]/2)^2
       );
:[font = input; nowordwrap; ]
ek = ek1 + ek2;
:[font = input; nowordwrap; ]
lag = ek - epT;
:[font = input; nowordwrap; ]
lagEquations =
  { 
    D[D[lag, phi1'[t]], t] - D[lag, phi1[t]] == 0, 
    D[D[lag, phi2'[t]], t] - D[lag, phi2[t]] == 0
  };
:[font = input; preserveAspect; nowordwrap; ]
angles = {phi1[t], phi2[t]};
:[font = input; preserveAspect; nowordwrap; ]
initials =
  {phi1[0] == 0, phi2[0] == 0,
   phi1'[0] == 0, phi2'[0] == 5};
:[font = input; preserveAspect; nowordwrap; ]
valueRule = {m -> 1, l -> 1, g -> 1, omega -> 0.5};
:[font = input; preserveAspect; nowordwrap; ]
lagEquInits = Join[lagEquations, initials] /.
  valueRule;
:[font = input; preserveAspect; nowordwrap; ]
NDSolve[lagEquInits, angles, {t, 0, 10}];
:[font = input; preserveAspect; nowordwrap; ]
lagSolRule = NDSolve[lagEquInits, angles, {t, 0, 10},
  MaxSteps -> 2000];
:[font = input; preserveAspect; nowordwrap; ]
ParametricPlot[Evaluate[angles /. lagSolRule],
  {t, 0, 10}, AxesLabel -> {"phi1", "phi2"}]
:[font = input; preserveAspect; nowordwrap; ]
phi1 = (phi1[t] /. lagSolRule[[1]]);
:[font = input; preserveAspect; nowordwrap; ]
phi2 = (phi2[t] /. lagSolRule[[1]]);
:[font = input; preserveAspect; nowordwrap; ]
ParametricPlot3D[
  {
    Cos[phi1](r1 + r2 Cos[phi2]),
    Sin[phi1](r1 + r2 Cos[phi2]),
    r2 Sin[phi2]
  } // Evaluate,
  {t, 0, 10}]
:[font = input; preserveAspect; nowordwrap; ]
sol = ParametricPlot3D[
  {
    Cos[phi1](r1 + (r2 + .05) Cos[phi2]),
    Sin[phi1](r1 + (r2 + .05) Cos[phi2]),
    (r2 + .05) Sin[phi2]
  } // Evaluate,
  {t, 0, 10}, PlotPoints -> 500]
:[font = input; preserveAspect; endGroup; nowordwrap; ]
Show[torus, sol, Boxed -> False, Axes -> False]
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
1.5.5 Plotting Data: The Random Generator
:[font = input; preserveAspect; nowordwrap; ]
data = Table[Sin[x] + Random[Real, {0, .1}], {x, 0, 6, .1}]
:[font = input; preserveAspect; nowordwrap; ]
Save["data-file.m", data]
:[font = input; preserveAspect; nowordwrap; ]
<<data-file.m;
:[font = input; preserveAspect; nowordwrap; ]
!!raw-data-file.m
:[font = input; preserveAspect; nowordwrap; ]
expData = ReadList["raw-data-file.m", Real];
:[font = input; preserveAspect; nowordwrap; ]
ListPlot[expData]
:[font = input; preserveAspect; nowordwrap; ]
ListPlot[expData, PlotJoined -> True]
:[font = input; preserveAspect; nowordwrap; ]
ListPlot[Evaluate[Table[Random[], {100}]]]
:[font = input; preserveAspect; nowordwrap; ]
ListPlot[Evaluate[Table[{Random[], Random[]}, {100}]]]
:[font = input; preserveAspect; nowordwrap; ]
ListPlot[Evaluate[Table[{Random[], Random[]}, {100}]],
  AspectRatio -> Automatic]
:[font = input; preserveAspect; endGroup; endGroup; nowordwrap; ]
ListPlot[Evaluate[Table[{Random[], Random[]}, {10000}]],
  AspectRatio -> Automatic]
^*)