(*^

::[	frontEndVersion = "Microsoft Windows Mathematica Notebook Front End Version 2.2";
	microsoftWindowsStandardFontEncoding;
	fontset = title, "Times New Roman", 24, L0, center, nohscroll, bold;
	fontset = subtitle, "Times New Roman", 18, L0, center, nohscroll, bold;
	fontset = subsubtitle, "Times New Roman", 14, L0, center, nohscroll, bold;
	fontset = section, "Times New Roman", 14, L0, bold, grayBox;
	fontset = subsection, "Times New Roman", 12, L0, bold, blackBox;
	fontset = subsubsection, "Times New Roman", 10, L0, bold, whiteBox;
	fontset = text, "Times New Roman", 12, L0;
	fontset = smalltext, "Times New Roman", 10, L0;
	fontset = input, "Courier New", 12, L0, nowordwrap, bold;
	fontset = output, "Courier New", 12, L0, nowordwrap;
	fontset = message, "Courier New", 10, L0, nowordwrap, R65535;
	fontset = print, "Courier New", 10, L0, nowordwrap;
	fontset = info, "Courier New", 10, L0, nowordwrap;
	fontset = postscript, "Courier New", 8, L0, nowordwrap;
	fontset = name, "Times New Roman", 10, L0, nohscroll, italic, B65535;
	fontset = header, "Times New Roman", 10, L0, right, nohscroll;
	fontset = footer, "Times New Roman", 10, L0, right, nohscroll;
	fontset = help, "Times New Roman", 10, L0, nohscroll;
	fontset = clipboard, "Times New Roman", 12, L0, nohscroll;
	fontset = completions, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = graphics, "Courier New", 10, L0, nowordwrap, nohscroll;
	fontset = special1, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = special2, "Times New Roman", 12, L0, center, nowordwrap, nohscroll;
	fontset = special3, "Times New Roman", 12, L0, right, nowordwrap, nohscroll;
	fontset = special4, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = special5, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = leftheader, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = leftfooter, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = reserved1, "Courier New", 10, L0, nowordwrap, nohscroll;]
:[font = section; inactive; startGroup; ]
1.6 Lists
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
1.6.1 Creating and Formatting Lists
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Making Lists
:[font = input; preserveAspect; nowordwrap; ]
{x, x^2, x^3, x^4, x^5}
:[font = input; preserveAspect; nowordwrap; ]
Table[x^n, {n, 5}]
:[font = input; preserveAspect; nowordwrap; ]
Range[5]
:[font = input; preserveAspect; endGroup; nowordwrap; ]
Range[.1, 1.1, .2]
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Formatting Lists
:[font = input; preserveAspect; nowordwrap; ]
nPi = Table[N[i Pi, j + 2i], {i, 3}, {j, 4}]
:[font = input; preserveAspect; nowordwrap; ]
TableForm[nPi]
:[font = input; preserveAspect; nowordwrap; ]
MatrixForm[%]
:[font = input; preserveAspect; nowordwrap; ]
TableForm[nPi, 
  TableHeadings -> {{" Pi:", "2Pi:", "3Pi:"}, None}]
:[font = input; preserveAspect; endGroup; nowordwrap; ]
TableForm[nPi, 
  TableHeadings -> {{" Pi:", "2Pi:", "3Pi:"}, None},
  TableAlignments -> {Center, Center, Center}]
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Indexed Symbols
:[font = input; preserveAspect; nowordwrap; ]
Array[a, 5]
:[font = input; preserveAspect; nowordwrap; ]
Table[a[i], {i, 5}]
:[font = input; preserveAspect; nowordwrap; ]
Array[a, 5, 0]
:[font = input; preserveAspect; nowordwrap; ]
Array[a, {3, 3}, 0] // MatrixForm
:[font = input; preserveAspect; nowordwrap; ]
Table[a[i][t], {i, 3}]
:[font = input; preserveAspect; endGroup; endGroup; nowordwrap; ]
Table[a[i, t], {i, 3}]
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
1.6.2 Calculations with Lists, Pure Functions
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Operations on Lists
:[font = input; preserveAspect; nowordwrap; ]
Exp[N[Range[0, 1, .2]]]
:[font = input; preserveAspect; nowordwrap; ]
c Array[a, 2] Array[b, 2]
:[font = input; preserveAspect; nowordwrap; ]
Variables[x + y]
:[font = input; preserveAspect; nowordwrap; ]
v1 = {x + y, x, z};
:[font = input; preserveAspect; nowordwrap; ]
Variables[v1]
:[font = input; preserveAspect; nowordwrap; ]
Map[Variables, v1]
:[font = input; preserveAspect; endGroup; nowordwrap; ]
Variables /@ v1
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Pure Functions
:[font = input; preserveAspect; nowordwrap; ]
h[x_] := f[x] + g[x]
:[font = input; preserveAspect; nowordwrap; ]
v2 = Array[a, 3]
:[font = input; preserveAspect; nowordwrap; ]
h /@ v2
:[font = input; preserveAspect; nowordwrap; ]
Function[x, f[x] + g[x]] /@ v2
:[font = input; preserveAspect; nowordwrap; ]
Function[f[#] + g[#]] /@ v2
:[font = input; preserveAspect; endGroup; nowordwrap; ]
f[#] + g[#]& /@ v2
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Example: The Equations of Motion of the Triple Pendulum
:[font = input; nowordwrap; ]
vars = Table[phi[i][t], {i, 3}]
:[font = input; preserveAspect; nowordwrap; ]
vars = Through[Array[phi, 3][t]]
:[font = input; nowordwrap; ]
variableRule =
  {phi1 -> phi[1], phi2 -> phi[2], phi3 -> phi[3]};
:[font = input; preserveAspect; nowordwrap; ]
<<triplePendulum.m;
:[font = input; preserveAspect; nowordwrap; ]
lagNew = lag /. variableRule;
:[font = input; nowordwrap; ]
D[D[lagNew, D[#, t]], t] - D[lagNew, #] == 0& /@ vars //
  Simplify;
:[font = input; preserveAspect; endGroup; nowordwrap; ]
Table[%[[i, 1]] - lagEquations[[i, 1]] /. variableRule,
  {i, 3}]
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Converting Lists into Parameters
:[font = input; preserveAspect; nowordwrap; ]
Apply[f, v2]
:[font = input; preserveAspect; nowordwrap; ]
f[v2]
:[font = input; preserveAspect; nowordwrap; ]
f @@ v2
:[font = input; preserveAspect; nowordwrap; ]
Plus @@ v2
:[font = input; preserveAspect; nowordwrap; ]
Times @@ v2
:[font = input; preserveAspect; nowordwrap; ]
Sum[a[i], {i, 3}]
:[font = input; preserveAspect; endGroup; endGroup; nowordwrap; ]
Product[a[i], {i, 3}]
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
1.6.3 List Manipulation: The Cross Product
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Parts of Lists
:[font = input; preserveAspect; nowordwrap; ]
aList = Table[Exp[i], {i, 5}];
:[font = input; preserveAspect; nowordwrap; ]
Part[aList, 2]
:[font = input; preserveAspect; nowordwrap; ]
aList[[-3]]
:[font = input; preserveAspect; nowordwrap; ]
aList[[Range[3]]]
:[font = input; preserveAspect; nowordwrap; ]
Take[aList, 3]
:[font = input; preserveAspect; nowordwrap; ]
Rest[aList]
:[font = input; preserveAspect; nowordwrap; ]
Drop[aList, {2, 4}]
:[font = input; preserveAspect; nowordwrap; ]
Array[a, {2, 2}]
:[font = input; preserveAspect; endGroup; nowordwrap; ]
%[[2, 1]]
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Changing Lists
:[font = input; preserveAspect; nowordwrap; ]
Append[aList, Exp[6]]
:[font = input; preserveAspect; nowordwrap; ]
Prepend[aList, Exp[0]]
:[font = input; preserveAspect; nowordwrap; ]
Insert[aList, Exp[5/2], 3]
:[font = input; preserveAspect; nowordwrap; ]
Delete[%, 3]
:[font = input; preserveAspect; endGroup; nowordwrap; ]
ReplacePart[aList, Exp[3.], 3]
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Joining Lists
:[font = input; preserveAspect; nowordwrap; ]
Join[aList, {a, b, c}]
:[font = input; preserveAspect; nowordwrap; ]
{a, b, c} ~ Join ~ aList
:[font = input; preserveAspect; nowordwrap; ]
Union[{a, b, c}, {b, c, d}]
:[font = input; preserveAspect; nowordwrap; ]
Intersection[{a, b, c}, {b, c, d}]
:[font = input; preserveAspect; endGroup; nowordwrap; ]
Complement[{a, b, c}, {b}]
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Rearranging Lists
:[font = input; preserveAspect; nowordwrap; ]
Sort[{f, b, g, e, 1, f}]
:[font = input; preserveAspect; nowordwrap; ]
Union[%]
:[font = input; preserveAspect; nowordwrap; ]
Reverse[aList]
:[font = input; preserveAspect; nowordwrap; ]
RotateRight[aList]
:[font = input; preserveAspect; endGroup; nowordwrap; ]
RotateLeft[aList, 3]
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Example: The Cross Product
:[font = input; preserveAspect; nowordwrap; ]
crossNaive[u_, v_] :=
  { 
    u[[2]] v[[3]] - u[[3]] v[[2]],
    u[[3]] v[[1]] - u[[1]] v[[3]],
    u[[1]] v[[2]] - u[[2]] v[[1]]
  }
:[font = input; preserveAspect; nowordwrap; ]
u = {x1, y1, z1}; v = {x2, y2, z2};
:[font = input; preserveAspect; nowordwrap; ]
crossNaive[u, v]
:[font = input; preserveAspect; nowordwrap; ]
crossNaive[a, b]
:[font = input; preserveAspect; nowordwrap; ]
VectorQ[Sin[x]]
:[font = input; preserveAspect; nowordwrap; ]
VectorQ[{a, b}]
:[font = input; preserveAspect; nowordwrap; ]
crossFormula[u_List, v_List] :=
  {u[[2]] v[[3]] - u[[3]] v[[2]],
   u[[3]] v[[1]] - u[[1]] v[[3]],
   u[[1]] v[[2]] - u[[2]] v[[1]]} /; 
    VectorQ[u] && VectorQ[v] && 
    Length[u] == 3 && Length[v] == 3
:[font = input; preserveAspect; nowordwrap; ]
crossFormula[a, b]
:[font = input; preserveAspect; nowordwrap; ]
RotateLeft[u RotateLeft[v] - RotateLeft[u] v]
:[font = input; nowordwrap; ]
cross[u_List, v_List] := 
  RotateLeft[u RotateLeft[v] - RotateLeft[u] v] /; 
    VectorQ[u] && VectorQ[v] && 
    Length[u] == 3 && Length[v] == 3
:[font = input; preserveAspect; nowordwrap; ]
Table[crossFormula[u, v], {20}]; // Timing
:[font = input; preserveAspect; nowordwrap; ]
Table[cross[u, v], {20}]; // Timing
:[font = input; preserveAspect; nowordwrap; ]
<<LinearAlgebra`CrossProduct`
:[font = input; preserveAspect; nowordwrap; ]
Table[Cross[u, v], {20}]; // Timing
:[font = input; preserveAspect; nowordwrap; ]
crossFast[{u1_, u2_, u3_}?VectorQ,
          {v1_, v2_, v3_}?VectorQ] :=
  {u2 v3 - u3 v2, u3 v1 - u1 v3, u1 v2 - u2 v1}
:[font = input; preserveAspect; nowordwrap; ]
crossFast[u, v]
:[font = input; preserveAspect; endGroup; nowordwrap; ]
Table[crossFast[u, v], {20}]; // Timing
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Efficiency of List Manipulations
:[font = input; preserveAspect; nowordwrap; ]
direct = Table[a, {500}]; // Timing
:[font = input; preserveAspect; nowordwrap; ]
appended = {};
:[font = input; preserveAspect; nowordwrap; ]
Do[appended = Append[appended, a], {500}]; // Timing
:[font = input; preserveAspect; endGroup; endGroup; nowordwrap; ]
Shallow[{appended, direct}]
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
1.6.4 Vectors, Matrices, Tensors: The Jacobian
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Predefined Matrices and Matrix-Functions
:[font = input; preserveAspect; nowordwrap; ]
id = IdentityMatrix[3]
:[font = input; preserveAspect; nowordwrap; ]
diag = DiagonalMatrix[{a, b, c}]
:[font = input; preserveAspect; nowordwrap; ]
m = {{a, b}, {c, d}}
:[font = input; preserveAspect; nowordwrap; ]
Det[m]
:[font = input; preserveAspect; nowordwrap; ]
Transpose[m]
:[font = input; preserveAspect; nowordwrap; ]
Inverse[m]
:[font = input; preserveAspect; nowordwrap; ]
MatrixPower[m, 2]
:[font = input; preserveAspect; endGroup; nowordwrap; ]
MatrixExp[{{a, b}, {b, a}}]
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Example: Scaled Plots of Data
:[font = input; preserveAspect; startGroup; Cclosed; nowordwrap; ]
(expData = ReadList["raw-data-file.m", Real]) // Short
:[font = output; inactive; formatted; output; endGroup; nowordwrap; ]
Short["<<>>"]



;[o]
{0.07969920798244439641, <<59>>, -0.2<<16>>09}
:[font = input; preserveAspect; nowordwrap; ]
(timeValues = Range[0, 6, .1]) // Short
:[font = input; preserveAspect; nowordwrap; ]
Transpose[{timeValues, expData}] // Short
:[font = input; preserveAspect; endGroup; nowordwrap; ]
ListPlot[%]
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Products: The Jacobian
:[font = input; preserveAspect; nowordwrap; ]
a Array[x, 3]
:[font = input; preserveAspect; nowordwrap; ]
diag . Array[x, {3, 3}]
:[font = input; preserveAspect; nowordwrap; ]
Array[x, 3] . Array[y, 3]
:[font = input; preserveAspect; nowordwrap; ]
Outer[Times, Array[x, 2], Array[y, 2]] // MatrixForm
:[font = input; preserveAspect; nowordwrap; ]
Outer[f, Array[x, 2], Array[y, 2]] // MatrixForm
:[font = input; preserveAspect; nowordwrap; ]
jac1[f_, var_, point_] :=
  (Table[D[f[[i]], var[[j]]], 
    {i, Length[f]}, {j, Length[var]}] /. 
      Table[var[[k]] -> point[[k]], {k, Length[var]}]) /;
    Length[var] == Length[point]
:[font = input; preserveAspect; nowordwrap; ]
jac1[{x y, x + y}, {x, y}, {1, 2}]
:[font = input; preserveAspect; nowordwrap; ]
jac2[f_, var_, point_] :=
  (D[f, #]& /@ var /. 
    Table[var[[k]] -> point[[k]], {k, Length[var]}]) /;
    Length[var] == Length[point]
:[font = input; preserveAspect; nowordwrap; ]
jac2[{x y, x + y}, {x, y}, {1, 2}]
:[font = input; preserveAspect; nowordwrap; ]
jac3[f_, var_, point_] :=
  (Outer[D, f, var] /. 
    Table[var[[k]] -> point[[k]], {k, Length[var]}]) /;
    Length[var] == Length[point]
:[font = input; preserveAspect; nowordwrap; ]
jac3[{x y, x + y}, {x, y}, {1, 2}]
:[font = input; preserveAspect; nowordwrap; ]
jac4[f_, var_, point_] :=
  (Outer[D, f, var] /. 
    var -> point) /;
    Length[var] == Length[point]
:[font = input; preserveAspect; nowordwrap; ]
jac4[{x y, x + y}, {x, y}, {1, 2}]
:[font = input; preserveAspect; nowordwrap; ]
Thread[f[{a, b}, {c, d}]]
:[font = input; preserveAspect; nowordwrap; ]
Thread[{x, y} -> {1, 2}]
:[font = input; preserveAspect; nowordwrap; ]
jac[f_, var_, point_] :=
  (Outer[D, f, var] /. Thread[var -> point]) /;
    Length[var] == Length[point]
:[font = input; preserveAspect; endGroup; endGroup; nowordwrap; ]
jac[{x y, x + y}, {x, y}, {1, 2}]
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
1.6.5 Eigenvectors and Eigenvalues: An Oscillator
:[font = input; nowordwrap; ]
m = DiagonalMatrix[{m1, m1, m2, m2, m3, m3}];
:[font = input; nowordwrap; ]
c = f*
    {
     {1/2, 0, -1/4, Sqrt[3]/4, -1/4, -Sqrt[3]/4},
     {0, 5/2, Sqrt[3]/4, -3/4, -Sqrt[3]/4, -3/4},
     {-1/4, Sqrt[3]/4, 9/4, -Sqrt[3]/4, -1, 0},
     {Sqrt[3]/4, -3/4, -Sqrt[3]/4, 7/4, 0, 0},
     {-1/4, -Sqrt[3]/4, -1, 0, 9/4, Sqrt[3]/4},
     {-Sqrt[3]/4, -3/4, 0, 0, Sqrt[3]/4, 7/4}
    };
:[font = input; preserveAspect; nowordwrap; ]
c - Transpose[c] // MatrixForm
:[font = input; nowordwrap; ]
Eigenvalues[Inverse[m].c];
:[font = input; preserveAspect; nowordwrap; ]
Det[Inverse[m].c - mu IdentityMatrix[6]] // Simplify
:[font = input; nowordwrap; ]
numericalValues =
  {f -> 1., m1 -> 1., m2 -> 1.5, m3 -> 2.};
:[font = input; nowordwrap; ]
Eigenvalues[Inverse[m].c /. numericalValues]
:[font = input; nowordwrap; ]
Eigenvectors[Inverse[m].c /. numericalValues]
:[font = input; preserveAspect; nowordwrap; ]
N[%, 2] // MatrixForm
:[font = input; preserveAspect; endGroup; endGroup; nowordwrap; ]
Save["oscillator.m", m, c, numericalValues]
^*)