(*^

::[	frontEndVersion = "Microsoft Windows Mathematica Notebook Front End Version 2.2";
	microsoftWindowsStandardFontEncoding;
	fontset = title, "Times New Roman", 24, L0, center, nohscroll, bold;
	fontset = subtitle, "Times New Roman", 18, L0, center, nohscroll, bold;
	fontset = subsubtitle, "Times New Roman", 14, L0, center, nohscroll, bold;
	fontset = section, "Times New Roman", 14, L0, bold, grayBox;
	fontset = subsection, "Times New Roman", 12, L0, bold, blackBox;
	fontset = subsubsection, "Times New Roman", 10, L0, bold, whiteBox;
	fontset = text, "Times New Roman", 12, L0;
	fontset = smalltext, "Times New Roman", 10, L0;
	fontset = input, "Courier New", 12, L0, nowordwrap, bold;
	fontset = output, "Courier New", 12, L0, nowordwrap;
	fontset = message, "Courier New", 10, L0, nowordwrap, R65535;
	fontset = print, "Courier New", 10, L0, nowordwrap;
	fontset = info, "Courier New", 10, L0, nowordwrap;
	fontset = postscript, "Courier New", 8, L0, nowordwrap;
	fontset = name, "Times New Roman", 10, L0, nohscroll, italic, B65535;
	fontset = header, "Times New Roman", 10, L0, right, nohscroll;
	fontset = footer, "Times New Roman", 10, L0, right, nohscroll;
	fontset = help, "Times New Roman", 10, L0, nohscroll;
	fontset = clipboard, "Times New Roman", 12, L0, nohscroll;
	fontset = completions, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = graphics, "Courier New", 10, L0, nowordwrap, nohscroll;
	fontset = special1, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = special2, "Times New Roman", 12, L0, center, nowordwrap, nohscroll;
	fontset = special3, "Times New Roman", 12, L0, right, nowordwrap, nohscroll;
	fontset = special4, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = special5, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = leftheader, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = leftfooter, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = reserved1, "Courier New", 10, L0, nowordwrap, nohscroll;]
:[font = section; inactive; preserveAspect; startGroup; ]
1.7 Graphics Programming
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
1.7.1 The Structure of Graphics
:[font = input; preserveAspect; nowordwrap; ]
ListPlot[{{0, 0}, {.5, .5}, {1, 1}}]
:[font = input; preserveAspect; nowordwrap; ]
Short[InputForm[%], 4]
:[font = input; preserveAspect; nowordwrap; ]
Show[Graphics3D[
  Cuboid /@ {{0,0,0},{-1,0,0},{1,0,0},{2,0,0},
    {0,1,0},{0,-1,0},{0,0,1},{0,0,-1}}]]
:[font = input; preserveAspect; nowordwrap; ]
Show[Graphics[
  {
    Line[{{0,0},{0,1},{1,1},{1,0},{0,0}}],
    {GrayLevel[.4], Rectangle[{0, 0}, {.2, .2}]},
    {
      Dashing[{.1, .05}],
      Circle[{.5,.5}, .3, {Pi/2,3Pi/2}],
      Thickness[.02], Line[{{.1,.9},{.9,.1}}]
    },
    {PointSize[.1], Point[{.5,.5}]},
    Text["large dot", {.7,.5}],
    Text[FontForm[
      "rectangle (\"Courier\",14)", {"Courier",14}],
      {.6,.05}]
  }]
]
:[font = input; preserveAspect; endGroup; nowordwrap; ]
Show[%,
  AspectRatio -> 1,
  Axes -> True,
  Background -> GrayLevel[.9]
]
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
1.7.2 Example: Animation of the Triple Pendulum
:[font = input; preserveAspect; nowordwrap; ]
angles = {.1, .2, .25};
:[font = input; preserveAspect; nowordwrap; ]
x1 = Sin[angles[[1]]];
:[font = input; preserveAspect; nowordwrap; ]
y1 = - Cos[angles[[1]]];
:[font = input; preserveAspect; nowordwrap; ]
x2 = x1 + Sin[angles[[2]]];
:[font = input; preserveAspect; nowordwrap; ]
y2 = y1 - Cos[angles[[2]]];
:[font = input; preserveAspect; nowordwrap; ]
x3 = x2 + Sin[angles[[3]]];
:[font = input; preserveAspect; nowordwrap; ]
y3 = y2 - Cos[angles[[3]]];
:[font = input; preserveAspect; nowordwrap; ]
Show[Graphics[Line[
  {{0, 0}, {x1, y1}, {x2, y2}, {x3, y3}}]],
  AspectRatio -> Automatic,
  PlotRange -> {{-3,3},{-3,3}}]
:[font = input; preserveAspect; nowordwrap; ]
<<Graphics`Colors`
:[font = input; preserveAspect; nowordwrap; ]
Show[Graphics[
  {
    Thickness[.01],
    {
      {Red, Line[{{0, 0}, {x1, y1}}]},
      {Green, Line[{{x1, y1}, {x2, y2}}]},
      {Blue, Line[{{x2, y2}, {x3, y3}}]}
    }
  },
  AspectRatio -> Automatic,
  PlotRange -> {{-3, 3},{-3, 3}}]
]
:[font = input; preserveAspect; nowordwrap; ]
pendulumLines[angles_] :=
  (
    x1 = Sin[angles[[1]]];
    y1 = - Cos[angles[[1]]];
    x2 = x1 + Sin[angles[[2]]];
    y2 = y1 - Cos[angles[[2]]];
    x3 = x2 + Sin[angles[[3]]];
    y3 = y2 - Cos[angles[[3]]];
    Graphics[
      {
        Thickness[.01],
        {
          {Red, Line[{{0, 0}, {x1, y1}}]},
          {Green, Line[{{x1, y1}, {x2, y2}}]},
          {Blue, Line[{{x2, y2}, {x3, y3}}]}
        }
      },
      AspectRatio -> Automatic,
      PlotRange -> {{-3, 3},{-3, 3}}
    ]
  )
:[font = input; preserveAspect; nowordwrap; ]
Clear[x1, y1, x2, y2, x3, y3]
:[font = input; preserveAspect; nowordwrap; ]
Show[pendulumLines[angles]]
:[font = input; preserveAspect; nowordwrap; ]
x1
:[font = input; preserveAspect; nowordwrap; ]
pendulumLines[angles_] :=
  Module[
    {x1, y1, x2, y2, x3, y3},
    x1 = Sin[angles[[1]]];
    y1 = - Cos[angles[[1]]];
    x2 = x1 + Sin[angles[[2]]];
    y2 = y1 - Cos[angles[[2]]];
    x3 = x2 + Sin[angles[[3]]];
    y3 = y2 - Cos[angles[[3]]];
    Graphics[
      {
        Thickness[.01],
        {
          {Red, Line[{{0, 0}, {x1, y1}}]},
          {Green, Line[{{x1, y1}, {x2, y2}}]},
          {Blue, Line[{{x2, y2}, {x3, y3}}]}
        }
      },
      AspectRatio -> Automatic,
      PlotRange -> {{-3, 3},{-3, 3}}
    ]
  ] /; VectorQ[angles] && Length[angles] == 3
:[font = input; preserveAspect; nowordwrap; ]
Clear[x1, y1, x2, y2, x3, y3]
:[font = input; preserveAspect; nowordwrap; ]
pendulumLines[angles];
:[font = input; preserveAspect; nowordwrap; ]
x1
:[font = input; preserveAspect; nowordwrap; ]
<<triplePendulum.m;
:[font = input; preserveAspect; nowordwrap; ]
initials =
  {phi1[0] == 3, phi2[0] == 0, phi3[0] == 0,
   phi1'[0] == 0, phi2'[0] == 0, phi3'[0] == 0 };
:[font = input; preserveAspect; nowordwrap; ]
valueRule = {m -> 1, l -> 1, g -> 1};
:[font = input; preserveAspect; nowordwrap; ]
lagSolRule = NDSolve[Evaluate[
  Flatten[{lagEquations, initials}] /.
    valueRule], angles, {t, 0, 10}];
:[font = input; preserveAspect; nowordwrap; ]
animationGraphics =
  Table[pendulumLines[angles /. lagSolRule[[1]]],
    {t, 0, 10, 1/10}];
:[font = input; preserveAspect; nowordwrap; ]
<<Graphics`Animation`
:[font = input; preserveAspect; nowordwrap; ]
ShowAnimation[animationGraphics]
:[font = input; preserveAspect; endGroup; nowordwrap; ]
Show[GraphicsArray[Partition[
  animationGraphics[[Range[1, 97, 2]]], 6]]]
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
1.7.3 Example: The Oscillator
:[font = input; nowordwrap; ]
<<oscillator.m
:[font = input; nowordwrap; ]
masses := {m1, m2, m3} /. numericalValues
:[font = input; preserveAspect; nowordwrap; ]
massDisks[points_] :=
  Thread[Disk[points, .05 Sqrt[masses]]]
:[font = input; nowordwrap; ]
equiPts = {{1/2, Sqrt[3]/2}, {1, 0}, {0, 0}};
:[font = input; preserveAspect; nowordwrap; ]
Show[Graphics[massDisks[equiPts]],
  AspectRatio -> Automatic]
:[font = input; nowordwrap; ]
box = Line[{ {-1, -1}, {2, -1}, {2, Sqrt[3]/2 + 1},
             {-1, Sqrt[3]/2 + 1}, {-1, -1} }];
:[font = input; preserveAspect; nowordwrap; ]
springLines[points_] :=
  { 
    Line[{{1/2, Sqrt[3]/2 + 1}, points[[1]]}],
    Line[{{1, -1}, points[[2]], {2, 0}}],
    Line[{{-1, 0}, points[[3]], {0, -1}}],
    Line[Append[points, points[[1]]]]
  }
:[font = input; preserveAspect; nowordwrap; ]
Show[Graphics[
  { 
    box,
    massDisks[equiPts],
    springLines[equiPts]
  },
  AspectRatio -> Automatic]
]
:[font = input; preserveAspect; nowordwrap; ]
Needs["Graphics`Colors`"]
:[font = input; preserveAspect; nowordwrap; ]
Show[Graphics[
  { 
    {Red, Thickness[.02], box},
    { 
      Magenta,
      massDisks[equiPts],
      {Dashing[{.05, .05}], springLines[equiPts]}
    }
  },
  AspectRatio -> Automatic]
]
:[font = input; nowordwrap; ]
ev = Eigenvectors[Inverse[m].c /. numericalValues];
:[font = input; preserveAspect; nowordwrap; ]
oscPts[mode_, scale_] :=
  equiPts + scale Partition[ev[[mode]], 2]
:[font = input; preserveAspect; nowordwrap; ]
dispPts = oscPts[1, .2];
:[font = input; preserveAspect; nowordwrap; ]
Show[Graphics[
  { 
    {Red, Thickness[.02], box},
    { 
      Magenta,
      massDisks[equiPts],
      {Dashing[{.05, .05}], springLines[equiPts]}
    },
    { 
      Blue,
      massDisks[dispPts],
      springLines[dispPts]
    }   
  },
  AspectRatio -> Automatic]
]
:[font = input; preserveAspect; nowordwrap; ]
generateGraphics[mode_, scale_] :=
  Module[{dispPts = oscPts[mode, scale]},
    Graphics[
      { 
        { Red, Thickness[.02], box },
        { 
          Magenta,
          massDisks[equiPts],
          {Dashing[{.05, .05}], springLines[equiPts]}
        },
        { 
          Blue,
          massDisks[dispPts],
          springLines[dispPts]
        }   
      },
      AspectRatio -> Automatic
    ]
  ]
:[font = input; preserveAspect; nowordwrap; ]
animationGraphics[mode_] :=
  Table[generateGraphics[mode, 0.2 Sin[t]],
    {t, 0, 2Pi - Pi/10, Pi/10}]
:[font = input; preserveAspect; nowordwrap; ]
picts = animationGraphics[1];
:[font = input; preserveAspect; nowordwrap; ]
Needs["Graphics`Animation`"]
:[font = input; preserveAspect; nowordwrap; ]
ShowAnimation[picts]
:[font = input; preserveAspect; endGroup; endGroup; nowordwrap; ]
Show[GraphicsArray[Partition[picts, 4]]]
^*)