(*^

::[	frontEndVersion = "Microsoft Windows Mathematica Notebook Front End Version 2.2";
	microsoftWindowsStandardFontEncoding;
	fontset = title, "Times New Roman", 24, L0, center, nohscroll, bold;
	fontset = subtitle, "Times New Roman", 18, L0, center, nohscroll, bold;
	fontset = subsubtitle, "Times New Roman", 14, L0, center, nohscroll, bold;
	fontset = section, "Times New Roman", 14, L0, bold, grayBox;
	fontset = subsection, "Times New Roman", 12, L0, bold, blackBox;
	fontset = subsubsection, "Times New Roman", 10, L0, bold, whiteBox;
	fontset = text, "Times New Roman", 12, L0;
	fontset = smalltext, "Times New Roman", 10, L0;
	fontset = input, "Courier New", 12, L0, nowordwrap, bold;
	fontset = output, "Courier New", 12, L0, nowordwrap;
	fontset = message, "Courier New", 10, L0, nowordwrap, R65535;
	fontset = print, "Courier New", 10, L0, nowordwrap;
	fontset = info, "Courier New", 10, L0, nowordwrap;
	fontset = postscript, "Courier New", 8, L0, nowordwrap;
	fontset = name, "Times New Roman", 10, L0, nohscroll, italic, B65535;
	fontset = header, "Times New Roman", 10, L0, right, nohscroll;
	fontset = footer, "Times New Roman", 10, L0, right, nohscroll;
	fontset = help, "Times New Roman", 10, L0, nohscroll;
	fontset = clipboard, "Times New Roman", 12, L0, nohscroll;
	fontset = completions, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = graphics, "Courier New", 10, L0, nowordwrap, nohscroll;
	fontset = special1, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = special2, "Times New Roman", 12, L0, center, nowordwrap, nohscroll;
	fontset = special3, "Times New Roman", 12, L0, right, nowordwrap, nohscroll;
	fontset = special4, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = special5, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = leftheader, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = leftfooter, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = reserved1, "Courier New", 10, L0, nowordwrap, nohscroll;]
:[font = section; inactive; preserveAspect; startGroup; ]
1.8 More Selected Tools
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
1.8.1 Graphics and Sound
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Vector Fields
:[font = input; preserveAspect; nowordwrap; ]
<<Graphics`PlotField`
:[font = input; preserveAspect; nowordwrap; ]
?Graphics`PlotField`*
:[font = input; preserveAspect; nowordwrap; ]
?PlotVectorField
:[font = input; preserveAspect; nowordwrap; ]
vf = PlotVectorField[
  {-y + x^2, x + Sin[y]}, {x, -2, 2}, {y, -2, 2}]
:[font = input; preserveAspect; nowordwrap; ]
NDSolve[
  {x'[t] == -y[t] + x[t]^2, y'[t] == x[t] + Sin[y[t]], 
  x[0] == -1.5, y[0] == 0}, {x, y}, {t, 0, 2}];
:[font = input; preserveAspect; nowordwrap; ]
sol = ParametricPlot[Evaluate[{x[t], y[t]} /. %],
  {t, 0, 2}, PlotRange -> {{-2, 2}, {-2, 2}}]
:[font = input; preserveAspect; endGroup; nowordwrap; ]
Show[{sol, vf}, AspectRatio -> Automatic]
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Graphics Tools
:[font = input; preserveAspect; nowordwrap; ]
<<Graphics`Graphics`
:[font = input; preserveAspect; nowordwrap; ]
?Graphics`Graphics`*
:[font = input; preserveAspect; nowordwrap; ]
Plot[BesselJ[3, x], {x, 0, 6Pi},
  Ticks -> {PiScale, Automatic}]
:[font = input; preserveAspect; endGroup; nowordwrap; ]
BarChart[Sin[Range[10]]^2]
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Sound
:[font = input; preserveAspect; nowordwrap; ]
Play[Sin[2Pi 440t], {t, 0, 2}]
:[font = input; preserveAspect; endGroup; endGroup; nowordwrap; ]
Play[AiryAi[t] Sin[2Pi 440t], {t, 0, 2}]
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
1.8.2 Complex Numbers
:[font = input; preserveAspect; nowordwrap; ]
Re[a + I b]
:[font = input; preserveAspect; nowordwrap; ]
ComplexExpand[Re[a + I b]]
:[font = input; preserveAspect; nowordwrap; ]
ComplexExpand[Re[a + I b], {a, b}]
:[font = input; preserveAspect; nowordwrap; ]
ComplexExpand[Re[a + I b], {a, b},
  TargetFunctions -> {Abs, Arg}]
:[font = input; preserveAspect; nowordwrap; ]
ComplexExpand[Sin[a + I b]]
:[font = input; preserveAspect; nowordwrap; ]
<<Algebra`ReIm`
:[font = input; preserveAspect; nowordwrap; ]
a /: Im[a] = 0;
:[font = input; preserveAspect; nowordwrap; ]
Im[b] = 0
:[font = input; preserveAspect; nowordwrap; ]
b /: Im[b] = 0;
:[font = input; preserveAspect; nowordwrap; ]
Re[(a + I b)^3]
:[font = input; preserveAspect; nowordwrap; ]
ComplexExpand[Re[(a + I b)^3]]
:[font = input; preserveAspect; nowordwrap; ]
{Abs[(a + I b)^3], Arg[(a + I b)^3]}
:[font = input; preserveAspect; endGroup; nowordwrap; ]
ComplexExpand[#, TargetFunctions -> {Re, Im}]& /@
  {Abs[(a + I b)^3], Arg[(a + I b)^3]}
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
1.8.3 Sums, Products, Series
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Symbolic Sums, Products, and Series
:[font = input; preserveAspect; nowordwrap; ]
Sum[k^3, {k, 10}]
:[font = input; preserveAspect; nowordwrap; ]
Sum[k^3, {k, n}]
:[font = input; preserveAspect; nowordwrap; ]
Product[1 - 1/(2k), {k, 1, n}]
:[font = input; preserveAspect; nowordwrap; ]
Sum[(n - 1)/(n + 1)^5, {n, Infinity}]
:[font = input; preserveAspect; nowordwrap; ]
NSum[(n - 1)/(n + 1)^5, {n, Infinity}]
:[font = input; preserveAspect; nowordwrap; ]
<<Algebra`SymbolicSum`
:[font = input; preserveAspect; nowordwrap; ]
Sum[k^3, {k, n}]
:[font = input; preserveAspect; nowordwrap; ]
Product[1 - 1/(2k), {k, 1, n}]
:[font = input; preserveAspect; endGroup; nowordwrap; ]
Sum[(n - 1)/(n + 1)^5, {n, Infinity}]
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Taylor Expansions
:[font = input; preserveAspect; nowordwrap; ]
Series[Sin[x] Exp[x^2], {x, 0, 8}]
:[font = input; preserveAspect; nowordwrap; ]
InverseSeries[%, x]
:[font = input; preserveAspect; nowordwrap; ]
%% /. x -> %
:[font = input; preserveAspect; endGroup; endGroup; nowordwrap; ]
Normal[%]
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
1.8.4 Data Analysis, Interpolation
:[font = subsubsection; inactive; preserveAspect; ]
Reading and Plotting External Data
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Approximations, Interpolations
:[font = input; preserveAspect; nowordwrap; ]
data = Table[N[x! Exp[-2x]], {x, 10}];
:[font = input; preserveAspect; nowordwrap; ]
dataPlot = ListPlot[data, AxesOrigin -> {0, 0}]
:[font = input; preserveAspect; nowordwrap; ]
fit1 = Fit[data, {1, x, x^2}, x]
:[font = input; preserveAspect; nowordwrap; ]
fit2 = Fit[data, {1, x^2, Exp[-x]}, x]
:[font = input; preserveAspect; nowordwrap; ]
fit3 = Exp[Fit[Log[data], {1, x, x^2}, x]]
:[font = input; preserveAspect; nowordwrap; ]
fitPlot = Plot[{fit1, fit2, fit3}, {x, 1, 10},
  PlotStyle -> {Dashing[{1, 0}], Dashing[{.09, .02}],
    Dashing[{.06, .02}]},
  DisplayFunction -> Identity]
:[font = input; preserveAspect; nowordwrap; ]
Show[fitPlot, dataPlot,
  DisplayFunction -> $DisplayFunction]
:[font = input; preserveAspect; nowordwrap; ]
iPoly = InterpolatingPolynomial[data, x]
:[font = input; preserveAspect; nowordwrap; ]
iPolyPlot = Plot[iPoly, {x, 1, 10},
  DisplayFunction -> Identity]
:[font = input; preserveAspect; nowordwrap; ]
Show[iPolyPlot, dataPlot,
  DisplayFunction -> $DisplayFunction,
  PlotRange -> {0, .04}]
:[font = input; preserveAspect; nowordwrap; ]
iFunct = Interpolation[data]
:[font = input; preserveAspect; nowordwrap; ]
iFunctPlot = Plot[iFunct[x], {x, 1, 10},
  DisplayFunction -> Identity]
:[font = input; preserveAspect; endGroup; nowordwrap; ]
Show[iFunctPlot, dataPlot,
  DisplayFunction -> $DisplayFunction,
  PlotRange -> {0, .04}]
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Statistical Analysis, Nonlinear Fits
:[font = input; preserveAspect; endGroup; endGroup; nowordwrap; ]
Needs["Statistics`Master`"]
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
1.8.5 Transformations
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Discrete Fourier Transforms
:[font = input; nowordwrap; ]
expData = Join[{.5}, Table[Exp[-t] // N, 
  {t, .25, 7.75, .25}]];
:[font = input; nowordwrap; ]
ListPlot[expData,
  PlotRange -> {0, 1}, PlotLabel -> "Data"]
:[font = input; nowordwrap; ]
fData = Fourier[expData];
:[font = input; preserveAspect; nowordwrap; ]
fData = fData .25 Sqrt[Length[expData]] // N;
:[font = input; nowordwrap; ]
discRe = ListPlot[
  Transpose[{Table[t, {t, 0, 3.875, .125}], Re[fData]}], 
  PlotRange -> All, PlotLabel -> "Re[DFT]"]
:[font = input; preserveAspect; nowordwrap; ]
cft = Integrate[Exp[-t] Exp[2Pi I f t], {t, 0, Infinity}]
:[font = input; preserveAspect; nowordwrap; ]
cftRe = ComplexExpand[Re[cft]]
:[font = input; nowordwrap; ]
contRe = Plot[cftRe, {f, 0, 2},
  PlotLabel -> "Re[CFT]"]
:[font = input; endGroup; nowordwrap; ]
Show[discRe, contRe,
  PlotLabel -> "Re[DFT], Re[CFT]",
  PlotRange -> {{0, 3.875/2}, All}]
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Symbolic Fourier Transforms
:[font = input; preserveAspect; nowordwrap; ]
<<Calculus`FourierTransform`
:[font = input; preserveAspect; nowordwrap; ]
?Calculus`FourierTransform`*
:[font = input; preserveAspect; nowordwrap; ]
FourierTransform[Exp[-a t^2]/b, t, f]
:[font = input; preserveAspect; nowordwrap; ]
InverseFourierTransform[%, f, t]
:[font = input; preserveAspect; nowordwrap; ]
FourierTransform[1, t, f]
:[font = input; preserveAspect; nowordwrap; ]
fs = FourierTrigSeries[x^2, {x, 0, 1}, 3]
:[font = input; preserveAspect; endGroup; nowordwrap; ]
Plot[{fs, (x - Floor[x])^2}, {x, 0, 4}]
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Symbolic Laplace Transforms
:[font = input; preserveAspect; nowordwrap; ]
<<Calculus`LaplaceTransform`
:[font = input; preserveAspect; nowordwrap; ]
?Calculus`LaplaceTransform`*
:[font = input; preserveAspect; nowordwrap; ]
LaplaceTransform[Exp[t], t, s]
:[font = input; preserveAspect; nowordwrap; ]
InverseLaplaceTransform[Exp[a/s + b], s, t]
:[font = input; preserveAspect; endGroup; endGroup; nowordwrap; ]
LaplaceTransform[g'[t] + t g[t], t, s]
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
1.8.6 Mathematical Functions
:[font = input; preserveAspect; nowordwrap; ]
?RiemannSiegelTheta
:[font = input; preserveAspect; nowordwrap; ]
DSolve[t^2 x''[t] + t x'[t] + (t^2 - n^2)x[t] == 0,
  x[t], t]
:[font = input; preserveAspect; nowordwrap; ]
Integrate[Cos[t]/t, t]
:[font = input; preserveAspect; endGroup; nowordwrap; ]
2/Sqrt[Pi] Integrate[Exp[-t^2], t]
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
1.8.7 Polynomials
:[font = input; preserveAspect; nowordwrap; ]
poly = (a + x)^2 (b - x)^2
:[font = input; preserveAspect; nowordwrap; ]
Length[poly]
:[font = input; preserveAspect; nowordwrap; ]
Length[Expand[poly]]
:[font = input; preserveAspect; nowordwrap; ]
Exponent[poly, x]
:[font = input; preserveAspect; nowordwrap; ]
CoefficientList[poly, x]
:[font = input; preserveAspect; nowordwrap; ]
CoefficientList[poly, {a, b}]
:[font = input; preserveAspect; nowordwrap; ]
PolynomialQuotient[x^10 + x^3 + 1, x^5 - 1, x]
:[font = input; preserveAspect; nowordwrap; ]
PolynomialRemainder[x^10 + x^3 + 1, x^5 - 1, x]
:[font = input; preserveAspect; nowordwrap; ]
Decompose[x^10 + x^5 + 1, x]
:[font = input; preserveAspect; nowordwrap; ]
Decompose[1 - 3x + x^2 - 3x^3 + 2x^4 + x^6, x]
:[font = input; preserveAspect; endGroup; nowordwrap; ]
Expand[%[[1]] /. x -> %[[2]]]
:[font = subsection; inactive; preserveAspect; ]
1.8.8 Linear Algebra, Linear Programming
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
1.8.9 File Manipulation
:[font = input; preserveAspect; nowordwrap; ]
d = Directory[]
:[font = input; preserveAspect; nowordwrap; ]
Save["dummy", d]
:[font = input; preserveAspect; nowordwrap; ]
FileNames[]
:[font = input; preserveAspect; nowordwrap; ]
CopyFile[#,
  StringJoin[#, "-", ToString[FileByteCount[#]]]]& ["dummy"]
:[font = input; preserveAspect; nowordwrap; ]
FileNames["dummy*"]
:[font = input; preserveAspect; nowordwrap; ]
DeleteFile[%]
:[font = input; preserveAspect; endGroup; nowordwrap; ]
FileNames[]
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
1.8.10 Custom Configuration
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
The Initialization File
:[font = input; preserveAspect; nowordwrap; ]
Log[a b]
:[font = input; preserveAspect; nowordwrap; ]
Unprotect[Log]; Log[x_ y_] := Log[x]+Log[y]; Protect[Log];
:[font = input; preserveAspect; endGroup; endGroup; nowordwrap; ]
Log[a b]
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
1.8.11 Resources
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Time
:[font = input; preserveAspect; endGroup; nowordwrap; ]
Table[
  n = Random[Integer, {10^19, 10^20}];
  TimeConstrained[{n, FactorInteger[n]}, 
    1, {n, "difficult"}],
  {5}] // TableForm[#, TableHeadings ->
    {None, {"Number\n", "Factors and Multiplicities\n"}}]&
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Memory
:[font = input; preserveAspect; nowordwrap; ]
Table[ByteCount[(a+b)^i], {i, 10}]
:[font = input; preserveAspect; nowordwrap; ]
Table[ByteCount[Expand[(a+b)^i]], {i, 10}]
:[font = input; preserveAspect; nowordwrap; ]
Table[MemoryConstrained[Expand[(a+b)^i], 500,
  "too large"], {i, 10}]
:[font = input; preserveAspect; nowordwrap; ]
<<Calculus`EllipticIntegrate`
:[font = input; preserveAspect; nowordwrap; ]
MemoryInUse[]
:[font = input; preserveAspect; nowordwrap; ]
Share[] // Timing
:[font = input; preserveAspect; endGroup; endGroup; endGroup; nowordwrap; ]
MemoryInUse[]
^*)