(*^

::[	frontEndVersion = "Microsoft Windows Mathematica Notebook Front End Version 2.2";
	microsoftWindowsStandardFontEncoding;
	fontset = title, "Times New Roman", 24, L0, center, nohscroll, bold;
	fontset = subtitle, "Times New Roman", 18, L0, center, nohscroll, bold;
	fontset = subsubtitle, "Times New Roman", 14, L0, center, nohscroll, bold;
	fontset = section, "Times New Roman", 14, L0, bold, grayBox;
	fontset = subsection, "Times New Roman", 12, L0, bold, blackBox;
	fontset = subsubsection, "Times New Roman", 10, L0, bold, whiteBox;
	fontset = text, "Times New Roman", 12, L0;
	fontset = smalltext, "Times New Roman", 10, L0;
	fontset = input, "Courier New", 12, L0, nowordwrap, bold;
	fontset = output, "Courier New", 12, L0, nowordwrap;
	fontset = message, "Courier New", 10, L0, nowordwrap, R65535;
	fontset = print, "Courier New", 10, L0, nowordwrap;
	fontset = info, "Courier New", 10, L0, nowordwrap;
	fontset = postscript, "Courier New", 8, L0, nowordwrap;
	fontset = name, "Times New Roman", 10, L0, nohscroll, italic, B65535;
	fontset = header, "Times New Roman", 10, L0, right, nohscroll;
	fontset = footer, "Times New Roman", 10, L0, right, nohscroll;
	fontset = help, "Times New Roman", 10, L0, nohscroll;
	fontset = clipboard, "Times New Roman", 12, L0, nohscroll;
	fontset = completions, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = graphics, "Courier New", 10, L0, nowordwrap, nohscroll;
	fontset = special1, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = special2, "Times New Roman", 12, L0, center, nowordwrap, nohscroll;
	fontset = special3, "Times New Roman", 12, L0, right, nowordwrap, nohscroll;
	fontset = special4, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = special5, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = leftheader, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = leftfooter, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = reserved1, "Courier New", 10, L0, nowordwrap, nohscroll;]
:[font = section; inactive; preserveAspect; startGroup; ]
2.3 Transformation Rules and Definitions
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
2.3.1 Transformation Rules
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
The Simplest Use of Transformation Rules
:[font = input; preserveAspect; nowordwrap; ]
expr = x^2 + y^2
:[font = input; preserveAspect; nowordwrap; ]
rule1 = {x -> 1, y -> 2}
:[font = input; preserveAspect; nowordwrap; ]
expr /. rule1
:[font = input; preserveAspect; nowordwrap; ]
rule2 = {x -> 2, y -> 2}
:[font = input; preserveAspect; endGroup; nowordwrap; ]
expr /. {rule1, rule2}
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Multiple Evaluation of Transformation Rules
:[font = input; preserveAspect; nowordwrap; ]
expr /. {x -> (y + a), y -> b}
:[font = input; preserveAspect; nowordwrap; ]
expr /. x -> (y + a) /. y -> b
:[font = input; preserveAspect; nowordwrap; ]
expr //. {x -> (y + a), y -> b}
:[font = input; preserveAspect; nowordwrap; ]
fac[5] //. {fac[0] -> 1, fac[n_] -> n fac[n-1]}
:[font = input; preserveAspect; endGroup; nowordwrap; ]
fac[5] //. {fac[n_] -> n fac[n-1], fac[0] -> 1}
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Optimization
:[font = input; preserveAspect; nowordwrap; ]
rules = Table[s[i] -> Sin[i], {i, 10000}];
:[font = input; preserveAspect; nowordwrap; ]
dispRules = Dispatch[rules];
:[font = input; preserveAspect; nowordwrap; ]
s[6000] /. rules // Timing
:[font = input; preserveAspect; endGroup; nowordwrap; ]
s[6000] /. dispRules // Timing
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Delayed Transformation Rules
:[font = input; preserveAspect; nowordwrap; ]
immRule = x_ -> Expand[x]
:[font = input; preserveAspect; nowordwrap; ]
(a + b)^2 /. immRule
:[font = input; preserveAspect; nowordwrap; ]
delRule = x_ :> Expand[x]
:[font = input; preserveAspect; endGroup; endGroup; nowordwrap; ]
(a + b)^2 /. delRule
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
2.3.2 Definitions
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Immediate and Delayed Definitions
:[font = input; preserveAspect; nowordwrap; ]
demo1[x] = x
:[font = input; preserveAspect; nowordwrap; ]
{demo1[x], demo1[y]}
:[font = input; preserveAspect; nowordwrap; ]
demo2[x_] = x
:[font = input; preserveAspect; nowordwrap; ]
{demo2[x], demo2[y]}
:[font = input; preserveAspect; nowordwrap; ]
demo3[x_] = Expand[x]
:[font = input; preserveAspect; nowordwrap; ]
demo3[(a+b)^2]
:[font = input; preserveAspect; nowordwrap; ]
demo4[x_] := Expand[x]
:[font = input; preserveAspect; nowordwrap; ]
demo4[(a+b)^2]
:[font = input; preserveAspect; nowordwrap; ]
b = 1
:[font = input; preserveAspect; nowordwrap; ]
a := b
:[font = input; preserveAspect; nowordwrap; ]
b = 2
:[font = input; preserveAspect; nowordwrap; ]
a
:[font = input; preserveAspect; nowordwrap; ]
b = 1
:[font = input; preserveAspect; nowordwrap; ]
a = b
:[font = input; preserveAspect; nowordwrap; ]
b = 2
:[font = input; preserveAspect; endGroup; nowordwrap; ]
a
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
The Order of Evaluation
:[font = input; preserveAspect; nowordwrap; ]
fac[n_] := n fac[n-1]
:[font = input; preserveAspect; nowordwrap; ]
fac[0] = 1
:[font = input; preserveAspect; nowordwrap; ]
fac[100]
:[font = input; preserveAspect; endGroup; nowordwrap; ]
??fac
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Definitions with Memory
:[font = input; preserveAspect; nowordwrap; ]
facFast[n_] := facFast[n] = n facFast[n-1]
:[font = input; preserveAspect; nowordwrap; ]
facFast[0] = 1
:[font = input; preserveAspect; nowordwrap; ]
facFast[10] // Timing
:[font = input; preserveAspect; nowordwrap; ]
??facFast
:[font = input; preserveAspect; endGroup; nowordwrap; ]
facFast[10] // Timing
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Associated Definitions
:[font = input; preserveAspect; nowordwrap; ]
r /: Im[r] = 0
:[font = input; preserveAspect; nowordwrap; ]
Im[r] ^= 0
:[font = input; preserveAspect; nowordwrap; ]
?r
:[font = input; preserveAspect; nowordwrap; ]
Integrate[g[x_], x_] ^:= gint[x, x]
:[font = input; preserveAspect; endGroup; nowordwrap; ]
Integrate[g[t], t] 
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Changing Built-in Functions
:[font = input; preserveAspect; nowordwrap; ]
Re[x_] := x /; Im[x] == 0
:[font = input; preserveAspect; nowordwrap; ]
Unprotect[Re]
:[font = input; preserveAspect; nowordwrap; ]
Re[x_] := x /; Im[x] == 0
:[font = input; preserveAspect; nowordwrap; ]
Protect[Re]
:[font = input; preserveAspect; nowordwrap; ]
Re[r]
:[font = input; preserveAspect; endGroup; nowordwrap; ]
??Re
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Exercises
:[font = input; preserveAspect; nowordwrap; ]
y = D[Sin[1/x]^2, {x, 10}];
:[font = input; preserveAspect; nowordwrap; ]
z := D[Sin[1/x]^2, {x, 10}];
:[font = input; preserveAspect; nowordwrap; ]
Timing[Table[y /. x -> i, {i, 10}];]
:[font = input; preserveAspect; endGroup; endGroup; nowordwrap; ]
Timing[Table[z /. x -> i, {i, 10}];]
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
2.3.3 Attributes
:[font = input; preserveAspect; nowordwrap; ]
Attributes[Sin]
:[font = input; preserveAspect; nowordwrap; ]
SetAttributes[lf, Listable]
:[font = input; preserveAspect; nowordwrap; ]
Attributes[lf]
:[font = input; preserveAspect; nowordwrap; ]
lf[{a, b, c}, d, {e, f, g}]
:[font = input; preserveAspect; nowordwrap; ]
ClearAttributes[lf, Listable]
:[font = input; preserveAspect; nowordwrap; ]
Attributes[lf]
:[font = input; preserveAspect; nowordwrap; ]
SetAttributes[ol, Orderless]
:[font = input; preserveAspect; nowordwrap; ]
ol[q, a, 5, 3]
:[font = input; preserveAspect; nowordwrap; ]
SetAttributes[fl, Flat]
:[font = input; preserveAspect; nowordwrap; ]
fl[fl[a, b], c]
:[font = input; preserveAspect; nowordwrap; ]
fl[a, b, b] /. fl[x_, x_] -> fl2[x]
:[font = input; preserveAspect; nowordwrap; ]
SetAttributes[fl, OneIdentity]
:[font = input; preserveAspect; nowordwrap; ]
fl[a, b, b] /. fl[x_, x_] -> fl2[x]
:[font = input; preserveAspect; nowordwrap; ]
Attributes[Plus]
:[font = input; preserveAspect; nowordwrap; ]
a + b + b /. x_ + x_ -> two[x]
:[font = input; preserveAspect; nowordwrap; ]
Function[x, x > 2][{a, 2, 3}]
:[font = input; preserveAspect; endGroup; endGroup; nowordwrap; ]
Function[x, x > 2, {Listable}][{a, 2, 3}]
^*)