(*^

::[	frontEndVersion = "Microsoft Windows Mathematica Notebook Front End Version 2.2";
	microsoftWindowsStandardFontEncoding;
	fontset = title, "Times New Roman", 24, L0, center, nohscroll, bold;
	fontset = subtitle, "Times New Roman", 18, L0, center, nohscroll, bold;
	fontset = subsubtitle, "Times New Roman", 14, L0, center, nohscroll, bold;
	fontset = section, "Times New Roman", 14, L0, bold, grayBox;
	fontset = subsection, "Times New Roman", 12, L0, bold, blackBox;
	fontset = subsubsection, "Times New Roman", 10, L0, bold, whiteBox;
	fontset = text, "Times New Roman", 12, L0;
	fontset = smalltext, "Times New Roman", 10, L0;
	fontset = input, "Courier New", 12, L0, nowordwrap, bold;
	fontset = output, "Courier New", 12, L0, nowordwrap;
	fontset = message, "Courier New", 10, L0, nowordwrap, R65535;
	fontset = print, "Courier New", 10, L0, nowordwrap;
	fontset = info, "Courier New", 10, L0, nowordwrap;
	fontset = postscript, "Courier New", 8, L0, nowordwrap;
	fontset = name, "Times New Roman", 10, L0, nohscroll, italic, B65535;
	fontset = header, "Times New Roman", 10, L0, right, nohscroll;
	fontset = footer, "Times New Roman", 10, L0, right, nohscroll;
	fontset = help, "Times New Roman", 10, L0, nohscroll;
	fontset = clipboard, "Times New Roman", 12, L0, nohscroll;
	fontset = completions, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = graphics, "Courier New", 10, L0, nowordwrap, nohscroll;
	fontset = special1, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = special2, "Times New Roman", 12, L0, center, nowordwrap, nohscroll;
	fontset = special3, "Times New Roman", 12, L0, right, nowordwrap, nohscroll;
	fontset = special4, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = special5, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = leftheader, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = leftfooter, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = reserved1, "Courier New", 10, L0, nowordwrap, nohscroll;]
:[font = section; inactive; preserveAspect; startGroup; ]
2.4 Evaluation and Tools for Programming
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
2.4.1 Standard Evaluation
:[font = input; preserveAspect; nowordwrap; ]
a = 3;
:[font = input; preserveAspect; nowordwrap; ]
Trace[a^2 + a + 1]
:[font = input; preserveAspect; nowordwrap; ]
s = Sin;
:[font = input; preserveAspect; nowordwrap; ]
Trace[s[{0, a}]]
:[font = input; preserveAspect; nowordwrap; ]
f[g[x_]] = r1;
:[font = input; preserveAspect; nowordwrap; ]
f[g[x_]] ^= r2;
:[font = input; preserveAspect; nowordwrap; ]
f[g[1]]
:[font = input; preserveAspect; nowordwrap; ]
SetAttributes[pr, Orderless]
:[font = input; preserveAspect; nowordwrap; ]
pr[x___] := 1 /; Print[x]
:[font = input; preserveAspect; endGroup; nowordwrap; ]
pr[1, 2, 3]
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
2.4.2 Special Evaluation
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Reasons for Special Evaluation
:[font = input; preserveAspect; endGroup; nowordwrap; ]
Attributes[Set]
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Preventing and Enforcing the Evaluation
:[font = input; preserveAspect; nowordwrap; ]
Attributes[Hold]
:[font = input; preserveAspect; nowordwrap; ]
FullForm[a = 1]
:[font = input; preserveAspect; nowordwrap; ]
FullForm[Hold[a = 1]]
:[font = input; preserveAspect; nowordwrap; ]
Hold[1 + 1]
:[font = input; preserveAspect; nowordwrap; ]
HoldForm[1 + 1]
:[font = input; preserveAspect; nowordwrap; ]
ReleaseHold[%]
:[font = input; preserveAspect; nowordwrap; ]
Attributes[Plot]
:[font = input; preserveAspect; nowordwrap; ]
Plot[Table[x^(1/n), {n, 10}], {x, 0, 2}]
:[font = input; preserveAspect; endGroup; nowordwrap; ]
Plot[Evaluate[Table[x^(1/n), {n, 10}]], {x, 0, 2}]
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
 Patterns, Transformation Rules, and Definitions
:[font = input; preserveAspect; nowordwrap; ]
Hold[D[x, y]] /. D[x, y] -> dxy
:[font = input; preserveAspect; nowordwrap; ]
Hold[D[x, y]] /. Literal[D[x, y]] -> dxy
:[font = input; preserveAspect; endGroup; endGroup; nowordwrap; ]
f[2] = f2; f[1+1] = f11; f[2]
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
2.4.3 Conditionals, Loops, and Control Structures
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Conditionals
:[font = input; preserveAspect; nowordwrap; ]
f1[x_] := 0 /; x < 0
:[font = input; preserveAspect; nowordwrap; ]
f1[x_] := Exp[-x] /; x >= 0
:[font = input; preserveAspect; nowordwrap; ]
Table[f1[i], {i, -1, 1}]
:[font = input; preserveAspect; nowordwrap; ]
f2[x_] := If[x<0, 0, Exp[-x]]
:[font = input; preserveAspect; nowordwrap; ]
Table[f2[i], {i, -1, 1}]
:[font = input; preserveAspect; nowordwrap; ]
g1[x_] := If[Positive[x], "pos", "neg"]
:[font = input; preserveAspect; nowordwrap; ]
g1 /@ {1, -1, q}
:[font = input; preserveAspect; nowordwrap; ]
g2[x_] := If[Positive[x], "pos", "neg", "NaN"]
:[font = input; preserveAspect; nowordwrap; ]
g2 /@ {1, -1, q}
:[font = input; preserveAspect; nowordwrap; ]
h1[x_] := Which[x<0, 0, x<1, 1, x<2, 2]
:[font = input; preserveAspect; nowordwrap; ]
h1 /@ {-1, 0, 1, 2}
:[font = input; preserveAspect; nowordwrap; ]
h2[x_] := Which[x<0, 0, x<1, 1, x<2, 2, True, outside]
:[font = input; preserveAspect; nowordwrap; ]
h2 /@ {-1, 0, 1, 2}
:[font = input; preserveAspect; nowordwrap; ]
k1[f_, x_] := Switch[Integrate[f, x],
  _. x^_, "polyType",
  _. Sin[_] | _. Cos[_], "trigType",
  _. Exp[_], "expType",
  _. Log[_], "logType",
  _, "elseType"]
:[font = input; preserveAspect; nowordwrap; ]
k1[#, x]& /@ {x, Sin[x], Tan[x], 1/x, Exp[x^2]}
:[font = input; preserveAspect; nowordwrap; ]
k2[f_, x_] := Switch[Integrate[f, x],
  _. x^_, Print["polyType"]; pt[f],
  _. Sin[_] | _. Cos[_], Print["trigType"]; tt[f],
  _. Exp[_], Print["expType"]; et[f],
  _. Log[_], Print["logType"]; lt[f],
  _, Print["elseType"]; Fail]
:[font = input; preserveAspect; endGroup; nowordwrap; ]
k2[1/x, x]
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Procedural Structures
:[font = input; preserveAspect; nowordwrap; ]
Do[Print[n], {n, 2}]
:[font = input; preserveAspect; nowordwrap; ]
FullForm[%]
:[font = input; preserveAspect; nowordwrap; ]
n = 1; Do[Print[N[n]]; n = (1 + 1/n), {5}]; n
:[font = input; preserveAspect; nowordwrap; ]
n = 17; While[(n = Floor[n/2]) != 0, Print[n]]
:[font = input; preserveAspect; nowordwrap; ]
n = 1; t = x; While[n <= 4, t = x+1/t; n++]; t
:[font = input; preserveAspect; nowordwrap; ]
For[m=1; s=x, m <= 3, m++, s = (s+x+m)^2; Print[s]]
:[font = input; preserveAspect; endGroup; nowordwrap; ]
Attributes[While]
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Functional Structures
:[font = input; preserveAspect; nowordwrap; ]
Nest[f, x, 5]
:[font = input; preserveAspect; nowordwrap; ]
Nest[x+1/#&, x, 4]
:[font = input; preserveAspect; nowordwrap; ]
NestList[x+1/#&, x, 4]
:[font = input; preserveAspect; nowordwrap; ]
f[x_] = Sin[x^2] - Sin[x]^2;
:[font = input; preserveAspect; nowordwrap; ]
funcPlot = Plot[f[x], {x, 1, 2.1}]
:[font = input; preserveAspect; nowordwrap; ]
fp[x_] = D[f[x], x];
:[font = input; preserveAspect; nowordwrap; ]
newtonList = NestList[#-f[#]/fp[#]&, 2., 5]
:[font = input; preserveAspect; nowordwrap; ]
newtonLines =
  { AbsoluteThickness[0.3],
    Line[Flatten[Drop[Transpose[
      { Transpose[{newtonList,
          Table[0, {Length[newtonList]}]}],
        Transpose[{newtonList, f /@ newtonList}]
      }], -1], 1]] }
:[font = input; preserveAspect; nowordwrap; ]
Show[funcPlot, Graphics[newtonLines]]
:[font = input; preserveAspect; nowordwrap; ]
FixedPointList[#-f[#]/fp[#]&, 2.]
:[font = input; preserveAspect; nowordwrap; ]
FixedPointList[#-f[#]/fp[#]&, 2.,
  SameTest -> (Abs[#1-#2]<.001&)]
:[font = input; preserveAspect; nowordwrap; ]
Clear[f, fp]
:[font = input; preserveAspect; nowordwrap; ]
f[x_] = Cos[x^2] - Cos[x]^2;
:[font = input; preserveAspect; nowordwrap; ]
FindRoot[f[x], {x, 2}] // Timing
:[font = input; preserveAspect; nowordwrap; ]
( fp[x_] = D[f[x], x];
  FixedPoint[#-f[#]/fp[#]&, 2.] ) // Timing
:[font = input; preserveAspect; nowordwrap; ]
Clear[f, fp]
:[font = input; preserveAspect; nowordwrap; ]
f[x_] = Sin[x^2] - Cos[x]^2;
:[font = input; preserveAspect; nowordwrap; ]
fp[x_] = D[f[x], x];
:[font = input; preserveAspect; nowordwrap; ]
newton[x_] := x - f[x]/fp[x]
:[font = input; preserveAspect; nowordwrap; ]
FixedPoint[newton, 2.]
:[font = input; preserveAspect; nowordwrap; ]
FoldList[(#1 + x + #2)^2&, x, Range[3]]
:[font = input; preserveAspect; nowordwrap; ]
ComposeList[{func1, func2, func3}, x]
:[font = input; preserveAspect; nowordwrap; ]
ComposeList[Table[(# + x + i)^2&, {i, 3}], x]
:[font = input; preserveAspect; nowordwrap; ]
Table[Hold[i], {i, 3}]
:[font = input; preserveAspect; nowordwrap; ]
Hold[i] /. i -> k
:[font = input; preserveAspect; nowordwrap; ]
Table[(# + x + k)^2& /. k -> i, {i, 3}]
:[font = input; preserveAspect; nowordwrap; ]
ComposeList[%, x]
:[font = input; preserveAspect; endGroup; endGroup; endGroup; nowordwrap; ]
ComposeList[Table[With[{i=i}, (# + x + i)^2&], {i, 3}], x]
^*)