(*^

::[	frontEndVersion = "Microsoft Windows Mathematica Notebook Front End Version 2.2";
	microsoftWindowsStandardFontEncoding;
	fontset = title, "Times New Roman", 24, L0, center, nohscroll, bold;
	fontset = subtitle, "Times New Roman", 18, L0, center, nohscroll, bold;
	fontset = subsubtitle, "Times New Roman", 14, L0, center, nohscroll, bold;
	fontset = section, "Times New Roman", 14, L0, bold, grayBox;
	fontset = subsection, "Times New Roman", 12, L0, bold, blackBox;
	fontset = subsubsection, "Times New Roman", 10, L0, bold, whiteBox;
	fontset = text, "Times New Roman", 12, L0;
	fontset = smalltext, "Times New Roman", 10, L0;
	fontset = input, "Courier New", 12, L0, nowordwrap, bold;
	fontset = output, "Courier New", 12, L0, nowordwrap;
	fontset = message, "Courier New", 10, L0, nowordwrap, R65535;
	fontset = print, "Courier New", 10, L0, nowordwrap;
	fontset = info, "Courier New", 10, L0, nowordwrap;
	fontset = postscript, "Courier New", 8, L0, nowordwrap;
	fontset = name, "Times New Roman", 10, L0, nohscroll, italic, B65535;
	fontset = header, "Times New Roman", 10, L0, right, nohscroll;
	fontset = footer, "Times New Roman", 10, L0, right, nohscroll;
	fontset = help, "Times New Roman", 10, L0, nohscroll;
	fontset = clipboard, "Times New Roman", 12, L0, nohscroll;
	fontset = completions, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = graphics, "Courier New", 10, L0, nowordwrap, nohscroll;
	fontset = special1, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = special2, "Times New Roman", 12, L0, center, nowordwrap, nohscroll;
	fontset = special3, "Times New Roman", 12, L0, right, nowordwrap, nohscroll;
	fontset = special4, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = special5, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = leftheader, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = leftfooter, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = reserved1, "Courier New", 10, L0, nowordwrap, nohscroll;]
:[font = section; inactive; preserveAspect; startGroup; ]
2.5 Modularity
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
2.5.1 Local Variables and Constants
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Local Variables, Modules
:[font = input; preserveAspect; nowordwrap; ]
rot2D[x_?VectorQ /; Length[x] == 2, phi_] := 
  Module[
    {sinPhi = Sin[phi], cosPhi = Cos[phi]},
    {{cosPhi, -sinPhi}, {sinPhi, cosPhi}} . x
  ]
:[font = input; preserveAspect; nowordwrap; ]
rot2D[{a, b}, 1]
:[font = input; preserveAspect; nowordwrap; ]
myRoot[f_, {x_, x0_}] :=
  Module[{fPrimeLoc = D[f, x]},
    FixedPoint[#-f/fPrimeLoc/.x->#&, N[x0]]
  ]
:[font = input; preserveAspect; nowordwrap; ]
myRoot[BesselJ[1,x] + 1/BesselK[3,x] - 2, {x, 10}]
:[font = input; preserveAspect; nowordwrap; ]
myRoot1[f_, {x_, x0_}] :=
  Module[{fLoc, fPrimeLoc},
    fLoc = Function[{x}, f];
    fPrimeLoc = fLoc';
    FixedPoint[#-fLoc[#]/fPrimeLoc[#]&, N[x0]]
  ]
:[font = input; preserveAspect; nowordwrap; ]
myRoot2[f_, {x_, x0_}] :=
  Module[{fLoc, fPrimeLoc},
    fLoc[xLoc_] = f /. x -> xLoc;
    fPrimeLoc[xLoc_] = D[f, x] /. x -> xLoc;
    FixedPoint[#-fLoc[#]/fPrimeLoc[#]&, N[x0]]
  ]
:[font = input; preserveAspect; nowordwrap; ]
myRoot[Hypergeometric1F1[7, 1, x]/10^4 + BesselJ[1, x] -
  .6, {x, 5}] // Timing
:[font = input; preserveAspect; nowordwrap; ]
myRoot1[Hypergeometric1F1[7, 1, x]/10^4 + BesselJ[1, x] -
  .6, {x, 5}] // Timing
:[font = input; preserveAspect; nowordwrap; ]
myRoot2[Hypergeometric1F1[7, 1, x]/10^4 + BesselJ[1, x] -
  .6, {x, 5}] // Timing
:[font = input; preserveAspect; nowordwrap; ]
FindRoot[Hypergeometric1F1[7, 1, x]/10^4 + BesselJ[1, x] -
  .6, {x, 5}] // Timing
:[font = input; preserveAspect; nowordwrap; ]
t = a; Module[{t = 1, y = t}, y]
:[font = input; preserveAspect; nowordwrap; ]
t = a; Module[{t = 1, y}, y = t]
:[font = input; preserveAspect; nowordwrap; ]
k[x_] := Module[{n}, Log[n] /; (n = x - 1) > 0]
:[font = input; preserveAspect; endGroup; nowordwrap; ]
Table[k[i], {i, 3}]
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Local Constants
:[font = input; preserveAspect; nowordwrap; ]
With[{s = x}, s = q]; {x, s}
:[font = input; preserveAspect; endGroup; nowordwrap; ]
With[{s = a}, Module[{s = b, u = c},
  With[{s = d}, (s + u)^2]]]
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
How it Works
:[font = input; preserveAspect; nowordwrap; ]
Unique[v]
:[font = input; preserveAspect; nowordwrap; ]
Module[{t}, Print[t]]
:[font = input; preserveAspect; nowordwrap; ]
z = Module[{t}, t]
:[font = input; preserveAspect; endGroup; nowordwrap; ]
$SessionID
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Dummy Variables
:[font = input; preserveAspect; nowordwrap; ]
int1[n_] := Integrate[Exp[n y], {y, 0, 1}]
:[font = input; preserveAspect; nowordwrap; ]
int1[a]
:[font = input; preserveAspect; nowordwrap; ]
int1[y]
:[font = input; preserveAspect; nowordwrap; ]
int2[n_] := Module[{y}, Integrate[Exp[n y], {y, 0, 1}]]
:[font = input; preserveAspect; nowordwrap; ]
int2[y]
:[font = input; preserveAspect; nowordwrap; ]
s[n_] := Sum[i^n, {i, 3}]
:[font = input; preserveAspect; nowordwrap; ]
{s[a], s[i]}
:[font = input; preserveAspect; nowordwrap; ]
s1[n_] := Module[{i}, Sum[i^n, {i, 3}]]
:[font = input; preserveAspect; nowordwrap; ]
{s1[a], s1[i]}
:[font = input; preserveAspect; endGroup; nowordwrap; ]
Trace[s[i]]
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Local Values
:[font = input; preserveAspect; nowordwrap; ]
t = 10;
:[font = input; preserveAspect; nowordwrap; ]
f[x_?NumberQ] := Block[{t}, t = N[Sin[x]]; {t, t^2}]
:[font = input; preserveAspect; nowordwrap; ]
f[1]
:[font = input; preserveAspect; nowordwrap; ]
t
:[font = input; preserveAspect; nowordwrap; ]
{Block[{t}, Print[t]]; Module[{t}, Print[t]]};
:[font = input; preserveAspect; nowordwrap; ]
u := s^2 + 1
:[font = input; preserveAspect; nowordwrap; ]
Block[{s = 1}, u]
:[font = input; preserveAspect; endGroup; endGroup; nowordwrap; ]
Module[{s = 1}, u]
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
2.5.2 Contexts and Packages
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Contexts
:[font = input; preserveAspect; nowordwrap; ]
$Context
:[font = input; preserveAspect; nowordwrap; ]
x; Context[x]
:[font = input; preserveAspect; nowordwrap; ]
Global`x - x
:[font = input; preserveAspect; nowordwrap; ]
MyContext`x - x
:[font = input; preserveAspect; nowordwrap; ]
Context[MyContext`Subcontext`x]
:[font = input; preserveAspect; nowordwrap; ]
$Context = "MyContext`"
:[font = input; preserveAspect; nowordwrap; ]
Context[`Subcontext`y]
:[font = input; preserveAspect; endGroup; nowordwrap; ]
$Context = "Global`"
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Searching Contexts
:[font = input; preserveAspect; nowordwrap; ]
Contexts[]
:[font = input; preserveAspect; nowordwrap; ]
$Context
:[font = input; preserveAspect; nowordwrap; ]
$ContextPath
:[font = input; preserveAspect; endGroup; nowordwrap; ]
Context[Integrate]
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
The Shadowing of Names
:[font = input; preserveAspect; nowordwrap; ]
<<Algebra`Trigonometry`
:[font = input; preserveAspect; nowordwrap; ]
$ContextPath
:[font = input; preserveAspect; nowordwrap; ]
Cross[{1, 2, 3}, {1, 2, 4}]
:[font = input; preserveAspect; nowordwrap; ]
<<LinearAlgebra`CrossProduct`
:[font = input; preserveAspect; nowordwrap; ]
Context[Cross]
:[font = input; preserveAspect; nowordwrap; ]
Cross[{1, 2, 3}, {1, 2, 4}]
:[font = input; preserveAspect; nowordwrap; ]
LinearAlgebra`CrossProduct`Cross[{1, 2, 3}, {1, 2, 4}]
:[font = input; preserveAspect; nowordwrap; ]
Remove[Global`Cross]
:[font = input; preserveAspect; nowordwrap; ]
Cross[{1, 2, 3}, {1, 2, 4}]
:[font = input; preserveAspect; nowordwrap; ]
DeclarePackage["Miscellaneous`Units`",
  {"SI", "Convert", "ConvertTemperature"}]
:[font = input; preserveAspect; nowordwrap; ]
SI[Inch]
:[font = input; preserveAspect; nowordwrap; ]
DeclarePackage["Calculus`FourierTransform`",
  {"FourierTransform"}]
:[font = input; preserveAspect; endGroup; nowordwrap; ]
Attributes["FourierTransform"]
:[font = subsubsection; inactive; preserveAspect; ]
A Prototype for Packages
:[font = subsubsection; inactive; preserveAspect; ]
How Contexts are Handled by Packages
:[font = subsubsection; inactive; preserveAspect; ]
Packages which Use other Packages
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Protecting Functions, Changing Protected Functions
:[font = input; preserveAspect; nowordwrap; ]
reallyProtected = Unprotect[Sin]
:[font = input; preserveAspect; nowordwrap; ]
Protect[reallyProtected]
:[font = input; preserveAspect; nowordwrap; ]
Protect[Evaluate[reallyProtected]]
:[font = input; preserveAspect; endGroup; nowordwrap; ]
Unprotect[reallyProtected]
:[font = subsubsection; inactive; preserveAspect; ]
Formatting Packages
:[font = subsubsection; inactive; preserveAspect; endGroup; endGroup; ]
About the Choice of Names in Packages
^*)