(*^

::[	frontEndVersion = "Microsoft Windows Mathematica Notebook Front End Version 2.2";
	microsoftWindowsStandardFontEncoding;
	fontset = title, "Times New Roman", 24, L0, center, nohscroll, bold;
	fontset = subtitle, "Times New Roman", 18, L0, center, nohscroll, bold;
	fontset = subsubtitle, "Times New Roman", 14, L0, center, nohscroll, bold;
	fontset = section, "Times New Roman", 14, L0, bold, grayBox;
	fontset = subsection, "Times New Roman", 12, L0, bold, blackBox;
	fontset = subsubsection, "Times New Roman", 10, L0, bold, whiteBox;
	fontset = text, "Times New Roman", 12, L0;
	fontset = smalltext, "Times New Roman", 10, L0;
	fontset = input, "Courier New", 12, L0, nowordwrap, bold;
	fontset = output, "Courier New", 12, L0, nowordwrap;
	fontset = message, "Courier New", 10, L0, nowordwrap, R65535;
	fontset = print, "Courier New", 10, L0, nowordwrap;
	fontset = info, "Courier New", 10, L0, nowordwrap;
	fontset = postscript, "Courier New", 8, L0, nowordwrap;
	fontset = name, "Times New Roman", 10, L0, nohscroll, italic, B65535;
	fontset = header, "Times New Roman", 10, L0, right, nohscroll;
	fontset = footer, "Times New Roman", 10, L0, right, nohscroll;
	fontset = help, "Times New Roman", 10, L0, nohscroll;
	fontset = clipboard, "Times New Roman", 12, L0, nohscroll;
	fontset = completions, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = graphics, "Courier New", 10, L0, nowordwrap, nohscroll;
	fontset = special1, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = special2, "Times New Roman", 12, L0, center, nowordwrap, nohscroll;
	fontset = special3, "Times New Roman", 12, L0, right, nowordwrap, nohscroll;
	fontset = special4, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = special5, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = leftheader, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = leftfooter, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = reserved1, "Courier New", 10, L0, nowordwrap, nohscroll;]
:[font = section; inactive; preserveAspect; startGroup; ]
2.6 Strings, Text, Messages
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
2.6.1 Printing Text
:[font = input; preserveAspect; endGroup; nowordwrap; ]
Print[a, "   ", b]; Print[c];
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
2.6.2 Arranging Text
:[font = input; preserveAspect; nowordwrap; ]
myText = "This is text"
:[font = input; preserveAspect; nowordwrap; ]
StringForm["aaa``ccc``eee ``", "b", "d", N[Pi]]
:[font = input; preserveAspect; nowordwrap; ]
StringForm["aaa`1`ccc`2`eee`1`ccc", "b", "d"]
:[font = input; preserveAspect; nowordwrap; ]
SequenceForm["a[", i, "]"] /. {i -> 5, a -> 1}
:[font = input; preserveAspect; nowordwrap; ]
FullForm[%]
:[font = input; preserveAspect; endGroup; nowordwrap; ]
Sin[N[10^100, 105]] (* try this on a calculator *)
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
2.6.3 Built-in Formats
:[font = input; preserveAspect; nowordwrap; ]
expr = Expand[(a+b)^2]
:[font = input; preserveAspect; nowordwrap; ]
InputForm[expr]
:[font = input; preserveAspect; nowordwrap; ]
CForm[expr]
:[font = input; preserveAspect; nowordwrap; ]
FortranForm[expr]
:[font = input; preserveAspect; nowordwrap; ]
TeXForm[expr]
:[font = input; preserveAspect; nowordwrap; ]
%^2
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
A Possible Problem
:[font = input; preserveAspect; nowordwrap; ]
p = FortranForm[(1.2 + x)^2]
:[font = input; preserveAspect; nowordwrap; ]
Expand[p]
:[font = input; preserveAspect; nowordwrap; ]
FullForm[p]
:[font = input; preserveAspect; nowordwrap; ]
FortranForm[q = (1.2 + x)^2]
:[font = input; preserveAspect; endGroup; endGroup; nowordwrap; ]
Expand[q]
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
2.6.4 Formats for Numbers
:[font = input; preserveAspect; nowordwrap; ]
ScientificForm[E^10.]
:[font = input; preserveAspect; nowordwrap; ]
EngineeringForm[%]
:[font = input; preserveAspect; nowordwrap; ]
NumberForm[%, {15, 10}]
:[font = input; preserveAspect; nowordwrap; ]
PaddedForm[%, {15, 10},
  NumberPoint -> ",",
  DigitBlock -> 3,
  NumberSeparator -> {"'", ""}]
:[font = input; preserveAspect; endGroup; nowordwrap; ]
BaseForm[%, 2]
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
2.6.5 Subscripts and Superscripts
:[font = input; preserveAspect; nowordwrap; ]
Subscripted[x[a, b, c]]
:[font = input; preserveAspect; nowordwrap; ]
Subscripted[x[a, b, c], 2]
:[font = input; preserveAspect; nowordwrap; ]
Subscripted[x[a, b, c], {1, 1}, {2, 3}]
:[font = input; preserveAspect; nowordwrap; ]
SequenceForm[
  "<<< f[a", Subscript[s], " x, b",
  Superscript[e], "] >>>"]
:[font = input; preserveAspect; nowordwrap; ]
expr = D[s[x, y, z], {x, 2}] + D[s[x, y, z], y]
:[font = input; preserveAspect; nowordwrap; ]
FullForm[%]
:[font = input; preserveAspect; nowordwrap; ]
pdeForm[e_] := e /.
  Derivative[n__][f_][x__] :>
    SequenceForm[f, Subscript[","], Subscript @@
       Flatten[Table[#[[1]], {#[[2]]}]& /@
         Transpose[{{x}, {n}}]]]
:[font = input; preserveAspect; nowordwrap; ]
pdeForm[expr]
:[font = input; preserveAspect; nowordwrap; ]
equOfCont =
  Plus @@ (D[t[x, #][x, y, z], #]& /@ {x, y, z}) +
    f[x] == 0
:[font = input; preserveAspect; nowordwrap; ]
pdeForm[e_, indexed_List] := e /.
  {Derivative[n__][f_?(MemberQ[indexed, #]&)[i__]][x__]
       :> SequenceForm[f, Subscript[i], Subscript[","],
     Subscript @@ Flatten[Table[#[[1]], {#[[2]]}]& /@
       Transpose[{{x}, {n}}]]],
   Derivative[n__][f_][x__] :>
     SequenceForm[f, Subscript[","], Subscript @@
       Flatten[Table[#[[1]], {#[[2]]}]& /@
         Transpose[{{x}, {n}}]]],
   f_?(MemberQ[indexed, #]&)[i__] ->
     SequenceForm[f, Subscript[i]],
   f_?(MemberQ[indexed, #]&)[i__][___] ->
     SequenceForm[f, Subscript[i]]}
:[font = input; preserveAspect; nowordwrap; ]
pdeForm[equOfCont, {t, f}]
:[font = input; preserveAspect; nowordwrap; ]
FullForm[%]
:[font = input; preserveAspect; endGroup; nowordwrap; ]
Prefix[myOperator[x], "!!="]
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
2.6.6 Custom Formats
:[font = input; preserveAspect; nowordwrap; ]
Format[myIntegrate[x_, t_Symbol]] :=
  SequenceForm["S ", x, " d", t]
:[font = input; preserveAspect; nowordwrap; ]
myIntegrate[x^2, x]
:[font = input; preserveAspect; nowordwrap; ]
Format[myIntegrate[x_, t_Symbol], TeXForm] :=
  SequenceForm["\int d", t, "\,", x]
:[font = input; preserveAspect; nowordwrap; ]
TeXForm[myIntegrate[f[t^2], t]]
:[font = input; preserveAspect; nowordwrap; ]
TeXForm[Integrate[f[t^2], t]]
:[font = input; preserveAspect; nowordwrap; ]
Format[PDEForm[e_, ___], PDEForm] := e
:[font = input; preserveAspect; nowordwrap; ]
Format[PDEForm[e_], OutputForm] := e /.
  Derivative[n__][f_][x__] :>
    SequenceForm[f, Subscript[","], Subscript @@
      Flatten[Table[#[[1]], {#[[2]]}]& /@
        Transpose[{{x}, {n}}]]]
:[font = input; preserveAspect; nowordwrap; ]
Format[PDEForm[e_, indexed_List], OutputForm] := e /.
  {Derivative[n__][f_?(MemberQ[indexed, #]&)[i__]][x__]
       :> SequenceForm[f, Subscript[i], Subscript[","],
     Subscript @@ Flatten[Table[#[[1]], {#[[2]]}]& /@
       Transpose[{{x}, {n}}]]],
   Derivative[n__][f_][x__] :>
     SequenceForm[f, Subscript[","], Subscript @@
       Flatten[Table[#[[1]], {#[[2]]}]& /@
         Transpose[{{x}, {n}}]]],
   f_?(MemberQ[indexed, #]&)[i__] ->
     SequenceForm[f, Subscript[i]],
   f_?(MemberQ[indexed, #]&)[i__][___] ->
     SequenceForm[f, Subscript[i]]}
:[font = input; preserveAspect; nowordwrap; ]
expr = D[s[x, y, z], {x, 2}] + D[s[x, y, z], y]
:[font = input; preserveAspect; nowordwrap; ]
PDEForm[expr]
:[font = input; preserveAspect; endGroup; nowordwrap; ]
FullForm[%]
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
2.6.7 Strings
:[font = input; preserveAspect; nowordwrap; ]
ToCharacterCode["text"]
:[font = input; preserveAspect; nowordwrap; ]
FromCharacterCode[%]
:[font = input; preserveAspect; nowordwrap; ]
Characters["text"]
:[font = input; preserveAspect; nowordwrap; ]
Print["text\nmore text on a new line"]
:[font = input; preserveAspect; nowordwrap; ]
StringInsert["abde", "c", 3]
:[font = input; preserveAspect; nowordwrap; ]
ToString[Sin[x]]
:[font = input; preserveAspect; nowordwrap; ]
Head[%]
:[font = input; preserveAspect; nowordwrap; ]
ToExpression["Expand[(a + b)^2]"]
:[font = input; preserveAspect; endGroup; nowordwrap; ]
StringMatchQ["aabcc", "a*c"]
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
2.6.8 Messages
:[font = input; preserveAspect; nowordwrap; ]
1/0
:[font = input; preserveAspect; nowordwrap; ]
Off[Power::infy]
:[font = input; preserveAspect; nowordwrap; ]
1/0
:[font = input; preserveAspect; nowordwrap; ]
On[Power::infy]
:[font = input; preserveAspect; nowordwrap; ]
ndiv::infy = "Infinite expression encountered.";
:[font = input; preserveAspect; nowordwrap; ]
ndiv[a_, b_] := 
  If[b == 0, 
    Message[ndiv::infy]; Infinity,
    N[a/b]
  ]
:[font = input; preserveAspect; nowordwrap; ]
ndiv[1, 0]
:[font = input; preserveAspect; nowordwrap; ]
ndiv::infy =
"Infinite expression ndiv[`1`, `2`] encountered.";
:[font = input; preserveAspect; nowordwrap; ]
ndiv[a_, b_] := 
  If[b == 0, 
    Message[ndiv::infy, a, b]; Infinity,
    N[a/b]
  ]
:[font = input; preserveAspect; nowordwrap; ]
ndiv[1, 0]
:[font = input; preserveAspect; nowordwrap; ]
checkForError[a_, b_] := Check[ndiv[a, b], err]
:[font = input; preserveAspect; nowordwrap; ]
checkForError[1, 2]
:[font = input; preserveAspect; nowordwrap; ]
checkForError[1, 0]
:[font = input; preserveAspect; nowordwrap; ]
checkForError[1, 0^0]
:[font = input; preserveAspect; nowordwrap; ]
checkForError[1, 0^0] // Trace
:[font = input; preserveAspect; nowordwrap; ]
Check[Sqrt[a, b], err, Sqrt::argx]
:[font = input; preserveAspect; endGroup; endGroup; nowordwrap; ]
Check[1/0, err, Sqrt::argx]
^*)