(*^

::[	frontEndVersion = "Microsoft Windows Mathematica Notebook Front End Version 2.2";
	microsoftWindowsStandardFontEncoding;
	fontset = title, "Times New Roman", 24, L0, center, nohscroll, bold;
	fontset = subtitle, "Times New Roman", 18, L0, center, nohscroll, bold;
	fontset = subsubtitle, "Times New Roman", 14, L0, center, nohscroll, bold;
	fontset = section, "Times New Roman", 14, L0, bold, grayBox;
	fontset = subsection, "Times New Roman", 12, L0, bold, blackBox;
	fontset = subsubsection, "Times New Roman", 10, L0, bold, whiteBox;
	fontset = text, "Times New Roman", 12, L0;
	fontset = smalltext, "Times New Roman", 10, L0;
	fontset = input, "Courier New", 12, L0, nowordwrap, bold;
	fontset = output, "Courier New", 12, L0, nowordwrap;
	fontset = message, "Courier New", 10, L0, nowordwrap, R65535;
	fontset = print, "Courier New", 10, L0, nowordwrap;
	fontset = info, "Courier New", 10, L0, nowordwrap;
	fontset = postscript, "Courier New", 8, L0, nowordwrap;
	fontset = name, "Times New Roman", 10, L0, nohscroll, italic, B65535;
	fontset = header, "Times New Roman", 10, L0, right, nohscroll;
	fontset = footer, "Times New Roman", 10, L0, right, nohscroll;
	fontset = help, "Times New Roman", 10, L0, nohscroll;
	fontset = clipboard, "Times New Roman", 12, L0, nohscroll;
	fontset = completions, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = graphics, "Courier New", 10, L0, nowordwrap, nohscroll;
	fontset = special1, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = special2, "Times New Roman", 12, L0, center, nowordwrap, nohscroll;
	fontset = special3, "Times New Roman", 12, L0, right, nowordwrap, nohscroll;
	fontset = special4, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = special5, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = leftheader, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = leftfooter, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = reserved1, "Courier New", 10, L0, nowordwrap, nohscroll;]
:[font = section; inactive; preserveAspect; startGroup; ]
3.1 Programming Methodologies
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
3.1.1 Procedural Programming
:[font = input; preserveAspect; nowordwrap; ]
makeList1[num_Integer] :=
  Module[{res = {}, rem = num},
    While[rem != 0, PrependTo[res, Mod[rem, 256]];
      rem = Quotient[rem, 256]];
    res
  ]
:[font = input; preserveAspect; endGroup; nowordwrap; ]
makeList1[111111111111]
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
3.1.2 Recursive Programming
:[font = input; preserveAspect; nowordwrap; ]
makeList2[0] = {};
:[font = input; nowordwrap; ]
makeList2[num_Integer] :=
  Append[makeList2[Quotient[num, 256]], Mod[num, 256]]
:[font = input; preserveAspect; nowordwrap; ]
makeList2[111111111111]
:[font = input; preserveAspect; nowordwrap; ]
makeList1[10^100] // Timing
:[font = input; preserveAspect; nowordwrap; ]
makeList2[10^100] // Timing
:[font = input; nowordwrap; ]
fib1[0] = 1; fib1[1] = 1;
:[font = input; nowordwrap; ]
fib1[n_] := fib1[n-1] + fib1[n-2]
:[font = input; nowordwrap; ]
Timing[fib1[16]]
:[font = input; nowordwrap; ]
fib2[0] = 1; fib2[1] = 1;
:[font = input; nowordwrap; ]
fib2[n_] := fib2[n] = fib2[n-1] + fib2[n-2]
:[font = input; nowordwrap; ]
Timing[fib2[16]]
:[font = input; nowordwrap; ]
Timing[fib2[200]]
:[font = input; preserveAspect; nowordwrap; ]
$RecursionLimit = 1000
:[font = input; nowordwrap; ]
Clear[fib2]; fib2[0] = 1; fib2[1] = 1;
:[font = input; nowordwrap; ]
fib2[n_] := fib2[n] = fib2[n-1] + fib2[n-2]
:[font = input; nowordwrap; ]
Timing[fib2[200]]
:[font = input; nowordwrap; ]
fib3[0] = 1; fib3[1] = 1;
:[font = input; nowordwrap; ]
fib3[n_] :=
  Module[{i, fn = 1, fn1 = 1, fn2},
    Do[fn2 = fn1; fn1 = fn; fn = fn1 + fn2, {i, 2, n}];
    fn
  ]
:[font = input; nowordwrap; ]
Timing[fib3[200]]
:[font = input; nowordwrap; ]
fib4[0] = 1; fib4[1] = 1;
:[font = input; nowordwrap; ]
fib4[n_] :=
  Module[{fn1 = 1, fn2 = 1},
    Do[{fn1, fn2} = {fn1 + fn2, fn1}, {n - 1}];
    fn1
  ]
:[font = input; endGroup; nowordwrap; ]
Timing[fib4[200]]
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
3.1.3 Functional Programming
:[font = input; preserveAspect; nowordwrap; ]
N[Sum[1/i!, {i, 0, 10}]]
:[font = input; preserveAspect; nowordwrap; ]
r = 1;
:[font = input; preserveAspect; nowordwrap; ]
For[i = 1, i <= 10, i++, 
  For[j = 1; s = 1, j <= i, j++, s *= j]; r += 1/s]; 
:[font = input; preserveAspect; nowordwrap; ]
N[r]
:[font = input; preserveAspect; nowordwrap; ]
FixedPoint[1/2(# + 3/#)&, 1.]
:[font = input; preserveAspect; nowordwrap; ]
x = 1.; xx = 2.;
:[font = input; preserveAspect; endGroup; nowordwrap; ]
While[!Equal[x, xx], xx = x; x = 1/2(x + 3/x)]; x
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
3.1.4 Rule-Based Programming
:[font = input; preserveAspect; nowordwrap; ]
laplace[c_, t_, s_] := c/s /; FreeQ[c, t]
:[font = input; preserveAspect; nowordwrap; ]
laplace[a_ + b_, t_, s_] :=
  laplace[a, t, s] + laplace[b, t, s]
:[font = input; preserveAspect; nowordwrap; ]
laplace[c_ a_, t_, s_] := c laplace[a, t, s] /; 
  FreeQ[c, t]
:[font = input; preserveAspect; nowordwrap; ]
laplace[t_^n_., t_, s_] := n!/s^(n+1) /; 
  FreeQ[n, t] && n > 0
:[font = input; preserveAspect; nowordwrap; ]
laplace[a_ t_^n_., t_, s_] :=
  (-1)^n D[laplace[a, t, s], {s, n}] /;
    FreeQ[n, t] && n > 0
:[font = input; preserveAspect; nowordwrap; ]
laplace[a_/t_, t_, s_] :=
  Module[{tt},
    Integrate[laplace[a, t, tt], {tt, s, Infinity}]
  ]
:[font = input; preserveAspect; nowordwrap; ]
laplace[a_. Exp[b_. + c_. t_], t_, s_] :=
  laplace[a Exp[b], t, s - c] /; FreeQ[{b, c}, t]
:[font = input; preserveAspect; nowordwrap; ]
laplace[t^3 Exp[-3t], t, s]
:[font = input; preserveAspect; nowordwrap; ]
<<Calculus`LaplaceTransform`
:[font = input; preserveAspect; endGroup; nowordwrap; ]
LaplaceTransform[t^3 Exp[-3t], t, s]
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
3.1.5 Programming with Constraint-Propagation
:[font = input; preserveAspect; nowordwrap; ]
eqns =
  { x == x0 + v0 Cos[a] t,
    y == y0 + v0 Sin[a] t - g t^2/2,
    z == z0 };
:[font = input; preserveAspect; nowordwrap; ]
Solve[eqns, y, t]
:[font = input; preserveAspect; nowordwrap; ]
Solve[eqns /. {x -> 1, y -> 1, z -> 0, t -> 1},
  {x0, y0, z0}]
:[font = input; preserveAspect; nowordwrap; ]
parabola = Solve[eqns /.
  {x0 -> 0, y0 -> 1, z0 -> 0, v0 -> 1}, y, t]
:[font = input; preserveAspect; nowordwrap; ]
yZero = Solve[y == 0 /. parabola[[1]], x] // Simplify
:[font = input; preserveAspect; nowordwrap; ]
g = 9.81
:[font = input; preserveAspect; nowordwrap; ]
Needs["Graphics`Graphics`"]
:[font = input; preserveAspect; nowordwrap; ]
Plot[Evaluate[x /. yZero], {a, 0, Pi/2},
  Ticks -> {PiScale, Automatic}]
:[font = input; preserveAspect; nowordwrap; ]
Select[x /. yZero, Positive[# /. a -> 0]&]
:[font = input; preserveAspect; endGroup; nowordwrap; ]
FindMinimum[-%[[1]], {a, 1}]
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
3.1.6 Data Types, Object-Oriented Programming
:[font = input; preserveAspect; nowordwrap; ]
name /: Format[name[f_String, l_String]] :=
  SequenceForm[f, " ", l]
:[font = input; preserveAspect; nowordwrap; ]
name["Stephen", "Wolfram"]
:[font = input; preserveAspect; nowordwrap; ]
Equal[name[f1_String, l1_String], 
  name[f2_String, l2_String]] ^:= f1 == f2 && l1 == l2
:[font = input; preserveAspect; nowordwrap; ]
Equal[name["Stephen", "Wolfram"],
      name["Stephen", "Wolfram"]]
:[font = input; preserveAspect; nowordwrap; ]
Equal[name["Stephen", "Clinton"],
      name["Stephen", "Wolfram"]]
:[font = input; preserveAspect; nowordwrap; ]
nameSort[x:{name[_String, _String]..}] :=
  Sort[x, OrderedQ[
      { StringJoin[#1[[2]], #1[[1]]],
        StringJoin[#2[[2]], #2[[1]]] }]&]
:[font = input; preserveAspect; nowordwrap; ]
nameList = 
  { name["Stephen", "Wolfram"],
    name["Stephen", "Clinton"],
    name["Bill", "Wolfram"],
    name["Bill", "Clinton"] };
:[font = input; preserveAspect; endGroup; endGroup; nowordwrap; ]
nameSort[nameList]
^*)