(*^

::[	frontEndVersion = "Microsoft Windows Mathematica Notebook Front End Version 2.2";
	microsoftWindowsStandardFontEncoding;
	fontset = title, "Times New Roman", 24, L0, center, nohscroll, bold;
	fontset = subtitle, "Times New Roman", 18, L0, center, nohscroll, bold;
	fontset = subsubtitle, "Times New Roman", 14, L0, center, nohscroll, bold;
	fontset = section, "Times New Roman", 14, L0, bold, grayBox;
	fontset = subsection, "Times New Roman", 12, L0, bold, blackBox;
	fontset = subsubsection, "Times New Roman", 10, L0, bold, whiteBox;
	fontset = text, "Times New Roman", 12, L0;
	fontset = smalltext, "Times New Roman", 10, L0;
	fontset = input, "Courier New", 12, L0, nowordwrap, bold;
	fontset = output, "Courier New", 12, L0, nowordwrap;
	fontset = message, "Courier New", 10, L0, nowordwrap, R65535;
	fontset = print, "Courier New", 10, L0, nowordwrap;
	fontset = info, "Courier New", 10, L0, nowordwrap;
	fontset = postscript, "Courier New", 8, L0, nowordwrap;
	fontset = name, "Times New Roman", 10, L0, nohscroll, italic, B65535;
	fontset = header, "Times New Roman", 10, L0, right, nohscroll;
	fontset = footer, "Times New Roman", 10, L0, right, nohscroll;
	fontset = help, "Times New Roman", 10, L0, nohscroll;
	fontset = clipboard, "Times New Roman", 12, L0, nohscroll;
	fontset = completions, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = graphics, "Courier New", 10, L0, nowordwrap, nohscroll;
	fontset = special1, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = special2, "Times New Roman", 12, L0, center, nowordwrap, nohscroll;
	fontset = special3, "Times New Roman", 12, L0, right, nowordwrap, nohscroll;
	fontset = special4, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = special5, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = leftheader, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = leftfooter, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = reserved1, "Courier New", 10, L0, nowordwrap, nohscroll;]
:[font = section; inactive; startGroup; ]
3.3 Numerics
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
3.3.1 Compiling Expressions: Fractals
:[font = input; nowordwrap; ]
f[z_] = z^5 - 1
:[font = input; preserveAspect; nowordwrap; ]
fp[z_] = D[f[z], z]
:[font = input; preserveAspect; nowordwrap; ]
f1 = Function[{z}, z - f[z]/fp[z]]
:[font = input; preserveAspect; nowordwrap; ]
FixedPoint[f1, 2.]
:[font = input; preserveAspect; nowordwrap; ]
f2 = Function[{z}, Evaluate[z - f[z]/fp[z]]]
:[font = input; preserveAspect; nowordwrap; ]
FixedPoint[f2, 2.]
:[font = input; preserveAspect; nowordwrap; ]
Do[FixedPoint[f1, 2.], {100}] // Timing
:[font = input; preserveAspect; nowordwrap; ]
Do[FixedPoint[f2, 2.], {100}] // Timing
:[font = input; preserveAspect; nowordwrap; ]
c1 = Compile[{z}, Evaluate[z - f[z]/fp[z]]]
:[font = input; preserveAspect; nowordwrap; ]
FixedPoint[c1, 2.]
:[font = input; preserveAspect; nowordwrap; ]
Do[FixedPoint[c1, 2.], {100}] // Timing
:[font = input; preserveAspect; nowordwrap; ]
n = Exponent[f[x], x]
:[font = input; preserveAspect; nowordwrap; ]
c1[1. + I]
:[font = input; preserveAspect; nowordwrap; ]
c2 = Compile[{{z, _Complex}}, Evaluate[z - f[z]/fp[z]]]
:[font = input; preserveAspect; nowordwrap; ]
c2[1. + I]
:[font = input; preserveAspect; nowordwrap; ]
Do[FixedPoint[c2, 2.], {100}] // Timing
:[font = input; preserveAspect; nowordwrap; ]
c2[0.]
:[font = input; preserveAspect; nowordwrap; ]
c3 = Compile[{{z, _Complex}},
  Which[
    Abs[z] < 10.^-10, 10.^20,
    Abs[z] >= 10.^10, 10.^20,
    True, Evaluate[z - f[z]/fp[z]]]]
:[font = input; preserveAspect; nowordwrap; ]
comp = With[{expr = z - f[z]/fp[z]},
  Compile[{{z, _Complex}},
    Which[
      Abs[z] < 10.^-10, 10.^20,
      Abs[z] >= 10.^10, 10.^20,
      True, expr]]]
:[font = input; preserveAspect; nowordwrap; ]
Do[FixedPoint[comp, 2.], {100}] // Timing
:[font = input; nowordwrap; ]
findColorOfPoint[e_, max_] :=
  If[Abs[e] >= 10^10, Hue[1, 0, 0],
    Hue[Round[N[Arg[e] max/(2 Pi)]]/N[max]]]
:[font = input; nowordwrap; ]
generateTable[comp_,
    {left_, right_, horStep_},
    {bottom_, top_, vertStep_},
    max_] :=
  Table[
    findColorOfPoint[FixedPoint[comp, N[x + I y]], max],
    {y, bottom, top, vertStep}, 
    {x, left, right, horStep}]
:[font = input; nowordwrap; ]
points = generateTable[comp,
  {-1., 1., .05}, {-1., 1., .05}, n];
:[font = input; nowordwrap; ]
Show[Graphics[RasterArray[points]],
  AspectRatio -> Automatic]
:[font = input; preserveAspect; nowordwrap; ]
showFractal[exponent_Integer?(#>1&),
    {left_, right_, horStep_},
    {bottom_, top_, vertStep_}] :=
  Module[{z, f, fp, comp, findColor},
    f = z^exponent - 1;
    fp = D[f, z];
    comp = With[{expr = z - f/fp},
      Compile[{{z, _Complex}},
        Which[
          Abs[z] < 10.^-10, 10.^20,
          Abs[z] >= 10.^10, 10.^20,
          True, expr]]];
    findColor[e_] := If[Abs[e] >= 10^10, Hue[1, 0, 0],
       Hue[Round[N[Arg[e] exponent/(2 Pi)]]/N[exponent]]];
    Show[
      Graphics[RasterArray[Table[
            findColor[FixedPoint[comp, x + I y]],
          {y, bottom, top, vertStep}, 
          {x, left, right, horStep}]]],
        AspectRatio -> Automatic]]
:[font = input; preserveAspect; nowordwrap; ]
showFractal[6, {-.2, .2, .01}, {.7, .9, .005}]
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
A Possible Problem
:[font = input; preserveAspect; nowordwrap; ]
c = Compile[{x, y}, {x^2 + y^2, ArcTan[y/x]}]
:[font = input; preserveAspect; nowordwrap; ]
c = Compile[{x, y}, #]& /@ {x^2 + y^2, ArcTan[y/x]}
:[font = input; preserveAspect; endGroup; endGroup; nowordwrap; ]
Through[c[1, 1]]
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
3.3.2 Precision and Accuracy
:[font = input; preserveAspect; nowordwrap; ]
{Precision[3.], Precision[N[Pi]]}
:[font = input; preserveAspect; nowordwrap; ]
{Precision[3.00000000000000000000000000000],
 Precision[N[Pi, 25]]}
:[font = input; preserveAspect; nowordwrap; ]
N[Sqrt[3.0], 30]
:[font = input; preserveAspect; nowordwrap; ]
Precision[%]
:[font = input; preserveAspect; nowordwrap; ]
r = 3.2;
:[font = input; preserveAspect; nowordwrap; ]
r = SetPrecision[r, 30];
:[font = input; preserveAspect; nowordwrap; ]
Precision[r]
:[font = input; preserveAspect; nowordwrap; ]
N[r, 30]
:[font = input; preserveAspect; nowordwrap; ]
r - 3.200000000000000000000001
:[font = input; preserveAspect; nowordwrap; ]
Precision[%]
:[font = input; preserveAspect; endGroup; nowordwrap; ]
Accuracy[%%]
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
3.3.3 Controlling Numerical Built-in Functions
:[font = input; preserveAspect; nowordwrap; ]
i1 = NIntegrate[Sin[1/x], {x, .004, 1}]
:[font = input; preserveAspect; nowordwrap; ]
i2 = NIntegrate[Sin[1/x], {x, .004, 1},
  MaxRecursion -> 20]
:[font = input; preserveAspect; nowordwrap; ]
i3 = NIntegrate[Sin[1/x], {x, .004, 1},
  MaxRecursion -> 20, WorkingPrecision -> 30]
:[font = input; preserveAspect; nowordwrap; ]
{i1 - i2, i2 - i3}
:[font = input; preserveAspect; nowordwrap; ]
Through[{Precision, Accuracy}[i3]]
:[font = input; preserveAspect; nowordwrap; ]
res = Integrate[Sin[1/x], {x, 4/1000, 1}]
:[font = input; preserveAspect; endGroup; endGroup; nowordwrap; ]
N[res - i3, 21]
^*)