(*^

::[	frontEndVersion = "Microsoft Windows Mathematica Notebook Front End Version 2.2";
	microsoftWindowsStandardFontEncoding;
	fontset = title, "Times New Roman", 24, L0, center, nohscroll, bold;
	fontset = subtitle, "Times New Roman", 18, L0, center, nohscroll, bold;
	fontset = subsubtitle, "Times New Roman", 14, L0, center, nohscroll, bold;
	fontset = section, "Times New Roman", 14, L0, bold, grayBox;
	fontset = subsection, "Times New Roman", 12, L0, bold, blackBox;
	fontset = subsubsection, "Times New Roman", 10, L0, bold, whiteBox;
	fontset = text, "Times New Roman", 12, L0;
	fontset = smalltext, "Times New Roman", 10, L0;
	fontset = input, "Courier New", 12, L0, nowordwrap, bold;
	fontset = output, "Courier New", 12, L0, nowordwrap;
	fontset = message, "Courier New", 10, L0, nowordwrap, R65535;
	fontset = print, "Courier New", 10, L0, nowordwrap;
	fontset = info, "Courier New", 10, L0, nowordwrap;
	fontset = postscript, "Courier New", 8, L0, nowordwrap;
	fontset = name, "Times New Roman", 10, L0, nohscroll, italic, B65535;
	fontset = header, "Times New Roman", 10, L0, right, nohscroll;
	fontset = footer, "Times New Roman", 10, L0, right, nohscroll;
	fontset = help, "Times New Roman", 10, L0, nohscroll;
	fontset = clipboard, "Times New Roman", 12, L0, nohscroll;
	fontset = completions, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = graphics, "Courier New", 10, L0, nowordwrap, nohscroll;
	fontset = special1, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = special2, "Times New Roman", 12, L0, center, nowordwrap, nohscroll;
	fontset = special3, "Times New Roman", 12, L0, right, nowordwrap, nohscroll;
	fontset = special4, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = special5, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = leftheader, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = leftfooter, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = reserved1, "Courier New", 10, L0, nowordwrap, nohscroll;]
:[font = section; inactive; startGroup; ]
3.4 Long Calculations: RSA
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
3.4.1 Primes for RSA
:[font = input; preserveAspect; nowordwrap; ]
GoodRSAPrimeQ[n_, k_] :=
  PrimeQ[n] &&
  Module[{d = 1, m = (n-1)/2},
    While[d <= k && !PrimeQ[m/d], d++];
    d <= k
  ]
:[font = input; preserveAspect; nowordwrap; ]
RSAPrime[digits_Integer] :=
  Module[{k, cand},
    cand = Random[Integer, {10^(digits-1), 10^digits-1}];
    k = 10^Floor[Log[10., cand]/30];
    If[EvenQ[cand], cand++];
    While[!GoodRSAPrimeQ[cand, k], cand += 2];
    cand
  ]
:[font = input; preserveAspect; nowordwrap; ]
smallPrime = RSAPrime[6]
:[font = input; preserveAspect; nowordwrap; ]
PrimeQ[smallPrime]
:[font = input; preserveAspect; nowordwrap; ]
10^Floor[Log[10., smallPrime]/30]
:[font = input; preserveAspect; endGroup; nowordwrap; ]
FactorInteger[(smallPrime-1)/2]
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
3.4.2 Saving Results in a File
:[font = input; preserveAspect; nowordwrap; ]
Needs["SKPackages`RSA`"]
:[font = input; preserveAspect; nowordwrap; ]
generatePrimes1[digits_, max_] :=
  Block[{p},
    Do[p = RSAPrime[digits];
      Save[StringJoin["rsa-primes-", 
        ToString[digits], ".m"], p],
      {i, max}]
  ]
:[font = input; preserveAspect; nowordwrap; ]
generatePrimes1[5, 3]
:[font = input; preserveAspect; nowordwrap; ]
!!rsa-primes-5.m
:[font = input; preserveAspect; nowordwrap; ]
generatePrimes2[digits_, max_] :=
  Block[{p},
    Do[p[i] = RSAPrime[digits];
      Save[StringJoin["rsa-primes-", 
        ToString[digits], ".m"], 
        p],
      {i, max}]
  ]
:[font = input; preserveAspect; nowordwrap; ]
generatePrimes2[6, 3]
:[font = input; preserveAspect; nowordwrap; ]
!!rsa-primes-6.m
:[font = input; preserveAspect; nowordwrap; ]
generatePrimes[digits_, max_] :=
  Module[{t, p},
    Do[
      p = RSAPrime[digits];
      t = OpenAppend[StringJoin[
        "rsa-primes-",ToString[digits],
        ".m"]];
      WriteString[t, "p[", ToString[i], "] = "];
      Write[t, p];
      Close[t],
      {i, max}
    ]
  ]
:[font = input; preserveAspect; nowordwrap; ]
generatePrimes[7, 3]
:[font = input; preserveAspect; nowordwrap; ]
!!rsa-primes-7.m
:[font = input; preserveAspect; nowordwrap; ]
<<rsa-primes-7.m;
:[font = input; preserveAspect; endGroup; nowordwrap; ]
?p
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
3.4.3 External Programs, Calculations in the Background
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Batch Jobs
:[font = input; preserveAspect; nowordwrap; ]
TextForm["Needs[\"SKPackages`RSA`\"]\n"] >>
  "rsa-primes-100.control"
:[font = input; preserveAspect; nowordwrap; ]
Definition[generatePrimes] >>>
  "rsa-primes-100.control"
:[font = input; preserveAspect; nowordwrap; ]
TextForm["\ngeneratePrimes[100, 100]"] >>>
  "rsa-primes-100.control"
:[font = input; preserveAspect; endGroup; nowordwrap; ]
!!rsa-primes-100.control
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
External Programs
:[font = input; preserveAspect; endGroup; endGroup; endGroup; nowordwrap; ]
Run["nice math < rsa-primes-100.control >
  rsa-primes-100.log &"]
^*)