(*^

::[	frontEndVersion = "Microsoft Windows Mathematica Notebook Front End Version 2.2";
	microsoftWindowsStandardFontEncoding;
	fontset = title, "Times New Roman", 24, L0, center, nohscroll, bold;
	fontset = subtitle, "Times New Roman", 18, L0, center, nohscroll, bold;
	fontset = subsubtitle, "Times New Roman", 14, L0, center, nohscroll, bold;
	fontset = section, "Times New Roman", 14, L0, bold, grayBox;
	fontset = subsection, "Times New Roman", 12, L0, bold, blackBox;
	fontset = subsubsection, "Times New Roman", 10, L0, bold, whiteBox;
	fontset = text, "Times New Roman", 12, L0;
	fontset = smalltext, "Times New Roman", 10, L0;
	fontset = input, "Courier New", 12, L0, nowordwrap, bold;
	fontset = output, "Courier New", 12, L0, nowordwrap;
	fontset = message, "Courier New", 10, L0, nowordwrap, R65535;
	fontset = print, "Courier New", 10, L0, nowordwrap;
	fontset = info, "Courier New", 10, L0, nowordwrap;
	fontset = postscript, "Courier New", 8, L0, nowordwrap;
	fontset = name, "Times New Roman", 10, L0, nohscroll, italic, B65535;
	fontset = header, "Times New Roman", 10, L0, right, nohscroll;
	fontset = footer, "Times New Roman", 10, L0, right, nohscroll;
	fontset = help, "Times New Roman", 10, L0, nohscroll;
	fontset = clipboard, "Times New Roman", 12, L0, nohscroll;
	fontset = completions, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = graphics, "Courier New", 10, L0, nowordwrap, nohscroll;
	fontset = special1, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = special2, "Times New Roman", 12, L0, center, nowordwrap, nohscroll;
	fontset = special3, "Times New Roman", 12, L0, right, nowordwrap, nohscroll;
	fontset = special4, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = special5, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = leftheader, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = leftfooter, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = reserved1, "Courier New", 10, L0, nowordwrap, nohscroll;]
:[font = section; inactive; preserveAspect; startGroup; ]
Graphics
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
The Cover Picture
:[font = input; preserveAspect; nowordwrap; ]
r1 = 2.5; r2 = 1;
:[font = input; preserveAspect; nowordwrap; ]
<<rotDoublePend.m;
:[font = input; preserveAspect; nowordwrap; ]
FindMinimum[epEff /. {l -> 1, m -> 1, g -> 1, omega -> .5},
  {phi1, -2}, {phi2, -2}]
:[font = input; preserveAspect; nowordwrap; ]
FindMinimum[-epEff /. {l -> 1, m -> 1, g -> 1, omega -> .5},
  {phi1, Pi}, {phi2, Pi}]
:[font = input; preserveAspect; nowordwrap; ]
pot = ParametricPlot3D[
  Evaluate[
    {
      Cos[phi1](r1 + r2 Cos[phi2]),
      Sin[phi1](r1 + r2 Cos[phi2]),
      r2 Sin[phi2],
      Hue[(epEff + 2)/4]
    } /. {l -> 1, m -> 1, g -> 1, omega -> .5}
  ],
  {phi1, 0, 2Pi}, {phi2, 0, 2Pi},
  Lighting -> False, PlotPoints -> {60, 30},
  Boxed -> False, Axes -> False
]
:[font = input; preserveAspect; nowordwrap; ]
potAlone = Show[Graphics3D[{EdgeForm[], pot[[1]]}],
  Boxed -> False, Lighting -> False]
:[font = input; preserveAspect; nowordwrap; ]
epT = epEff /. {phi1 -> phi1[t], phi2 -> phi2[t]};
:[font = input; nowordwrap; ]
ek1 = (1/2) (m l^2 / 3) phi1'[t]^2;
:[font = input; nowordwrap; ]
ek2 = (m l^2/2) *
       ((phi2'[t]^2/12) + 
        (phi1'[t] Cos[phi1[t]] + phi2'[t] Cos[phi2[t]]/2)^2 + 
        (phi1'[t] Sin[phi1[t]] + phi2'[t] Sin[phi2[t]]/2)^2
       );
:[font = input; nowordwrap; ]
ek = ek1 + ek2;
:[font = input; nowordwrap; ]
lag = ek - epT;
:[font = input; nowordwrap; ]
lagEquations =
  { 
    D[D[lag, phi1'[t]], t] - D[lag, phi1[t]] == 0, 
    D[D[lag, phi2'[t]], t] - D[lag, phi2[t]] == 0
  };
:[font = input; preserveAspect; nowordwrap; ]
angles = {phi1[t], phi2[t]};
:[font = input; preserveAspect; nowordwrap; ]
initials =
  {phi1[0] == 0, phi2[0] == 0,
   phi1'[0] == 0, phi2'[0] == 5};
:[font = input; preserveAspect; nowordwrap; ]
valueRule = {m -> 1, g -> 1, l -> 1, omega -> 0.5};
:[font = input; preserveAspect; nowordwrap; ]
lagEquInits = Flatten[{lagEquations, initials}] /.
  valueRule;
:[font = input; preserveAspect; nowordwrap; ]
lagSolRule = NDSolve[lagEquInits, angles, {t, 0, 10},
  MaxSteps -> 2000];
:[font = input; preserveAspect; nowordwrap; ]
phi1 = (phi1[t] /. lagSolRule[[1]]);
:[font = input; preserveAspect; nowordwrap; ]
phi2 = (phi2[t] /. lagSolRule[[1]]);
:[font = input; preserveAspect; nowordwrap; ]
sol = ParametricPlot3D[
  {
    Cos[phi1](r1 + (r2 + .05) Cos[phi2]),
    Sin[phi1](r1 + (r2 + .05) Cos[phi2]),
    (r2 + .05) Sin[phi2]
  } // Evaluate,
  {t, 0, 10}, PlotPoints -> 500]
:[font = input; preserveAspect; endGroup; nowordwrap; ]
Show[potAlone, sol, Boxed -> False, Axes -> False,
  Lighting -> False]
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
Part 1.
:[font = input; preserveAspect; endGroup; nowordwrap; ]
ParametricPlot3D[
  { 
    Cos[v] Sin[u],
    Sin[v] Cos[u],
    Cos[u]
  },
  {u, 0, Pi}, {v, 0, 2 Pi},
  ViewPoint -> {3, -1, 1},
  Boxed -> False,
  Axes -> False,
  PlotPoints -> {30, 30}]
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
Part 2.
:[font = input; preserveAspect; endGroup; nowordwrap; ]
ParametricPlot3D[
  {
    r Cos[3u],
    r Sin[3u],
    Sin[u]
  },
  {u, 0, 2Pi}, {r, 0, 1},
  PlotPoints -> {70, 10},
  Boxed -> False,
  Axes -> False]
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
Part 3.
:[font = input; preserveAspect; nowordwrap; ]
Needs["LinearAlgebra`CrossProduct`"]
:[font = input; preserveAspect; nowordwrap; ]
absV[v_?VectorQ] := Sqrt[Plus @@ (v^2)] /; Length[v] == 3
:[font = input; preserveAspect; nowordwrap; ]
surfacePoint[curve_, t_, angle_, scale_] := 
  Module[{tang = D[curve, t], perp1, perp2},
     perp1 = {tang[[2]], -tang[[1]], 0};
     perp2 = Cross[tang, perp1];
     scale (perp1/absV[perp1] Cos[angle] +
       perp2/absV[perp2] Sin[angle])
  ]
:[font = input; nowordwrap; ]
curve = {(1 + .4 Cos[3/2 t]) Cos[t],
         (1 + .4 Cos[3/2 t]) Sin[t], Sin[3/2 t]};
:[font = input; preserveAspect; nowordwrap; ]
p1 = ParametricPlot3D[Evaluate[
  curve + surfacePoint[curve, t, angle, .3]],
  {t, -Pi, 2Pi}, {angle, 0, 2Pi},
  PlotPoints -> {150, 15}, DisplayFunction -> Identity];
:[font = input; preserveAspect; nowordwrap; ]
p2 = ParametricPlot3D[Evaluate[
  curve + surfacePoint[curve, t, 80t, .3]], {t, 2Pi, 3Pi},
  PlotPoints -> 3000, DisplayFunction -> Identity];
:[font = input; preserveAspect; endGroup; endGroup; nowordwrap; ]
Show[Graphics3D[
  {{EdgeForm[AbsoluteThickness[.05]], p1[[1]]},
   {AbsoluteThickness[1], p2[[1]]}}],
   Axes -> False, Boxed -> False,
   ViewPoint -> {1.3, 1.5, 4.5}]
^*)