(*^

::[	frontEndVersion = "Microsoft Windows Mathematica Notebook Front End Version 2.2";
	microsoftWindowsStandardFontEncoding;
	fontset = title, "Times New Roman", 24, L0, center, nohscroll, bold;
	fontset = subtitle, "Times New Roman", 18, L0, center, nohscroll, bold;
	fontset = subsubtitle, "Times New Roman", 14, L0, center, nohscroll, bold;
	fontset = section, "Times New Roman", 14, L0, bold, grayBox;
	fontset = subsection, "Times New Roman", 12, L0, bold, blackBox;
	fontset = subsubsection, "Times New Roman", 10, L0, bold, whiteBox;
	fontset = text, "Times New Roman", 12, L0;
	fontset = smalltext, "Times New Roman", 10, L0;
	fontset = input, "Courier New", 12, L0, nowordwrap, bold;
	fontset = output, "Courier New", 12, L0, nowordwrap;
	fontset = message, "Courier New", 10, L0, nowordwrap, R65535;
	fontset = print, "Courier New", 10, L0, nowordwrap;
	fontset = info, "Courier New", 10, L0, nowordwrap;
	fontset = postscript, "Courier New", 8, L0, nowordwrap;
	fontset = name, "Times New Roman", 10, L0, nohscroll, italic, B65535;
	fontset = header, "Times New Roman", 10, L0, right, nohscroll;
	fontset = footer, "Times New Roman", 10, L0, right, nohscroll;
	fontset = help, "Times New Roman", 10, L0, nohscroll;
	fontset = clipboard, "Times New Roman", 12, L0, nohscroll;
	fontset = completions, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = graphics, "Courier New", 10, L0, nowordwrap, nohscroll;
	fontset = special1, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = special2, "Times New Roman", 12, L0, center, nowordwrap, nohscroll;
	fontset = special3, "Times New Roman", 12, L0, right, nowordwrap, nohscroll;
	fontset = special4, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = special5, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = leftheader, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = leftfooter, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = reserved1, "Courier New", 10, L0, nowordwrap, nohscroll;]
:[font = title; inactive; startGroup; nohscroll; center; ]
AbsArg
:[font = subsubtitle; inactive; nohscroll; center; ]
Stephan Kaufmann
:[font = special2; inactive; nowordwrap; nohscroll; center; ]
The functions Abs und Arg are generalized to work with symbolic expressions.
:[font = subsection; inactive; startGroup; Cclosed; ]
Reference
:[font = subsubsection; inactive; locked; startGroup; Cclosed; ]
Author
:[font = smalltext; inactive; locked; endGroup; ]
Stephan Kaufmann
Institute of Mechanics
Swiss Federal Institute of Technology
ETH Zentrum, HG F38.4 
CH-8092 Zurich
Switzerland
kaufmann@ifm.mavt.ethz.ch
:[font = subsubsection; inactive; locked; startGroup; Cclosed; ]
Copyright Notice
:[font = smalltext; inactive; locked; ]
Copyright  1994 by Stephan Kaufmann
:[font = smalltext; inactive; locked; preserveAspect; endGroup; nohscroll; backColorRed = 65535; backColorGreen = 65535; backColorBlue = 65535; fontColorRed = 0; fontColorGreen = 0; fontColorBlue = 0; plain; fontName = "Times New Roman"; fontSize = 10; ]
Permission is hereby granted to make copies of this file for any purpose other than direct profit,
or as part of a commercial product, provided this copyright notice is left intact. Sale is prohibited.

Permission is hereby granted to reproduce part or all of this file provided that the source is acknowledged.
:[font = subsubsection; inactive; startGroup; Cclosed; ]
Version
:[font = smalltext; inactive; endGroup; ]
Notebook Version 2.2 (E)
:[font = subsubsection; inactive; startGroup; Cclosed; ]
History
:[font = smalltext; inactive; endGroup; ]
Changes in Version 2.2 (August 93):
No changes, but uses improved NonNegativeQ
:[font = subsubsection; inactive; startGroup; Cclosed; ]
Requirements
:[font = smalltext; inactive; preserveAspect; ]
This package is based on SKPackages`NonNegativeQ` and Algebra`ReIm`. These packages must be present.
:[font = smalltext; inactive; ]
Mathematica Version: 2.0 or higher.
:[font = input; initialization; endGroup; endGroup; nowordwrap; ]
*)
If[$VersionNumber < 2.0, Print[
  "This package requires Mathematica version 2.0 or higher."]]
(*
:[font = section; inactive; startGroup; Cclosed; ]
Discussion
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
Background
:[font = text; inactive; preserveAspect; ]
The built in functions Re, Im, Conjugate, Abs and Arg evaluate for numbers only. The package Algebra`ReIm` extends Re, Im and Conjugate to symbols and expressions. This package also extends Abs and Arg.

Mathematica does not know a priori if a symbol stands for a real or a complex number. A real symbol can be defined by:
:[font = input; preserveAspect; nowordwrap; ]
a /: Im[a] = 0;
:[font = text; inactive; preserveAspect; ]
or, equivalently, by:
:[font = input; preserveAspect; nowordwrap; ]
Im[a] ^= 0;
:[font = text; inactive; preserveAspect; ]
Abs and Arg often allow further simplification if information about the positivity of symbols is given. This can be done with the functions Positive, Negative and NonNegative or with NonNegativeQ from the package SKPackages`NonNegativeQ`, e.g.:
:[font = input; preserveAspect; endGroup; nowordwrap; ]
Positive[a] ^= True;
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
Examples
:[font = text; inactive; preserveAspect; ]
We assume x and y to be real:
:[font = input; preserveAspect; nowordwrap; ]
Im[x] ^= 0;
:[font = input; preserveAspect; nowordwrap; ]
Im[y] ^= 0;
:[font = text; inactive; preserveAspect; ]
Now, the following absolute values can be calculated:
:[font = input; preserveAspect; startGroup; Cclosed; nowordwrap; ]
Abs[x]
:[font = output; inactive; formatted; output; preserveAspect; endGroup; nowordwrap; ]
(x^2)^(1/2)





;[o]
      2
Sqrt[x ]
:[font = input; preserveAspect; startGroup; Cclosed; nowordwrap; ]
Abs[x^2]
:[font = output; inactive; formatted; output; preserveAspect; endGroup; nowordwrap; ]
x^2





;[o]
 2
x
:[font = input; preserveAspect; startGroup; Cclosed; nowordwrap; ]
Abs[x + I y]
:[font = output; inactive; formatted; output; preserveAspect; endGroup; nowordwrap; ]
(x^2 + y^2)^(1/2)





;[o]
      2    2
Sqrt[x  + y ]
:[font = input; preserveAspect; startGroup; Cclosed; nowordwrap; ]
Abs[x y]
:[font = output; inactive; formatted; output; preserveAspect; endGroup; nowordwrap; ]
(x^2*y^2)^(1/2)





;[o]
      2  2
Sqrt[x  y ]
:[font = text; inactive; preserveAspect; ]
If nothing else is said, the generic case is chosen, i.e.: the real part is assumed to be unequal to zero:
:[font = input; preserveAspect; startGroup; Cclosed; nowordwrap; ]
Arg[x + I y]
:[font = output; inactive; formatted; output; preserveAspect; endGroup; nowordwrap; ]
ArcTan[y/x]





;[o]
       y
ArcTan[-]
       x
:[font = text; inactive; preserveAspect; ]
In the following example, the result is either 0 or . In such a case, the result will not be evaluated.
:[font = input; preserveAspect; startGroup; Cclosed; nowordwrap; ]
Arg[x/y]
:[font = output; inactive; formatted; output; preserveAspect; endGroup; nowordwrap; ]
Arg[x/y]





;[o]
    x
Arg[-]
    y
:[font = text; inactive; preserveAspect; ]
With assumptions about the positivity or negativity of symbols, we get further simplifications:
:[font = input; preserveAspect; nowordwrap; ]
Positive[x] ^= True;
:[font = input; preserveAspect; nowordwrap; ]
Negative[y] ^= True;
:[font = input; preserveAspect; startGroup; Cclosed; nowordwrap; ]
Abs[x]
:[font = output; inactive; formatted; output; preserveAspect; endGroup; nowordwrap; ]
x





;[o]
x
:[font = input; preserveAspect; startGroup; Cclosed; nowordwrap; ]
Abs[y]
:[font = output; inactive; formatted; output; preserveAspect; endGroup; nowordwrap; ]
-y





;[o]
-y
:[font = input; preserveAspect; startGroup; Cclosed; nowordwrap; ]
Abs[x y]
:[font = output; inactive; formatted; output; preserveAspect; endGroup; nowordwrap; ]
-(x*y)





;[o]
-(x y)
:[font = input; preserveAspect; startGroup; Cclosed; nowordwrap; ]
Arg[x]
:[font = output; inactive; formatted; output; preserveAspect; endGroup; nowordwrap; ]
0





;[o]
0
:[font = input; preserveAspect; startGroup; Cclosed; nowordwrap; ]
Arg[x/y]
:[font = output; inactive; formatted; output; preserveAspect; endGroup; endGroup; endGroup; nowordwrap; ]
Pi





;[o]
Pi
:[font = section; inactive; startGroup; Cclosed; ]
Implementation
:[font = subsection; inactive; startGroup; Cclosed; ]
Preparation
:[font = input; initialization; nowordwrap; ]
*)
BeginPackage["SKPackages`AbsArg`",
  "Algebra`ReIm`", "SKPackages`NonNegativeQ`"];
(*
:[font = input; initialization; nowordwrap; ]
*)
AbsArg::usage = 
"The package AbsArg extends the definitions of Abs and Arg to symbols. Properties of symbols should be given in the form: Re[z] ^= z; Im[z] ^= 0; Positive[z] ^= True, Negative[x] ^= True etc.";
(*
:[font = input; initialization; endGroup; nowordwrap; ]
*)
Begin["`Private`"];
(*
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
Definitions
:[font = input; initialization; nowordwrap; ]
*)
reallyProtected = Unprotect[Abs, Arg];
(*
:[font = input; initialization; nowordwrap; ]
*)
Abs[z_] := Re[z] /; Im[z] == 0 && NonNegativeQ[Re[z]]
(*
:[font = input; initialization; nowordwrap; ]
*)
Abs[z_] := -Re[z] /; Im[z] == 0 && NonNegativeQ[-Re[z]]
(*
:[font = input; initialization; nowordwrap; ]
*)
Abs[z_] := Im[z] /; Re[z] == 0 && NonNegativeQ[Im[z]]
(*
:[font = input; initialization; nowordwrap; ]
*)
Abs[z_] := -Im[z] /; Re[z] == 0 && NonNegativeQ[-Im[z]]
(*
:[font = input; initialization; nowordwrap; ]
*)
Abs[z_] := Sqrt[Re[z]^2 + Im[z]^2]
(*
:[font = input; initialization; nowordwrap; ]
*)
Arg[z_] := 0 /; NonNegativeQ[z]
(*
:[font = input; initialization; nowordwrap; ]
*)
Arg[z_] := Pi /; NonNegativeQ[-z]
(*
:[font = input; initialization; nowordwrap; ]
*)
Arg[z_] := Pi/2 /; Re[z] == 0 && NonNegativeQ[Im[z]]
(*
:[font = input; initialization; nowordwrap; ]
*)
Arg[z_] := -Pi/2 /; Re[z] == 0 && NonNegativeQ[-Im[z]]
(*
:[font = input; initialization; nowordwrap; ]
*)
Arg[z_] := ArcTan[Im[z]/Re[z]] /; Re[z] =!= 0 && Im[z] =!= 0
(*
:[font = input; initialization; endGroup; nowordwrap; ]
*)
Protect[Release[reallyProtected]];
(*
:[font = subsection; inactive; startGroup; Cclosed; ]
Finish
:[font = input; initialization; nowordwrap; ]
*)
End[];
(*
:[font = input; initialization; endGroup; endGroup; endGroup; nowordwrap; ]
*)
EndPackage[];
(*
^*)