(*^

::[	frontEndVersion = "Microsoft Windows Mathematica Notebook Front End Version 2.2";
	microsoftWindowsStandardFontEncoding;
	fontset = title, "Times New Roman", 24, L0, center, nohscroll, bold;
	fontset = subtitle, "Times New Roman", 18, L0, center, nohscroll, bold;
	fontset = subsubtitle, "Times New Roman", 14, L0, center, nohscroll, bold;
	fontset = section, "Times New Roman", 14, L0, bold, grayBox;
	fontset = subsection, "Times New Roman", 12, L0, bold, blackBox;
	fontset = subsubsection, "Times New Roman", 10, L0, bold, whiteBox;
	fontset = text, "Times New Roman", 12, L0;
	fontset = smalltext, "Times New Roman", 10, L0;
	fontset = input, "Courier New", 12, L0, nowordwrap, bold;
	fontset = output, "Courier New", 12, L0, nowordwrap;
	fontset = message, "Courier New", 10, L0, nowordwrap, R65535;
	fontset = print, "Courier New", 10, L0, nowordwrap;
	fontset = info, "Courier New", 10, L0, nowordwrap;
	fontset = postscript, "Courier New", 8, L0, nowordwrap;
	fontset = name, "Times New Roman", 10, L0, nohscroll, italic, B65535;
	fontset = header, "Times New Roman", 10, L0, right, nohscroll;
	fontset = footer, "Times New Roman", 10, L0, right, nohscroll;
	fontset = help, "Times New Roman", 10, L0, nohscroll;
	fontset = clipboard, "Times New Roman", 12, L0, nohscroll;
	fontset = completions, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = graphics, "Courier New", 10, L0, nowordwrap, nohscroll;
	fontset = special1, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = special2, "Times New Roman", 12, L0, center, nowordwrap, nohscroll;
	fontset = special3, "Times New Roman", 12, L0, right, nowordwrap, nohscroll;
	fontset = special4, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = special5, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = leftheader, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = leftfooter, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = reserved1, "Courier New", 10, L0, nowordwrap, nohscroll;]
:[font = title; inactive; startGroup; nohscroll; center; ]
Linearization
:[font = subsubtitle; inactive; nohscroll; center; ]
Stephan Kaufmann
:[font = special1; inactive; nowordwrap; nohscroll; center; backColorRed = 65535; backColorGreen = 65535; backColorBlue = 65535; fontColorRed = 0; fontColorGreen = 0; fontColorBlue = 0; plain; fontName = "Times New Roman"; fontSize = 12; ]
Calculation of the Jacobi matrix and the linearization of functions and equations.
:[font = subsection; inactive; startGroup; Cclosed; ]
Reference
:[font = subsubsection; inactive; locked; startGroup; Cclosed; ]
Author
:[font = smalltext; inactive; locked; endGroup; ]
Stephan Kaufmann
Institute of Mechanics
Swiss Federal Institute of Technology
ETH Zentrum, HG F38.4 
CH-8092 Zurich
Switzerland
kaufmann@ifm.mavt.ethz.ch
:[font = subsubsection; inactive; locked; startGroup; Cclosed; backColorRed = 65535; backColorGreen = 65535; backColorBlue = 65535; fontColorRed = 0; fontColorGreen = 0; fontColorBlue = 0; bold; fontName = "Times New Roman"; fontSize = 10; ]
Copyright Notice
:[font = smalltext; inactive; locked; backColorRed = 65535; backColorGreen = 65535; backColorBlue = 65535; fontColorRed = 0; fontColorGreen = 0; fontColorBlue = 0; plain; fontName = "Times New Roman"; fontSize = 10; ]
Copyright  1994 by Stephan Kaufmann
:[font = smalltext; inactive; locked; preserveAspect; endGroup; nohscroll; backColorRed = 65535; backColorGreen = 65535; backColorBlue = 65535; fontColorRed = 0; fontColorGreen = 0; fontColorBlue = 0; plain; fontName = "Times New Roman"; fontSize = 10; ]
Permission is hereby granted to make copies of this file for any purpose other than direct profit,
or as part of a commercial product, provided this copyright notice is left intact. Sale is prohibited.

Permission is hereby granted to reproduce part or all of this file provided that the source is acknowledged.
:[font = subsubsection; inactive; startGroup; Cclosed; ]
Version
:[font = smalltext; inactive; endGroup; ]
Notebook Version 2.2 (E)
:[font = subsubsection; inactive; startGroup; Cclosed; ]
History
:[font = smalltext; inactive; endGroup; ]
Changes in Version 2.2 (August 93):
- Now returns a single expression when given a single expression
- Works correctly for equations which evaluate to True or False when linearized
:[font = subsubsection; inactive; startGroup; Cclosed; ]
Requirements
:[font = smalltext; inactive; ]
Mathematica Version: 2.0 or higher.
:[font = input; initialization; endGroup; endGroup; nowordwrap; ]
*)
If[$VersionNumber < 2.0, Print[
  "This package requires Mathematica version 2.0 or higher."]]
(*
:[font = section; inactive; startGroup; Cclosed; ]
Discussion
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
The Functions
:[font = text; inactive; preserveAspect; ]
JacobiMatrix[functions, variables, atPoint] calculates (at a given point x0 (atPoint)) the Jacobi matrix of a mapping
f: Rn -> Rm
with coordinate functions fi (i = 1, ..., m) (functions) in the variables xj (j = 1, ..., n) (variables), i.e.: the matrix:
(dfi/dxj) | xj = x0j (i = 1, ..., m; j = 1, ..., n)
:[font = text; inactive; preserveAspect; endGroup; ]
Linearize[functions, variables, atPoint] gives the linearization of one or more functions or equations in the given variables, at the given point.
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
Examples
:[font = input; startGroup; Cclosed; nowordwrap; ]
JacobiMatrix[{a x^2 + b y, c x - y}, {x, y}, {1, 1}]
:[font = output; inactive; formatted; output; preserveAspect; endGroup; nowordwrap; ]
{{2*a, b}, {c, -1}}



;[o]
{{2 a, b}, {c, -1}}
:[font = input; preserveAspect; startGroup; Cclosed; nowordwrap; ]
Linearize[x^2 + a x, x, 1]
:[font = output; inactive; formatted; output; preserveAspect; endGroup; nowordwrap; ]
1 + a + (2 + a)*x



;[o]
1 + a + (2 + a) x
:[font = input; preserveAspect; startGroup; Cclosed; nowordwrap; ]
Linearize[Sin[x] == a x, x, 0]
:[font = output; inactive; formatted; output; preserveAspect; endGroup; nowordwrap; ]
x == a*x



;[o]
x == a x
:[font = input; preserveAspect; startGroup; Cclosed; nowordwrap; ]
Linearize[x^2 + x == x, x, 0]
:[font = output; inactive; formatted; output; preserveAspect; endGroup; nowordwrap; ]
True



;[o]
True
:[font = input; startGroup; Cclosed; nowordwrap; ]
Linearize[{a x^2 + b y, c x^2 - y}, {x, y}, {1, 0}]
:[font = output; inactive; formatted; output; preserveAspect; endGroup; nowordwrap; ]
{a + 2*a*x + b*y, c + 2*c*x - y}



;[o]
{a + 2 a x + b y, c + 2 c x - y}
:[font = input; startGroup; Cclosed; nowordwrap; ]
Linearize[{a x^2 + b y == y, c x - y == y^2}, {x, y}, {0, 0}]
:[font = output; inactive; formatted; output; preserveAspect; endGroup; nowordwrap; ]
{b*y == y, c*x - y == 0}



;[o]
{b y == y, c x - y == 0}
:[font = input; startGroup; Cclosed; nowordwrap; ]
Linearize[{x, y == 1}, {x, y}, {0, 0}]
:[font = message; inactive; preserveAspect; endGroup; endGroup; endGroup; nowordwrap; ]
Linearize::mix: 
   You can not mix equations with functions.
:[font = section; inactive; startGroup; Cclosed; ]
Implementation
:[font = subsection; inactive; startGroup; Cclosed; ]
Preparation
:[font = input; initialization; nowordwrap; ]
*)
BeginPackage["SKPackages`Linearization`"];
(*
:[font = input; initialization; nowordwrap; ]
*)
JacobiMatrix::usage = 
"JacobiMatrix[functions, variables, atPoint] returns the Jacobi Matrix of the functions with respect to the variables at the point atPoint.";
(*
:[font = input; initialization; nowordwrap; ]
*)
Linearize::usage = 
"Linearize[functions, variables, atPoint] calculates the linearization of the given functions or equations in the variable at the point atPoint. The length of variables and atPoint should be equal.";
(*
:[font = input; initialization; nowordwrap; ]
*)
Linearize::mix =
"You can not mix equations with functions.";
(*
:[font = input; initialization; endGroup; nowordwrap; ]
*)
Begin["`Private`"];
(*
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
Definitions
:[font = input; initialization; nowordwrap; ]
*)
JacobiMatrix[functions_, variables_, atPoint_] :=
  (Outer[D, Flatten[{functions}], Flatten[{variables}]] /. 
    Thread[variables -> atPoint]) /;
      Length[variables] == Length[atPoint]
(*
:[font = input; initialization; nowordwrap; ]
*)
Linearize[functions_List, variables_, atPoint_] :=
  Module[
    {
      subst = Thread[variables -> atPoint],
      varList = Flatten[{variables}],
      calculateIt, eq
    },
    calculateIt = ((# /. subst) +
      (Outer[D, #, varList] /. subst) . varList)&;
    Which[
      FreeQ[functions, Equal], (* only functions *)
        calculateIt[functions],
      And @@ (Head[#] === Equal& /@ functions), (* only equations *)
        (* prevent evaluation of Equal *)
        Thread[calculateIt /@
          Thread[functions /. Equal -> eq, eq]] /.
            eq -> Equal,
      True, (* else *)
        Message[Linearize::mix]
    ]
  ] /; Length[variables] == Length[atPoint]
(*
:[font = input; initialization; endGroup; nowordwrap; ]
*)
Linearize[functions_, variables_, atPoint_] :=
  Linearize[{functions}, variables, atPoint][[1]] /;
    Length[variables] == Length[atPoint]
(*
:[font = subsection; inactive; startGroup; Cclosed; ]
Finish
:[font = input; initialization; nowordwrap; ]
*)
End[ ];
(*
:[font = input; initialization; endGroup; endGroup; endGroup; nowordwrap; ]
*)
EndPackage[ ];
(*
^*)