(*^

::[	frontEndVersion = "Microsoft Windows Mathematica Notebook Front End Version 2.2";
	microsoftWindowsStandardFontEncoding;
	fontset = title, "Times New Roman", 24, L0, center, nohscroll, bold;
	fontset = subtitle, "Times New Roman", 18, L0, center, nohscroll, bold;
	fontset = subsubtitle, "Times New Roman", 14, L0, center, nohscroll, bold;
	fontset = section, "Times New Roman", 14, L0, bold, grayBox;
	fontset = subsection, "Times New Roman", 12, L0, bold, blackBox;
	fontset = subsubsection, "Times New Roman", 10, L0, bold, whiteBox;
	fontset = text, "Times New Roman", 12, L0;
	fontset = smalltext, "Times New Roman", 10, L0;
	fontset = input, "Courier New", 12, L0, nowordwrap, bold;
	fontset = output, "Courier New", 12, L0, nowordwrap;
	fontset = message, "Courier New", 10, L0, nowordwrap, R65535;
	fontset = print, "Courier New", 10, L0, nowordwrap;
	fontset = info, "Courier New", 10, L0, nowordwrap;
	fontset = postscript, "Courier New", 8, L0, nowordwrap;
	fontset = name, "Times New Roman", 10, L0, nohscroll, italic, B65535;
	fontset = header, "Times New Roman", 10, L0, right, nohscroll;
	fontset = footer, "Times New Roman", 10, L0, right, nohscroll;
	fontset = help, "Times New Roman", 10, L0, nohscroll;
	fontset = clipboard, "Times New Roman", 12, L0, nohscroll;
	fontset = completions, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = graphics, "Courier New", 10, L0, nowordwrap, nohscroll;
	fontset = special1, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = special2, "Times New Roman", 12, L0, center, nowordwrap, nohscroll;
	fontset = special3, "Times New Roman", 12, L0, right, nowordwrap, nohscroll;
	fontset = special4, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = special5, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = leftheader, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = leftfooter, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = reserved1, "Courier New", 10, L0, nowordwrap, nohscroll;]
:[font = title; inactive; startGroup; nohscroll; center; ]
NonNegativeQ
:[font = subsubtitle; inactive; nohscroll; center; ]
Stephan Kaufmann
:[font = special2; inactive; nowordwrap; nohscroll; center; ]
The function NonNegativeQ tries to find out if expressions can not be negative.
:[font = subsection; inactive; startGroup; Cclosed; ]
Reference
:[font = subsubsection; inactive; locked; startGroup; Cclosed; ]
Author
:[font = smalltext; inactive; locked; endGroup; ]
Stephan Kaufmann
Institute of Mechanics
Swiss Federal Institute of Technology
ETH Zentrum, HG F38.4 
CH-8092 Zurich
Switzerland
kaufmann@ifm.mavt.ethz.ch
:[font = subsubsection; inactive; locked; startGroup; Cclosed; backColorRed = 65535; backColorGreen = 65535; backColorBlue = 65535; fontColorRed = 0; fontColorGreen = 0; fontColorBlue = 0; bold; fontName = "Times New Roman"; fontSize = 10; ]
Copyright Notice
:[font = smalltext; inactive; locked; backColorRed = 65535; backColorGreen = 65535; backColorBlue = 65535; fontColorRed = 0; fontColorGreen = 0; fontColorBlue = 0; plain; fontName = "Times New Roman"; fontSize = 10; ]
Copyright  1994 by Stephan Kaufmann
:[font = smalltext; inactive; locked; preserveAspect; endGroup; nohscroll; backColorRed = 65535; backColorGreen = 65535; backColorBlue = 65535; fontColorRed = 0; fontColorGreen = 0; fontColorBlue = 0; plain; fontName = "Times New Roman"; fontSize = 10; ]
Permission is hereby granted to make copies of this file for any purpose other than direct profit,
or as part of a commercial product, provided this copyright notice is left intact. Sale is prohibited.

Permission is hereby granted to reproduce part or all of this file provided that the source is acknowledged.
:[font = subsubsection; inactive; startGroup; Cclosed; ]
Version
:[font = smalltext; inactive; endGroup; ]
Notebook Version 2.2 (E)
:[font = subsubsection; inactive; startGroup; Cclosed; ]
History
:[font = smalltext; inactive; endGroup; ]
Changes in Version 2.2 (August 93):
Completely rewritten in a more efficient way 
:[font = subsubsection; inactive; startGroup; Cclosed; ]
Requirements
:[font = smalltext; inactive; ]
Mathematica Version: 2.0 or higher.
:[font = input; initialization; endGroup; nowordwrap; ]
*)
If[$VersionNumber < 2.0, Print[
  "This package requires Mathematica version 2.0 or higher."]]
(*
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Restriction
:[font = smalltext; inactive; preserveAspect; endGroup; endGroup; ]
The function NonNegativeQ, defined in this package, does not attempt to be complete.
:[font = section; inactive; startGroup; Cclosed; ]
Discussion
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
Idea
:[font = text; inactive; preserveAspect; ]
The Mathematica functions Positive, Negative and NonNegative evaluate for numbers only. They can be used to define properties of symbols but for combinations of such symbols, the properties are not evaluated any further, e.g.,
:[font = input; preserveAspect; nowordwrap; ]
Positive[a] ^= True;
:[font = input; preserveAspect; startGroup; Cclosed; nowordwrap; ]
Positive[a^2]
:[font = output; inactive; formatted; output; preserveAspect; endGroup; nowordwrap; ]
Positive[a^2]



;[o]
          2
Positive[a ]
:[font = text; inactive; preserveAspect; endGroup; ]
The function NonNegativeQ (defined in this package) tries to find out if the result can not be negative. In such cases, it returns True, otherwise False.
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
Examples
:[font = text; inactive; preserveAspect; ]
The symbol a shall be positive:
:[font = input; preserveAspect; nowordwrap; ]
Positive[a] ^= True;
:[font = text; inactive; preserveAspect; ]
Then, a^2 is not negative:
:[font = input; preserveAspect; startGroup; Cclosed; nowordwrap; ]
NonNegativeQ[a^2]
:[font = output; inactive; formatted; output; preserveAspect; endGroup; nowordwrap; ]
True



;[o]
True
:[font = text; inactive; preserveAspect; ]
Nothing is said about b yet:
:[font = input; preserveAspect; startGroup; Cclosed; nowordwrap; ]
NonNegativeQ[b]
:[font = output; inactive; formatted; output; preserveAspect; endGroup; nowordwrap; ]
True



;[o]
True
:[font = text; inactive; preserveAspect; ]
We now fix it to be non negative:
:[font = input; preserveAspect; nowordwrap; ]
NonNegativeQ[b] ^= True;
:[font = text; inactive; preserveAspect; ]
Then, the following product can be evaluated:
:[font = input; preserveAspect; startGroup; Cclosed; nowordwrap; ]
NonNegativeQ[a b]
:[font = output; inactive; formatted; output; preserveAspect; endGroup; nowordwrap; ]
True



;[o]
True
:[font = text; inactive; preserveAspect; ]
With
:[font = input; preserveAspect; nowordwrap; ]
Negative[c] ^= True;
:[font = text; inactive; preserveAspect; ]
it is possible to analyse:
:[font = input; preserveAspect; startGroup; Cclosed; nowordwrap; ]
NonNegativeQ[- a b c]
:[font = output; inactive; formatted; output; preserveAspect; endGroup; endGroup; endGroup; nowordwrap; ]
True



;[o]
True
:[font = section; inactive; startGroup; Cclosed; ]
Implementation
:[font = subsection; inactive; startGroup; Cclosed; ]
Preparation
:[font = input; initialization; nowordwrap; ]
*)
BeginPackage["SKPackages`NonNegativeQ`"];
(*
:[font = input; initialization; preserveAspect; nowordwrap; ]
*)
Off[General::spell1];
(*
:[font = input; initialization; nowordwrap; ]
*)
NonNegativeQ::usage =
"NonNegativeQ[expr] returns True if expr is obviously not negative and else False. Properties of symbols can be defined with the functions Positive, NonNegative and Negative (e.g., x /: Positive[x] = True). Real symbols can be declared by definitions like a /: Im[a] = 0";
(*
:[font = input; initialization; preserveAspect; nowordwrap; ]
*)
On[General::spell1];
(*
:[font = input; initialization; endGroup; nowordwrap; ]
*)
Begin["`Private`"];
(*
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
Definitions
:[font = input; initialization; preserveAspect; nowordwrap; ]
*)
RealTest[x_?AtomQ] := True /; NonNegativeQ[x]
(*
:[font = input; initialization; preserveAspect; nowordwrap; ]
*)
RealTest[x_] := True /; Im[x] == 0 ||
  Positive[x] || NonNegative[x] || Negative[x]
(*
:[font = input; initialization; preserveAspect; nowordwrap; ]
*)
RealTest[x_ + y_] := RealTest[x] && RealTest[y]
(*
:[font = input; initialization; preserveAspect; nowordwrap; ]
*)
RealTest[x_ y_] := RealTest[x] && RealTest[y]
(*
:[font = input; initialization; preserveAspect; nowordwrap; ]
*)
RealTest[x_^_Integer] := RealTest[x]
(*
:[font = input; initialization; preserveAspect; nowordwrap; ]
*)
NonNegativeQ[x_] := True /; Positive[x] || NonNegative[x]
(*
:[font = input; initialization; preserveAspect; nowordwrap; ]
*)
NonNegativeQ[x_?(!AtomQ[#]&)] := NNQ[Factor[x]]
(*
:[font = input; initialization; nowordwrap; ]
*)
NonNegativeQ[x_] := False
(*
:[font = input; initialization; nowordwrap; ]
*)
NNQ[x_ y_] := (NNQ[x] && NNQ[y]) || (NNQ[-x] && NNQ[-y]) /;
    x =!= -1 && y =!= -1
(*
:[font = input; initialization; nowordwrap; ]
*)
NNQ[x_ + y_] := NNQ[x] && NNQ[y]
(*
:[font = input; initialization; nowordwrap; ]
*)
NNQ[x_^_?OddQ] := NNQ[x] /; RealTest[x]
(*
:[font = input; initialization; nowordwrap; ]
*)
NNQ[-x_^_?OddQ] := NNQ[-x] /; RealTest[x]
(*
:[font = input; initialization; nowordwrap; ]
*)
NNQ[x_^_?EvenQ] := True /; RealTest[x]
(*
:[font = input; initialization; nowordwrap; ]
*)
NNQ[Abs[x_]] := True
(*
:[font = input; initialization; nowordwrap; ]
*)
NNQ[Sqrt[x_]] := True /; RealTest[x]
(*
:[font = input; initialization; nowordwrap; ]
*)
NNQ[Exp[x_]] := True /; RealTest[x]
(*
:[font = input; initialization; preserveAspect; nowordwrap; ]
*)
NNQ[-x_] := True /;
  Positive[-x] || NonNegative[-x] || Negative[x]
(*
:[font = input; initialization; preserveAspect; nowordwrap; ]
*)
NNQ[x_] := True /;
  Positive[x] || NonNegative[x] || Negative[-x]
(*
:[font = input; initialization; preserveAspect; nowordwrap; ]
*)
NNQ[x_?AtomQ] := NonNegativeQ[x]
(*
:[font = input; initialization; endGroup; nowordwrap; ]
*)
NNQ[x_] := False
(*
:[font = subsection; inactive; startGroup; Cclosed; ]
Finish
:[font = input; initialization; nowordwrap; ]
*)
End[];
(*
:[font = input; initialization; endGroup; endGroup; endGroup; nowordwrap; ]
*)
EndPackage[];
(*
^*)