(*^

::[	frontEndVersion = "Microsoft Windows Mathematica Notebook Front End Version 2.2";
	microsoftWindowsStandardFontEncoding;
	fontset = title, "Times New Roman", 24, L0, center, nohscroll, bold;
	fontset = subtitle, "Times New Roman", 18, L0, center, nohscroll, bold;
	fontset = subsubtitle, "Times New Roman", 14, L0, center, nohscroll, bold;
	fontset = section, "Times New Roman", 14, L0, bold, grayBox;
	fontset = subsection, "Times New Roman", 12, L0, bold, blackBox;
	fontset = subsubsection, "Times New Roman", 10, L0, bold, whiteBox;
	fontset = text, "Times New Roman", 12, L0;
	fontset = smalltext, "Times New Roman", 10, L0;
	fontset = input, "Courier New", 12, L0, nowordwrap, bold;
	fontset = output, "Courier New", 12, L0, nowordwrap;
	fontset = message, "Courier New", 10, L0, nowordwrap, R65535;
	fontset = print, "Courier New", 10, L0, nowordwrap;
	fontset = info, "Courier New", 10, L0, nowordwrap;
	fontset = postscript, "Courier New", 8, L0, nowordwrap;
	fontset = name, "Times New Roman", 10, L0, nohscroll, italic, B65535;
	fontset = header, "Times New Roman", 10, L0, right, nohscroll;
	fontset = footer, "Times New Roman", 10, L0, right, nohscroll;
	fontset = help, "Times New Roman", 10, L0, nohscroll;
	fontset = clipboard, "Times New Roman", 12, L0, nohscroll;
	fontset = completions, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = graphics, "Courier New", 10, L0, nowordwrap, nohscroll;
	fontset = special1, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = special2, "Times New Roman", 12, L0, center, nowordwrap, nohscroll;
	fontset = special3, "Times New Roman", 12, L0, right, nowordwrap, nohscroll;
	fontset = special4, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = special5, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = leftheader, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = leftfooter, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = reserved1, "Courier New", 10, L0, nowordwrap, nohscroll;]
:[font = title; inactive; startGroup; nohscroll; center; ]
RSA
:[font = subsubtitle; inactive; nohscroll; center; ]
Stephan Kaufmann
:[font = special2; inactive; nowordwrap; nohscroll; center; ]
Demonstration of the RSA public key encryption system.
:[font = subsection; inactive; startGroup; Cclosed; ]
Reference
:[font = subsubsection; inactive; locked; startGroup; Cclosed; ]
Author
:[font = smalltext; inactive; locked; endGroup; ]
Stephan Kaufmann
Institute of Mechanics
Swiss Federal Institute of Technology
ETH Zentrum, HG F38.4 
CH-8092 Zurich
Switzerland
kaufmann@ifm.mavt.ethz.ch
:[font = subsubsection; inactive; locked; startGroup; Cclosed; backColorRed = 65535; backColorGreen = 65535; backColorBlue = 65535; fontColorRed = 0; fontColorGreen = 0; fontColorBlue = 0; bold; fontName = "Times New Roman"; fontSize = 10; ]
Copyright Notice
:[font = smalltext; inactive; locked; backColorRed = 65535; backColorGreen = 65535; backColorBlue = 65535; fontColorRed = 0; fontColorGreen = 0; fontColorBlue = 0; plain; fontName = "Times New Roman"; fontSize = 10; ]
Copyright  1994 by Stephan Kaufmann
:[font = smalltext; inactive; locked; preserveAspect; endGroup; nohscroll; backColorRed = 65535; backColorGreen = 65535; backColorBlue = 65535; fontColorRed = 0; fontColorGreen = 0; fontColorBlue = 0; plain; fontName = "Times New Roman"; fontSize = 10; ]
Permission is hereby granted to make copies of this file for any purpose other than direct profit,
or as part of a commercial product, provided this copyright notice is left intact. Sale is prohibited.

Permission is hereby granted to reproduce part or all of this file provided that the source is acknowledged.
:[font = subsubsection; inactive; startGroup; Cclosed; ]
Version
:[font = smalltext; inactive; endGroup; ]
Notebook Version 2.1 (E)
:[font = subsubsection; inactive; startGroup; Cclosed; ]
Requirements
:[font = smalltext; inactive; ]
Mathematica Version: 2.0 or higher.
:[font = input; initialization; endGroup; endGroup; nowordwrap; ]
*)
If[$VersionNumber < 2.0, Print[
  "This package requires Mathematica version 2.0 or higher."]]
(*
:[font = section; inactive; startGroup; Cclosed; ]
Discussion
:[font = subsection; inactive; startGroup; Cclosed; ]
Algebraic Tools
:[font = text; inactive; preserveAspect; endGroup; ]
The RSA system is based on Euler's theorem:

If a and m are relatively prime cardinals, then a^(j(m))  1 (mod m).

j(m) is Euler's totient function (i.e. the number of cardinals k with 0 < k  m which are relatively prime to m).

For a prime p, we have: j(p) = p-1;
for two primes p and q: j(p q) = (p-1)(q-1).
:[font = subsection; inactive; startGroup; Cclosed; ]
RSA Encryption
:[font = text; inactive; endGroup; ]
The receiver of a message generates two (large) primes p and q and a number e, which is relatively prime to j(p q) = (p-1)(q-1). He calculates the product n = p q and the (multiplicative) inverse d of e modulo j(n): d e  1 (mod j(n)).

The receiver puts n and e into a public directory; he keeps p, q and d secret.

The sender of a message uses the numbers n and e of the receiver. He transforms the message according to a public scheme into a cardinal m < n or a sequence of such numbers. Then, he calculates the encoded message c(m) according to c(m) = m^e (mod n). This number (or the sequence of such numbers) is transmitted.

The receiver reconstructs the message with the calculation
c(m)^d = m^(e d) = m^(1+k j(n))  m (mod n).

The safety of the encryption is based on the fact that there are no known polynomial-time algorithms for factoring numbers. If p and q are large enough, their product n can not be factored within reasonable time (or, equivalently, j(n) calculated).
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
Further Restrictions for the Primes
:[font = text; inactive; preserveAspect; endGroup; ]
For the encryption to be save, the numbers p and q must be chosen large enough (one hundred or more digits). Furthermore, p1 (and q1) should have a large prime factor. The number e must also be chosen large.
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
Literature
:[font = text; inactive; preserveAspect; endGroup; ]
Akritas, A. G.: Elements of Computer Algebra with Applications. Wiley, New York, 1989.

Rivest, R. L., A. Shamir and L. Adleman: A method for obtaining digital signatures and public key cryptosystems. Communications of the ACM 21, 120-126, 1978.
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
The Functions in this Package
:[font = text; inactive; preserveAspect; ]
RSAPrime[digits] generates prime suitable for RSA with digits digits.
:[font = text; inactive; ]
GenerateE[p, q] generates a suitable number e for two primes p and q.
:[font = text; inactive; ]
GenerateD[e, p, q] calculates the number d for a given e (and p and q).
:[font = text; inactive; ]
StringToList[text, n] transforms strings into a list of cardinals < n.
:[font = text; inactive; ]
ListToString[l] transforms a list of cardinals (from StringToList) back into the original string.
:[font = text; inactive; ]
RSAEncodeNumber[num, e, n] encodes a cardinal num with e and n.
:[font = text; inactive; ]
RSADecodeNumber[num, d, n] decodes a number num with d and n.
:[font = text; inactive; ]
RSAEncode[text, e, n] encodes a string.
:[font = text; inactive; endGroup; ]
RSADecode[l, d, n] decodes a list of cardinals.
:[font = subsection; inactive; startGroup; Cclosed; ]
Example
:[font = text; inactive; ]
The generation of large suitable primes takes some time. It is a good idea to do this in the background. We demonstrate the functions with an unrealistically small example.
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Generation of the Primes p and q
:[font = input; startGroup; Cclosed; nowordwrap; ]
p = RSAPrime[6]
:[font = output; inactive; formatted; output; preserveAspect; endGroup; nowordwrap; ]
511703



;[o]
511703
:[font = input; startGroup; Cclosed; nowordwrap; ]
q = RSAPrime[6]
:[font = output; inactive; formatted; output; preserveAspect; endGroup; endGroup; nowordwrap; ]
366239



;[o]
366239
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Calculation of n, e, d
:[font = input; startGroup; Cclosed; nowordwrap; ]
n = p q
:[font = output; inactive; formatted; output; preserveAspect; endGroup; nowordwrap; ]
187405595017



;[o]
187405595017
:[font = input; startGroup; Cclosed; nowordwrap; ]
e = GenerateE[p, q]
:[font = output; inactive; formatted; output; preserveAspect; endGroup; nowordwrap; ]
165321377563



;[o]
165321377563
:[font = input; startGroup; Cclosed; nowordwrap; ]
d = GenerateD[e, p, q]
:[font = output; inactive; formatted; output; preserveAspect; endGroup; endGroup; nowordwrap; ]
19084807299



;[o]
19084807299
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Encryption and Decryption of Cardinals
:[font = input; startGroup; Cclosed; nowordwrap; ]
c = RSAEncodeNumber[123, e, n]
:[font = output; inactive; formatted; output; preserveAspect; endGroup; nowordwrap; ]
8944737012



;[o]
8944737012
:[font = input; startGroup; Cclosed; nowordwrap; ]
RSADecodeNumber[c, d, n]
:[font = output; inactive; formatted; output; preserveAspect; endGroup; endGroup; nowordwrap; ]
123



;[o]
123
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Encoding and Decoding of Strings by Lists of Numbers
:[font = input; startGroup; Cclosed; nowordwrap; ]
StringToList["This is a message", n]
:[font = output; inactive; formatted; output; preserveAspect; endGroup; nowordwrap; ]
{1416128883, 543781664, 1629515109, 1936941415, 101}



;[o]
{1416128883, 543781664, 1629515109, 1936941415, 101}
:[font = input; startGroup; Cclosed; nowordwrap; ]
ListToString[%]
:[font = output; inactive; formatted; output; preserveAspect; endGroup; endGroup; nowordwrap; ]
"This is a message"



;[o]
This is a message
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Encryption and Decryption of Text
:[font = input; startGroup; Cclosed; nowordwrap; ]
c = RSAEncode["A secret message", e, n]
:[font = output; inactive; formatted; output; preserveAspect; endGroup; nowordwrap; ]
{8119970855, 110769553597, 140275287288, 169470606488}



;[o]
{8119970855, 110769553597, 140275287288, 169470606488}
:[font = input; startGroup; Cclosed; nowordwrap; ]
RSADecode[c, d, n]
:[font = output; inactive; formatted; output; preserveAspect; endGroup; endGroup; nowordwrap; ]
"A secret message"



;[o]
A secret message
:[font = subsubsection; inactive; preserveAspect; startGroup; Cclosed; ]
Using Larger Primes
:[font = text; inactive; preserveAspect; ]
The following primes have been generated with RSAPrime.
:[font = input; preserveAspect; startGroup; Cclosed; nowordwrap; ]
p =
332715112660848742187755808851902864945816936127916014252\
  3661652581105578513717982486654235124785151
:[font = output; inactive; formatted; output; preserveAspect; endGroup; nowordwrap; ]
33271511266084874218775580885190286494581693612791601\
 
  42523661652581105578513717982486654235124785151



;[o]
33271511266084874218775580885190286494581693612791601\
 
  42523661652581105578513717982486654235124785151
:[font = input; preserveAspect; startGroup; Cclosed; nowordwrap; ]
q =
120791468413759348683463308420511774373133760151037399776\
  0717454678735342949711476106521763447795837
:[font = output; inactive; formatted; output; preserveAspect; endGroup; nowordwrap; ]
12079146841375934868346330842051177437313376015103739\
 
  97760717454678735342949711476106521763447795837



;[o]
12079146841375934868346330842051177437313376015103739\
 
  97760717454678735342949711476106521763447795837
:[font = text; inactive; preserveAspect; ]
The example is more realistic now.
:[font = input; startGroup; Cclosed; nowordwrap; ]
n = p q
:[font = output; inactive; formatted; output; preserveAspect; endGroup; nowordwrap; ]
40189147021753294006510448131661664513040274316864053\
 
  837845579470790667493939207500165194481410254890822\
 
  153244299510562623137720909064395523671713481439722\
 
  08813102177718484985564189828039179137216387



;[o]
40189147021753294006510448131661664513040274316864053\
 
  837845579470790667493939207500165194481410254890822\
 
  153244299510562623137720909064395523671713481439722\
 
  08813102177718484985564189828039179137216387
:[font = input; startGroup; Cclosed; nowordwrap; ]
e = GenerateE[p, q]
:[font = output; inactive; formatted; output; preserveAspect; endGroup; nowordwrap; ]
11661507142843111615019454933748975566088994076481933\
 
  833412638185888684838235221967095963864835778326262\
 
  580853816435099869250903435618934642432222859417415\
 
  36904060728300757420004232568144774888207969



;[o]
11661507142843111615019454933748975566088994076481933\
 
  833412638185888684838235221967095963864835778326262\
 
  580853816435099869250903435618934642432222859417415\
 
  36904060728300757420004232568144774888207969
:[font = input; startGroup; Cclosed; nowordwrap; ]
d = GenerateD[e, p, q]
:[font = output; inactive; formatted; output; preserveAspect; endGroup; nowordwrap; ]
38154297924779128985486047815318279398114210211306367\
 
  362822100477724205654963311488326506750947825422424\
 
  361997992919450394387093795213157552772976679948070\
 
  89787655006400285302613877333766616583576929



;[o]
38154297924779128985486047815318279398114210211306367\
 
  362822100477724205654963311488326506750947825422424\
 
  361997992919450394387093795213157552772976679948070\
 
  89787655006400285302613877333766616583576929
:[font = input; startGroup; Cclosed; nowordwrap; ]
c = RSAEncode["A secret message", e, n]
:[font = output; inactive; formatted; output; preserveAspect; endGroup; nowordwrap; ]
{3350607077103043209711905874656072350183304350425435\
 
   77493701737179899511269881473256661670703672739016\
 
   37983385310432941706007406895097511396255678432813\
 
   55231820050609286296060607374344526618265048114}



;[o]
{3350607077103043209711905874656072350183304350425435\
 
   77493701737179899511269881473256661670703672739016\
 
   37983385310432941706007406895097511396255678432813\
 
   55231820050609286296060607374344526618265048114}
:[font = input; startGroup; Cclosed; nowordwrap; ]
RSADecode[c, d, n]
:[font = output; inactive; formatted; output; preserveAspect; endGroup; endGroup; endGroup; endGroup; nowordwrap; ]
"A secret message"



;[o]
A secret message
:[font = section; inactive; startGroup; Cclosed; ]
Implementation
:[font = subsection; inactive; startGroup; Cclosed; ]
Preparation
:[font = input; initialization; nowordwrap; ]
*)
BeginPackage["SKPackages`RSA`"];
(*
:[font = input; initialization; preserveAspect; nowordwrap; ]
*)
RSAPrime::usage =
"RSAPrime[digits] returns a prime suitable for RSA with the given number of digits.";
(*
:[font = input; initialization; nowordwrap; ]
*)
GenerateE::usage =
"GenerateE[p, q] generates a random encoding exponent e which is relatively prime to (p-1)(q-1).";
(*
:[font = input; initialization; preserveAspect; nowordwrap; ]
*)
Off[General::spell1];
(*
:[font = input; initialization; preserveAspect; nowordwrap; ]
*)
GenerateD::usage =
"GenerateD[e, p, q] returns the multiplicative inverse of e mod((p-1)(q-1)).";
(*
:[font = input; initialization; preserveAspect; nowordwrap; ]
*)
On[General::spell1];
(*
:[font = input; initialization; nowordwrap; ]
*)
StringToList::usage =
"StringToList[text, n] converts a given string to block of numbers smaller than n.";
(*
:[font = input; initialization; nowordwrap; ]
*)
ListToString::usage =
"ListToString[l] converts a list of numbers (resulting from StringToList) to the original text string.";
(*
:[font = input; initialization; nowordwrap; ]
*)
RSAEncodeNumber::usage =
"RSAEncodeNumber[num, e, n] encodes the given number num using RSA with exponent e and modulus n.";
(*
:[font = input; initialization; nowordwrap; ]
*)
RSADecodeNumber::usage =
"RSADecodeNumber[num, d, n] decodes the given number num using RSA with exponent d and modulus n.";
(*
:[font = input; initialization; nowordwrap; ]
*)
RSAEncode::usage =
"RSAEncode[text, e, n] encodes the given text by converting it to a list of numbers and using RSA with exponent e and modulus n.";
(*
:[font = input; initialization; nowordwrap; ]
*)
RSADecode::usage =
"RSADecode[l, d, n] decodes the given list of numbers l by using RSA with exponent d and modulus n and converting the result back to the original text string.";
(*
:[font = input; initialization; endGroup; nowordwrap; ]
*)
Begin["`Private`"];
(*
:[font = subsection; inactive; preserveAspect; startGroup; Cclosed; ]
Good Primes for RSA
:[font = input; initialization; preserveAspect; nowordwrap; ]
*)
GoodRSAPrimeQ[n_Integer, l_Integer] :=
  PrimeQ[n] &&
  Module[{d = 1, m = (n-1)/2},
    While[d <= l && !PrimeQ[m/d], d++];
    d <= l
  ]
(*
:[font = input; initialization; preserveAspect; endGroup; nowordwrap; ]
*)
RSAPrime[digits_Integer] :=
  Module[{l, cand},
    cand = Random[Integer, {10^(digits-1), 10^digits-1}];
    l = 10^Floor[Log[10., cand]/30];
    If[EvenQ[cand], cand++];
    While[!GoodRSAPrimeQ[cand, l], cand += 2];
    cand
  ]
(*
:[font = subsection; inactive; startGroup; Cclosed; ]
RSA with Numbers
:[font = input; initialization; nowordwrap; ]
*)
GenerateE[p_Integer, q_Integer] :=
  Module[{res, n = p q, phi = (p-1)(q-1)},
    res = Random[Integer, {p, n}];
    While[GCD[res, phi] != 1,
      res = Random[Integer, {p, n}]];
    res
  ]
(*
:[font = input; initialization; nowordwrap; ]
*)
GenerateD[e_Integer, p_Integer, q_Integer] :=
  PowerMod[e, -1, (p-1)(q-1)]
(*
:[font = input; initialization; nowordwrap; ]
*)
RSAEncodeNumber[num_Integer, e_Integer, n_Integer] :=
  PowerMod[num, e, n] /; num < n
(*
:[font = input; initialization; endGroup; nowordwrap; ]
*)
RSADecodeNumber[num_Integer, d_Integer, n_Integer] :=
  PowerMod[num, d, n]
(*
:[font = subsection; inactive; startGroup; Cclosed; ]
Conversion of Text
:[font = input; initialization; nowordwrap; ]
*)
ConvertString[str_String] :=
  Fold[Plus[256 #1, #2]&, 0, ToCharacterCode[str]]
(*
:[font = input; initialization; nowordwrap; ]
*)
StringToList[text_String, n_Integer] :=
  Module[
    { 
      blockLength = Floor[N[Log[256, n]]],
      strLength = StringLength[text]
    },    
    ConvertString /@ Table[StringTake[text, 
        {i, Min[strLength, i + blockLength - 1]}],
      {i, 1, strLength, blockLength}]
  ] /; n > 256
(*
:[font = input; initialization; preserveAspect; nowordwrap; ]
*)
MakeList[0] = {};
(*
:[font = input; initialization; nowordwrap; ]
*)
MakeList[num_Integer] :=
  Append[MakeList[Quotient[num, 256]], Mod[num, 256]]
(*
:[font = input; initialization; preserveAspect; nowordwrap; ]
*)
ConvertNumber[num_Integer] := FromCharacterCode /@ MakeList[num]
(*
:[font = input; initialization; endGroup; nowordwrap; ]
*)
ListToString[l_List] :=
  StringJoin[ConvertNumber /@ l]
(*
:[font = subsection; inactive; startGroup; Cclosed; ]
RSA with Text
:[font = input; initialization; nowordwrap; ]
*)
RSAEncode[text_String, e_Integer, n_Integer] :=
  RSAEncodeNumber[#, e, n]& /@
    StringToList[text, n] /; n > 256
(*
:[font = input; initialization; endGroup; nowordwrap; ]
*)
RSADecode[l_List, d_Integer, n_Integer] :=
  ListToString[RSADecodeNumber[#, d, n]& /@ l]
(*
:[font = subsection; inactive; startGroup; Cclosed; ]
Finish
:[font = input; initialization; nowordwrap; ]
*)
End[ ];
(*
:[font = input; initialization; endGroup; endGroup; endGroup; nowordwrap; ]
*)
EndPackage[ ];
(*
^*)